
(function() {
'use strict';

function F2(fun)
{
  function wrapper(a) { return function(b) { return fun(a,b); }; }
  wrapper.arity = 2;
  wrapper.func = fun;
  return wrapper;
}

function F3(fun)
{
  function wrapper(a) {
    return function(b) { return function(c) { return fun(a, b, c); }; };
  }
  wrapper.arity = 3;
  wrapper.func = fun;
  return wrapper;
}

function F4(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return fun(a, b, c, d); }; }; };
  }
  wrapper.arity = 4;
  wrapper.func = fun;
  return wrapper;
}

function F5(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return fun(a, b, c, d, e); }; }; }; };
  }
  wrapper.arity = 5;
  wrapper.func = fun;
  return wrapper;
}

function F6(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return fun(a, b, c, d, e, f); }; }; }; }; };
  }
  wrapper.arity = 6;
  wrapper.func = fun;
  return wrapper;
}

function F7(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return fun(a, b, c, d, e, f, g); }; }; }; }; }; };
  }
  wrapper.arity = 7;
  wrapper.func = fun;
  return wrapper;
}

function F8(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) {
    return fun(a, b, c, d, e, f, g, h); }; }; }; }; }; }; };
  }
  wrapper.arity = 8;
  wrapper.func = fun;
  return wrapper;
}

function F9(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) { return function(i) {
    return fun(a, b, c, d, e, f, g, h, i); }; }; }; }; }; }; }; };
  }
  wrapper.arity = 9;
  wrapper.func = fun;
  return wrapper;
}

function A2(fun, a, b)
{
  return fun.arity === 2
    ? fun.func(a, b)
    : fun(a)(b);
}
function A3(fun, a, b, c)
{
  return fun.arity === 3
    ? fun.func(a, b, c)
    : fun(a)(b)(c);
}
function A4(fun, a, b, c, d)
{
  return fun.arity === 4
    ? fun.func(a, b, c, d)
    : fun(a)(b)(c)(d);
}
function A5(fun, a, b, c, d, e)
{
  return fun.arity === 5
    ? fun.func(a, b, c, d, e)
    : fun(a)(b)(c)(d)(e);
}
function A6(fun, a, b, c, d, e, f)
{
  return fun.arity === 6
    ? fun.func(a, b, c, d, e, f)
    : fun(a)(b)(c)(d)(e)(f);
}
function A7(fun, a, b, c, d, e, f, g)
{
  return fun.arity === 7
    ? fun.func(a, b, c, d, e, f, g)
    : fun(a)(b)(c)(d)(e)(f)(g);
}
function A8(fun, a, b, c, d, e, f, g, h)
{
  return fun.arity === 8
    ? fun.func(a, b, c, d, e, f, g, h)
    : fun(a)(b)(c)(d)(e)(f)(g)(h);
}
function A9(fun, a, b, c, d, e, f, g, h, i)
{
  return fun.arity === 9
    ? fun.func(a, b, c, d, e, f, g, h, i)
    : fun(a)(b)(c)(d)(e)(f)(g)(h)(i);
}

var _elm_lang$core$Native_Bitwise = function() {

return {
	and: F2(function and(a, b) { return a & b; }),
	or: F2(function or(a, b) { return a | b; }),
	xor: F2(function xor(a, b) { return a ^ b; }),
	complement: function complement(a) { return ~a; },
	shiftLeftBy: F2(function(offset, a) { return a << offset; }),
	shiftRightBy: F2(function(offset, a) { return a >> offset; }),
	shiftRightZfBy: F2(function(offset, a) { return a >>> offset; })
};

}();

var _elm_lang$core$Bitwise$shiftRightZfBy = _elm_lang$core$Native_Bitwise.shiftRightZfBy;
var _elm_lang$core$Bitwise$shiftRightBy = _elm_lang$core$Native_Bitwise.shiftRightBy;
var _elm_lang$core$Bitwise$shiftLeftBy = _elm_lang$core$Native_Bitwise.shiftLeftBy;
var _elm_lang$core$Bitwise$complement = _elm_lang$core$Native_Bitwise.complement;
var _elm_lang$core$Bitwise$xor = _elm_lang$core$Native_Bitwise.xor;
var _elm_lang$core$Bitwise$or = _elm_lang$core$Native_Bitwise.or;
var _elm_lang$core$Bitwise$and = _elm_lang$core$Native_Bitwise.and;

var _Skinney$elm_array_exploration$Native_JsArray = function() {

var empty = [];

function singleton(val) {
    return [val];
}

function length(arr) {
    return arr.length;
}

function initialize(size, offset, f) {
    var result = new Array(size);

    for (var i = 0; i < size; i++) {
        result[i] = f(offset + i);
    }

    return result;
}

function initializeFromList(max, ls) {
    var result = new Array(max);

    for (var i = 0; i < max && ls.ctor !== '[]'; i++) {
        result[i] = ls._0;
        ls = ls._1;
    }

    result.length = i;

    return {
        ctor: '_Tuple2',
        _0: result,
        _1: ls
    };
}

function unsafeGet(idx, arr) {
    return arr[idx];
}

function unsafeSet(idx, val, arr) {
    var length = arr.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++) {
        result[i] = arr[i];
    }

    result[idx] = val;
    return result;
}

function push(val, arr) {
    var length = arr.length;
    var result = new Array(length + 1);

    for (var i = 0; i < length; i++) {
        result[i] = arr[i];
    }

    result[length] = val;
    return result;
}

function foldl(f, acc, arr) {
    var length = arr.length;

    for (var i = 0; i < length; i++) {
        acc = A2(f, arr[i], acc);
    }

    return acc;
}

function foldr(f, acc, arr) {
    for (var i = arr.length - 1; i >= 0; i--) {
        acc = A2(f, arr[i], acc);
    }

    return acc;
}

function map(f, arr) {
    var length = arr.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++) {
        result[i] = f(arr[i]);
    }

    return result;
}

function indexedMap(f, offset, arr) {
    var length = arr.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++) {
        result[i] = A2(f, offset + i, arr[i]);
    }

    return result;
}

function slice(from, to, arr) {
    return arr.slice(from, to);
}

function appendN(n, dest, source) {
    var destLen = dest.length;
    var itemsToCopy = n - destLen;

    if (itemsToCopy > source.length) {
        itemsToCopy = source.length;
    }

    var size = destLen + itemsToCopy;
    var result = new Array(size);

    for (var i = 0; i < destLen; i++) {
        result[i] = dest[i];
    }

    for (var i = 0; i < itemsToCopy; i++) {
        result[i + destLen] = source[i];
    }

    return result;
}

return {
    empty: empty,
    singleton: singleton,
    length: length,
    initialize: F3(initialize),
    initializeFromList: F2(initializeFromList),
    unsafeGet: F2(unsafeGet),
    unsafeSet: F3(unsafeSet),
    push: F2(push),
    foldl: F3(foldl),
    foldr: F3(foldr),
    map: F2(map),
    indexedMap: F3(indexedMap),
    slice: F3(slice),
    appendN: F3(appendN)
};

}();

//import Native.Utils //

var _elm_lang$core$Native_Basics = function() {

function div(a, b)
{
	return (a / b) | 0;
}
function rem(a, b)
{
	return a % b;
}
function mod(a, b)
{
	if (b === 0)
	{
		throw new Error('Cannot perform mod 0. Division by zero error.');
	}
	var r = a % b;
	var m = a === 0 ? 0 : (b > 0 ? (a >= 0 ? r : r + b) : -mod(-a, -b));

	return m === b ? 0 : m;
}
function logBase(base, n)
{
	return Math.log(n) / Math.log(base);
}
function negate(n)
{
	return -n;
}
function abs(n)
{
	return n < 0 ? -n : n;
}

function min(a, b)
{
	return _elm_lang$core$Native_Utils.cmp(a, b) < 0 ? a : b;
}
function max(a, b)
{
	return _elm_lang$core$Native_Utils.cmp(a, b) > 0 ? a : b;
}
function clamp(lo, hi, n)
{
	return _elm_lang$core$Native_Utils.cmp(n, lo) < 0
		? lo
		: _elm_lang$core$Native_Utils.cmp(n, hi) > 0
			? hi
			: n;
}

var ord = ['LT', 'EQ', 'GT'];

function compare(x, y)
{
	return { ctor: ord[_elm_lang$core$Native_Utils.cmp(x, y) + 1] };
}

function xor(a, b)
{
	return a !== b;
}
function not(b)
{
	return !b;
}
function isInfinite(n)
{
	return n === Infinity || n === -Infinity;
}

function truncate(n)
{
	return n | 0;
}

function degrees(d)
{
	return d * Math.PI / 180;
}
function turns(t)
{
	return 2 * Math.PI * t;
}
function fromPolar(point)
{
	var r = point._0;
	var t = point._1;
	return _elm_lang$core$Native_Utils.Tuple2(r * Math.cos(t), r * Math.sin(t));
}
function toPolar(point)
{
	var x = point._0;
	var y = point._1;
	return _elm_lang$core$Native_Utils.Tuple2(Math.sqrt(x * x + y * y), Math.atan2(y, x));
}

return {
	div: F2(div),
	rem: F2(rem),
	mod: F2(mod),

	pi: Math.PI,
	e: Math.E,
	cos: Math.cos,
	sin: Math.sin,
	tan: Math.tan,
	acos: Math.acos,
	asin: Math.asin,
	atan: Math.atan,
	atan2: F2(Math.atan2),

	degrees: degrees,
	turns: turns,
	fromPolar: fromPolar,
	toPolar: toPolar,

	sqrt: Math.sqrt,
	logBase: F2(logBase),
	negate: negate,
	abs: abs,
	min: F2(min),
	max: F2(max),
	clamp: F3(clamp),
	compare: F2(compare),

	xor: F2(xor),
	not: not,

	truncate: truncate,
	ceiling: Math.ceil,
	floor: Math.floor,
	round: Math.round,
	toFloat: function(x) { return x; },
	isNaN: isNaN,
	isInfinite: isInfinite
};

}();
//import //

var _elm_lang$core$Native_Utils = function() {

// COMPARISONS

function eq(x, y)
{
	var stack = [];
	var isEqual = eqHelp(x, y, 0, stack);
	var pair;
	while (isEqual && (pair = stack.pop()))
	{
		isEqual = eqHelp(pair.x, pair.y, 0, stack);
	}
	return isEqual;
}


function eqHelp(x, y, depth, stack)
{
    if (depth > 100)
	{
		stack.push({ x: x, y: y });
		return true;
	}

    if (x === y)
	{
		return true;
	}

    if (x instanceof String) {
        return x.valueOf() === y.valueOf();
    }

    if (typeof x !== 'object')
	{
		if (typeof x === 'function')
		{
			throw new Error(
				'Trying to use `(==)` on functions. There is no way to know if functions are "the same" in the Elm sense.'
				+ ' Read more about this at http://package.elm-lang.org/packages/elm-lang/core/latest/Basics#=='
				+ ' which describes why it is this way and what the better version will look like.'
			);
		}
		return false;
	}

    if (x === null || y === null)
	{
		return false
	}

    if (x instanceof Date)
	{
		return x.getTime() === y.getTime();
	}

    if (!('ctor' in x))
	{
		for (var key in x)
		{
			if (!eqHelp(x[key], y[key], depth + 1, stack))
			{
				return false;
			}
		}
		return true;
	}

    // convert Dicts and Sets to lists
    if (x.ctor === 'RBNode_elm_builtin' || x.ctor === 'RBEmpty_elm_builtin')
	{
		x = _elm_lang$core$Dict$toList(x);
		y = _elm_lang$core$Dict$toList(y);
	}
    if (x.ctor === 'Set_elm_builtin')
	{
		x = _elm_lang$core$Set$toList(x);
		y = _elm_lang$core$Set$toList(y);
	}

    // check if lists are equal without recursion
    if (x.ctor === '::')
	{
		var a = x;
		var b = y;
		while (a.ctor === '::' && b.ctor === '::')
		{
			if (!eqHelp(a._0, b._0, depth + 1, stack))
			{
				return false;
			}
			a = a._1;
			b = b._1;
		}
		return a.ctor === b.ctor;
	}

    // check if Arrays are equal
    if (x.ctor === '_Array')
	{
		var xs = _elm_lang$core$Native_Array.toJSArray(x);
		var ys = _elm_lang$core$Native_Array.toJSArray(y);
		if (xs.length !== ys.length)
		{
			return false;
		}
		for (var i = 0; i < xs.length; i++)
		{
			if (!eqHelp(xs[i], ys[i], depth + 1, stack))
			{
				return false;
			}
		}
		return true;
	}

    if (!eqHelp(x.ctor, y.ctor, depth + 1, stack))
	{
		return false;
	}

    for (var key in x)
	{
		if (!eqHelp(x[key], y[key], depth + 1, stack))
		{
			return false;
		}
	}
    return true;
}

// Code in Generate/JavaScript.hs, Basics.js, and List.js depends on
// the particular integer values assigned to LT, EQ, and GT.

var LT = -1, EQ = 0, GT = 1;

function cmp(x, y)
{
	if (typeof x !== 'object')
	{
		return x === y ? EQ : x < y ? LT : GT;
	}

	if (x instanceof String)
	{
		var a = x.valueOf();
		var b = y.valueOf();
		return a === b ? EQ : a < b ? LT : GT;
	}

	if (x.ctor === '::' || x.ctor === '[]')
	{
		while (x.ctor === '::' && y.ctor === '::')
		{
			var ord = cmp(x._0, y._0);
			if (ord !== EQ)
			{
				return ord;
			}
			x = x._1;
			y = y._1;
		}
		return x.ctor === y.ctor ? EQ : x.ctor === '[]' ? LT : GT;
	}

	if (x.ctor.slice(0, 6) === '_Tuple')
	{
		var ord;
		var n = x.ctor.slice(6) - 0;
		var err = 'cannot compare tuples with more than 6 elements.';
		if (n === 0) return EQ;
		if (n >= 1) { ord = cmp(x._0, y._0); if (ord !== EQ) return ord;
		if (n >= 2) { ord = cmp(x._1, y._1); if (ord !== EQ) return ord;
		if (n >= 3) { ord = cmp(x._2, y._2); if (ord !== EQ) return ord;
		if (n >= 4) { ord = cmp(x._3, y._3); if (ord !== EQ) return ord;
		if (n >= 5) { ord = cmp(x._4, y._4); if (ord !== EQ) return ord;
		if (n >= 6) { ord = cmp(x._5, y._5); if (ord !== EQ) return ord;
		if (n >= 7) throw new Error('Comparison error: ' + err); } } } } } }
		return EQ;
	}

	throw new Error(
		'Comparison error: comparison is only defined on ints, '
		+ 'floats, times, chars, strings, lists of comparable values, '
		+ 'and tuples of comparable values.'
	);
}


// COMMON VALUES

var Tuple0 = {
	ctor: '_Tuple0'
};

function Tuple2(x, y)
{
	return {
		ctor: '_Tuple2',
		_0: x,
		_1: y
	};
}

function chr(c)
{
	return new String(c);
}


// GUID

var count = 0;
function guid(_)
{
	return count++;
}


// RECORDS

function update(oldRecord, updatedFields)
{
	var newRecord = {};

	for (var key in oldRecord)
	{
		newRecord[key] = oldRecord[key];
	}

	for (var key in updatedFields)
	{
		newRecord[key] = updatedFields[key];
	}

	return newRecord;
}


//// LIST STUFF ////

var Nil = { ctor: '[]' };

function Cons(hd, tl)
{
	return {
		ctor: '::',
		_0: hd,
		_1: tl
	};
}

function append(xs, ys)
{
	// append Strings
	if (typeof xs === 'string')
	{
		return xs + ys;
	}

	// append Lists
	if (xs.ctor === '[]')
	{
		return ys;
	}
	var root = Cons(xs._0, Nil);
	var curr = root;
	xs = xs._1;
	while (xs.ctor !== '[]')
	{
		curr._1 = Cons(xs._0, Nil);
		xs = xs._1;
		curr = curr._1;
	}
	curr._1 = ys;
	return root;
}


// CRASHES

function crash(moduleName, region)
{
	return function(message) {
		throw new Error(
			'Ran into a `Debug.crash` in module `' + moduleName + '` ' + regionToString(region) + '\n'
			+ 'The message provided by the code author is:\n\n    '
			+ message
		);
	};
}

function crashCase(moduleName, region, value)
{
	return function(message) {
		throw new Error(
			'Ran into a `Debug.crash` in module `' + moduleName + '`\n\n'
			+ 'This was caused by the `case` expression ' + regionToString(region) + '.\n'
			+ 'One of the branches ended with a crash and the following value got through:\n\n    ' + toString(value) + '\n\n'
			+ 'The message provided by the code author is:\n\n    '
			+ message
		);
	};
}

function regionToString(region)
{
	if (region.start.line == region.end.line)
	{
		return 'on line ' + region.start.line;
	}
	return 'between lines ' + region.start.line + ' and ' + region.end.line;
}


// TO STRING

function toString(v)
{
	var type = typeof v;
	if (type === 'function')
	{
		return '<function>';
	}

	if (type === 'boolean')
	{
		return v ? 'True' : 'False';
	}

	if (type === 'number')
	{
		return v + '';
	}

	if (v instanceof String)
	{
		return '\'' + addSlashes(v, true) + '\'';
	}

	if (type === 'string')
	{
		return '"' + addSlashes(v, false) + '"';
	}

	if (v === null)
	{
		return 'null';
	}

	if (type === 'object' && 'ctor' in v)
	{
		var ctorStarter = v.ctor.substring(0, 5);

		if (ctorStarter === '_Tupl')
		{
			var output = [];
			for (var k in v)
			{
				if (k === 'ctor') continue;
				output.push(toString(v[k]));
			}
			return '(' + output.join(',') + ')';
		}

		if (ctorStarter === '_Task')
		{
			return '<task>'
		}

		if (v.ctor === '_Array')
		{
			var list = _elm_lang$core$Array$toList(v);
			return 'Array.fromList ' + toString(list);
		}

		if (v.ctor === '<decoder>')
		{
			return '<decoder>';
		}

		if (v.ctor === '_Process')
		{
			return '<process:' + v.id + '>';
		}

		if (v.ctor === '::')
		{
			var output = '[' + toString(v._0);
			v = v._1;
			while (v.ctor === '::')
			{
				output += ',' + toString(v._0);
				v = v._1;
			}
			return output + ']';
		}

		if (v.ctor === '[]')
		{
			return '[]';
		}

		if (v.ctor === 'Set_elm_builtin')
		{
			return 'Set.fromList ' + toString(_elm_lang$core$Set$toList(v));
		}

		if (v.ctor === 'RBNode_elm_builtin' || v.ctor === 'RBEmpty_elm_builtin')
		{
			return 'Dict.fromList ' + toString(_elm_lang$core$Dict$toList(v));
		}

		var output = '';
		for (var i in v)
		{
			if (i === 'ctor') continue;
			var str = toString(v[i]);
			var c0 = str[0];
			var parenless = c0 === '{' || c0 === '(' || c0 === '<' || c0 === '"' || str.indexOf(' ') < 0;
			output += ' ' + (parenless ? str : '(' + str + ')');
		}
		return v.ctor + output;
	}

	if (type === 'object')
	{
		if (v instanceof Date)
		{
			return '<' + v.toString() + '>';
		}

		if (v.elm_web_socket)
		{
			return '<websocket>';
		}

		var output = [];
		for (var k in v)
		{
			output.push(k + ' = ' + toString(v[k]));
		}
		if (output.length === 0)
		{
			return '{}';
		}
		return '{ ' + output.join(', ') + ' }';
	}

	return '<internal structure>';
}

function addSlashes(str, isChar)
{
	var s = str.replace(/\\/g, '\\\\')
			  .replace(/\n/g, '\\n')
			  .replace(/\t/g, '\\t')
			  .replace(/\r/g, '\\r')
			  .replace(/\v/g, '\\v')
			  .replace(/\0/g, '\\0');
	if (isChar)
	{
		return s.replace(/\'/g, '\\\'');
	}
	else
	{
		return s.replace(/\"/g, '\\"');
	}
}


return {
	eq: eq,
	cmp: cmp,
	Tuple0: Tuple0,
	Tuple2: Tuple2,
	chr: chr,
	update: update,
	guid: guid,

	append: F2(append),

	crash: crash,
	crashCase: crashCase,

	toString: toString
};

}();
var _elm_lang$core$Basics$never = function (_p0) {
	never:
	while (true) {
		var _p1 = _p0;
		var _v1 = _p1._0;
		_p0 = _v1;
		continue never;
	}
};
var _elm_lang$core$Basics$uncurry = F2(
	function (f, _p2) {
		var _p3 = _p2;
		return A2(f, _p3._0, _p3._1);
	});
var _elm_lang$core$Basics$curry = F3(
	function (f, a, b) {
		return f(
			{ctor: '_Tuple2', _0: a, _1: b});
	});
var _elm_lang$core$Basics$flip = F3(
	function (f, b, a) {
		return A2(f, a, b);
	});
var _elm_lang$core$Basics$always = F2(
	function (a, _p4) {
		return a;
	});
var _elm_lang$core$Basics$identity = function (x) {
	return x;
};
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['<|'] = F2(
	function (f, x) {
		return f(x);
	});
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['|>'] = F2(
	function (x, f) {
		return f(x);
	});
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['>>'] = F3(
	function (f, g, x) {
		return g(
			f(x));
	});
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['<<'] = F3(
	function (g, f, x) {
		return g(
			f(x));
	});
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['++'] = _elm_lang$core$Native_Utils.append;
var _elm_lang$core$Basics$toString = _elm_lang$core$Native_Utils.toString;
var _elm_lang$core$Basics$isInfinite = _elm_lang$core$Native_Basics.isInfinite;
var _elm_lang$core$Basics$isNaN = _elm_lang$core$Native_Basics.isNaN;
var _elm_lang$core$Basics$toFloat = _elm_lang$core$Native_Basics.toFloat;
var _elm_lang$core$Basics$ceiling = _elm_lang$core$Native_Basics.ceiling;
var _elm_lang$core$Basics$floor = _elm_lang$core$Native_Basics.floor;
var _elm_lang$core$Basics$truncate = _elm_lang$core$Native_Basics.truncate;
var _elm_lang$core$Basics$round = _elm_lang$core$Native_Basics.round;
var _elm_lang$core$Basics$not = _elm_lang$core$Native_Basics.not;
var _elm_lang$core$Basics$xor = _elm_lang$core$Native_Basics.xor;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['||'] = _elm_lang$core$Native_Basics.or;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['&&'] = _elm_lang$core$Native_Basics.and;
var _elm_lang$core$Basics$max = _elm_lang$core$Native_Basics.max;
var _elm_lang$core$Basics$min = _elm_lang$core$Native_Basics.min;
var _elm_lang$core$Basics$compare = _elm_lang$core$Native_Basics.compare;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['>='] = _elm_lang$core$Native_Basics.ge;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['<='] = _elm_lang$core$Native_Basics.le;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['>'] = _elm_lang$core$Native_Basics.gt;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['<'] = _elm_lang$core$Native_Basics.lt;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['/='] = _elm_lang$core$Native_Basics.neq;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['=='] = _elm_lang$core$Native_Basics.eq;
var _elm_lang$core$Basics$e = _elm_lang$core$Native_Basics.e;
var _elm_lang$core$Basics$pi = _elm_lang$core$Native_Basics.pi;
var _elm_lang$core$Basics$clamp = _elm_lang$core$Native_Basics.clamp;
var _elm_lang$core$Basics$logBase = _elm_lang$core$Native_Basics.logBase;
var _elm_lang$core$Basics$abs = _elm_lang$core$Native_Basics.abs;
var _elm_lang$core$Basics$negate = _elm_lang$core$Native_Basics.negate;
var _elm_lang$core$Basics$sqrt = _elm_lang$core$Native_Basics.sqrt;
var _elm_lang$core$Basics$atan2 = _elm_lang$core$Native_Basics.atan2;
var _elm_lang$core$Basics$atan = _elm_lang$core$Native_Basics.atan;
var _elm_lang$core$Basics$asin = _elm_lang$core$Native_Basics.asin;
var _elm_lang$core$Basics$acos = _elm_lang$core$Native_Basics.acos;
var _elm_lang$core$Basics$tan = _elm_lang$core$Native_Basics.tan;
var _elm_lang$core$Basics$sin = _elm_lang$core$Native_Basics.sin;
var _elm_lang$core$Basics$cos = _elm_lang$core$Native_Basics.cos;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['^'] = _elm_lang$core$Native_Basics.exp;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['%'] = _elm_lang$core$Native_Basics.mod;
var _elm_lang$core$Basics$rem = _elm_lang$core$Native_Basics.rem;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['//'] = _elm_lang$core$Native_Basics.div;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['/'] = _elm_lang$core$Native_Basics.floatDiv;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['*'] = _elm_lang$core$Native_Basics.mul;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['-'] = _elm_lang$core$Native_Basics.sub;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['+'] = _elm_lang$core$Native_Basics.add;
var _elm_lang$core$Basics$toPolar = _elm_lang$core$Native_Basics.toPolar;
var _elm_lang$core$Basics$fromPolar = _elm_lang$core$Native_Basics.fromPolar;
var _elm_lang$core$Basics$turns = _elm_lang$core$Native_Basics.turns;
var _elm_lang$core$Basics$degrees = _elm_lang$core$Native_Basics.degrees;
var _elm_lang$core$Basics$radians = function (t) {
	return t;
};
var _elm_lang$core$Basics$GT = {ctor: 'GT'};
var _elm_lang$core$Basics$EQ = {ctor: 'EQ'};
var _elm_lang$core$Basics$LT = {ctor: 'LT'};
var _elm_lang$core$Basics$JustOneMore = function (a) {
	return {ctor: 'JustOneMore', _0: a};
};

//import Native.Utils //

var _elm_lang$core$Native_Debug = function() {

function log(tag, value)
{
	var msg = tag + ': ' + _elm_lang$core$Native_Utils.toString(value);
	var process = process || {};
	if (process.stdout)
	{
		process.stdout.write(msg);
	}
	else
	{
		console.log(msg);
	}
	return value;
}

function crash(message)
{
	throw new Error(message);
}

return {
	crash: crash,
	log: F2(log)
};

}();
var _elm_lang$core$Debug$crash = _elm_lang$core$Native_Debug.crash;
var _elm_lang$core$Debug$log = _elm_lang$core$Native_Debug.log;

var _elm_lang$core$Maybe$withDefault = F2(
	function ($default, maybe) {
		var _p0 = maybe;
		if (_p0.ctor === 'Just') {
			return _p0._0;
		} else {
			return $default;
		}
	});
var _elm_lang$core$Maybe$Nothing = {ctor: 'Nothing'};
var _elm_lang$core$Maybe$andThen = F2(
	function (callback, maybeValue) {
		var _p1 = maybeValue;
		if (_p1.ctor === 'Just') {
			return callback(_p1._0);
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$Just = function (a) {
	return {ctor: 'Just', _0: a};
};
var _elm_lang$core$Maybe$map = F2(
	function (f, maybe) {
		var _p2 = maybe;
		if (_p2.ctor === 'Just') {
			return _elm_lang$core$Maybe$Just(
				f(_p2._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$map2 = F3(
	function (func, ma, mb) {
		var _p3 = {ctor: '_Tuple2', _0: ma, _1: mb};
		if (((_p3.ctor === '_Tuple2') && (_p3._0.ctor === 'Just')) && (_p3._1.ctor === 'Just')) {
			return _elm_lang$core$Maybe$Just(
				A2(func, _p3._0._0, _p3._1._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$map3 = F4(
	function (func, ma, mb, mc) {
		var _p4 = {ctor: '_Tuple3', _0: ma, _1: mb, _2: mc};
		if ((((_p4.ctor === '_Tuple3') && (_p4._0.ctor === 'Just')) && (_p4._1.ctor === 'Just')) && (_p4._2.ctor === 'Just')) {
			return _elm_lang$core$Maybe$Just(
				A3(func, _p4._0._0, _p4._1._0, _p4._2._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$map4 = F5(
	function (func, ma, mb, mc, md) {
		var _p5 = {ctor: '_Tuple4', _0: ma, _1: mb, _2: mc, _3: md};
		if (((((_p5.ctor === '_Tuple4') && (_p5._0.ctor === 'Just')) && (_p5._1.ctor === 'Just')) && (_p5._2.ctor === 'Just')) && (_p5._3.ctor === 'Just')) {
			return _elm_lang$core$Maybe$Just(
				A4(func, _p5._0._0, _p5._1._0, _p5._2._0, _p5._3._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$map5 = F6(
	function (func, ma, mb, mc, md, me) {
		var _p6 = {ctor: '_Tuple5', _0: ma, _1: mb, _2: mc, _3: md, _4: me};
		if ((((((_p6.ctor === '_Tuple5') && (_p6._0.ctor === 'Just')) && (_p6._1.ctor === 'Just')) && (_p6._2.ctor === 'Just')) && (_p6._3.ctor === 'Just')) && (_p6._4.ctor === 'Just')) {
			return _elm_lang$core$Maybe$Just(
				A5(func, _p6._0._0, _p6._1._0, _p6._2._0, _p6._3._0, _p6._4._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});

//import Native.Utils //

var _elm_lang$core$Native_List = function() {

var Nil = { ctor: '[]' };

function Cons(hd, tl)
{
	return { ctor: '::', _0: hd, _1: tl };
}

function fromArray(arr)
{
	var out = Nil;
	for (var i = arr.length; i--; )
	{
		out = Cons(arr[i], out);
	}
	return out;
}

function toArray(xs)
{
	var out = [];
	while (xs.ctor !== '[]')
	{
		out.push(xs._0);
		xs = xs._1;
	}
	return out;
}

function foldr(f, b, xs)
{
	var arr = toArray(xs);
	var acc = b;
	for (var i = arr.length; i--; )
	{
		acc = A2(f, arr[i], acc);
	}
	return acc;
}

function map2(f, xs, ys)
{
	var arr = [];
	while (xs.ctor !== '[]' && ys.ctor !== '[]')
	{
		arr.push(A2(f, xs._0, ys._0));
		xs = xs._1;
		ys = ys._1;
	}
	return fromArray(arr);
}

function map3(f, xs, ys, zs)
{
	var arr = [];
	while (xs.ctor !== '[]' && ys.ctor !== '[]' && zs.ctor !== '[]')
	{
		arr.push(A3(f, xs._0, ys._0, zs._0));
		xs = xs._1;
		ys = ys._1;
		zs = zs._1;
	}
	return fromArray(arr);
}

function map4(f, ws, xs, ys, zs)
{
	var arr = [];
	while (   ws.ctor !== '[]'
		   && xs.ctor !== '[]'
		   && ys.ctor !== '[]'
		   && zs.ctor !== '[]')
	{
		arr.push(A4(f, ws._0, xs._0, ys._0, zs._0));
		ws = ws._1;
		xs = xs._1;
		ys = ys._1;
		zs = zs._1;
	}
	return fromArray(arr);
}

function map5(f, vs, ws, xs, ys, zs)
{
	var arr = [];
	while (   vs.ctor !== '[]'
		   && ws.ctor !== '[]'
		   && xs.ctor !== '[]'
		   && ys.ctor !== '[]'
		   && zs.ctor !== '[]')
	{
		arr.push(A5(f, vs._0, ws._0, xs._0, ys._0, zs._0));
		vs = vs._1;
		ws = ws._1;
		xs = xs._1;
		ys = ys._1;
		zs = zs._1;
	}
	return fromArray(arr);
}

function sortBy(f, xs)
{
	return fromArray(toArray(xs).sort(function(a, b) {
		return _elm_lang$core$Native_Utils.cmp(f(a), f(b));
	}));
}

function sortWith(f, xs)
{
	return fromArray(toArray(xs).sort(function(a, b) {
		var ord = f(a)(b).ctor;
		return ord === 'EQ' ? 0 : ord === 'LT' ? -1 : 1;
	}));
}

return {
	Nil: Nil,
	Cons: Cons,
	cons: F2(Cons),
	toArray: toArray,
	fromArray: fromArray,

	foldr: F3(foldr),

	map2: F3(map2),
	map3: F4(map3),
	map4: F5(map4),
	map5: F6(map5),
	sortBy: F2(sortBy),
	sortWith: F2(sortWith)
};

}();
var _elm_lang$core$List$sortWith = _elm_lang$core$Native_List.sortWith;
var _elm_lang$core$List$sortBy = _elm_lang$core$Native_List.sortBy;
var _elm_lang$core$List$sort = function (xs) {
	return A2(_elm_lang$core$List$sortBy, _elm_lang$core$Basics$identity, xs);
};
var _elm_lang$core$List$singleton = function (value) {
	return {
		ctor: '::',
		_0: value,
		_1: {ctor: '[]'}
	};
};
var _elm_lang$core$List$drop = F2(
	function (n, list) {
		drop:
		while (true) {
			if (_elm_lang$core$Native_Utils.cmp(n, 0) < 1) {
				return list;
			} else {
				var _p0 = list;
				if (_p0.ctor === '[]') {
					return list;
				} else {
					var _v1 = n - 1,
						_v2 = _p0._1;
					n = _v1;
					list = _v2;
					continue drop;
				}
			}
		}
	});
var _elm_lang$core$List$map5 = _elm_lang$core$Native_List.map5;
var _elm_lang$core$List$map4 = _elm_lang$core$Native_List.map4;
var _elm_lang$core$List$map3 = _elm_lang$core$Native_List.map3;
var _elm_lang$core$List$map2 = _elm_lang$core$Native_List.map2;
var _elm_lang$core$List$any = F2(
	function (isOkay, list) {
		any:
		while (true) {
			var _p1 = list;
			if (_p1.ctor === '[]') {
				return false;
			} else {
				if (isOkay(_p1._0)) {
					return true;
				} else {
					var _v4 = isOkay,
						_v5 = _p1._1;
					isOkay = _v4;
					list = _v5;
					continue any;
				}
			}
		}
	});
var _elm_lang$core$List$all = F2(
	function (isOkay, list) {
		return !_elm_lang$core$List$any.func(function (_p2) {
            return !isOkay(_p2);
        }, list);
	});
var _elm_lang$core$List$foldr = _elm_lang$core$Native_List.foldr;
var _elm_lang$core$List$foldl = F3(
	function (func, acc, list) {
		foldl:
		while (true) {
			var _p3 = list;
			if (_p3.ctor === '[]') {
				return acc;
			} else {
				var _v7 = func,
					_v8 = A2(func, _p3._0, acc),
					_v9 = _p3._1;
				func = _v7;
				acc = _v8;
				list = _v9;
				continue foldl;
			}
		}
	});
var _elm_lang$core$List$length = function (xs) {
	return _elm_lang$core$List$foldl.func(F2(
        function (_p4, i) {
            return i + 1;
        }), 0, xs);
};
var _elm_lang$core$List$sum = function (numbers) {
	return _elm_lang$core$List$foldl.func(F2(
        function (x, y) {
            return x + y;
        }), 0, numbers);
};
var _elm_lang$core$List$product = function (numbers) {
	return _elm_lang$core$List$foldl.func(F2(
        function (x, y) {
            return x * y;
        }), 1, numbers);
};
var _elm_lang$core$List$maximum = function (list) {
	var _p5 = list;
	if (_p5.ctor === '::') {
		return _elm_lang$core$Maybe$Just(
			_elm_lang$core$List$foldl.func(_elm_lang$core$Basics$max, _p5._0, _p5._1));
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$List$minimum = function (list) {
	var _p6 = list;
	if (_p6.ctor === '::') {
		return _elm_lang$core$Maybe$Just(
			_elm_lang$core$List$foldl.func(_elm_lang$core$Basics$min, _p6._0, _p6._1));
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$List$member = F2(
	function (x, xs) {
		return _elm_lang$core$List$any.func(function (a) {
            return _elm_lang$core$Native_Utils.eq(a, x);
        }, xs);
	});
var _elm_lang$core$List$isEmpty = function (xs) {
	var _p7 = xs;
	if (_p7.ctor === '[]') {
		return true;
	} else {
		return false;
	}
};
var _elm_lang$core$List$tail = function (list) {
	var _p8 = list;
	if (_p8.ctor === '::') {
		return _elm_lang$core$Maybe$Just(_p8._1);
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$List$head = function (list) {
	var _p9 = list;
	if (_p9.ctor === '::') {
		return _elm_lang$core$Maybe$Just(_p9._0);
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$List_ops = _elm_lang$core$List_ops || {};
_elm_lang$core$List_ops['::'] = _elm_lang$core$Native_List.cons;
var _elm_lang$core$List$map = F2(
	function (f, xs) {
		return A3(
			_elm_lang$core$List$foldr,
			F2(
				function (x, acc) {
					return {
						ctor: '::',
						_0: f(x),
						_1: acc
					};
				}),
			{ctor: '[]'},
			xs);
	});
var _elm_lang$core$List$filter = F2(
	function (pred, xs) {
		var conditionalCons = F2(
			function (front, back) {
				return pred(front) ? {ctor: '::', _0: front, _1: back} : back;
			});
		return A3(
			_elm_lang$core$List$foldr,
			conditionalCons,
			{ctor: '[]'},
			xs);
	});
var _elm_lang$core$List$maybeCons = F3(
	function (f, mx, xs) {
		var _p10 = f(mx);
		if (_p10.ctor === 'Just') {
			return {ctor: '::', _0: _p10._0, _1: xs};
		} else {
			return xs;
		}
	});
var _elm_lang$core$List$filterMap = F2(
	function (f, xs) {
		return A3(
			_elm_lang$core$List$foldr,
			_elm_lang$core$List$maybeCons(f),
			{ctor: '[]'},
			xs);
	});
var _elm_lang$core$List$reverse = function (list) {
	return _elm_lang$core$List$foldl.func(F2(
        function (x, y) {
            return {ctor: '::', _0: x, _1: y};
        }), {ctor: '[]'}, list);
};
var _elm_lang$core$List$scanl = F3(
	function (f, b, xs) {
		var scan1 = F2(
			function (x, accAcc) {
				var _p11 = accAcc;
				if (_p11.ctor === '::') {
					return {
						ctor: '::',
						_0: A2(f, x, _p11._0),
						_1: accAcc
					};
				} else {
					return {ctor: '[]'};
				}
			});
		return _elm_lang$core$List$reverse(
			_elm_lang$core$List$foldl.func(scan1, {
                ctor: '::',
                _0: b,
                _1: {ctor: '[]'}
            }, xs));
	});
var _elm_lang$core$List$append = F2(
	function (xs, ys) {
		var _p12 = ys;
		if (_p12.ctor === '[]') {
			return xs;
		} else {
			return A3(
				_elm_lang$core$List$foldr,
				F2(
					function (x, y) {
						return {ctor: '::', _0: x, _1: y};
					}),
				ys,
				xs);
		}
	});
var _elm_lang$core$List$concat = function (lists) {
	return A3(
		_elm_lang$core$List$foldr,
		_elm_lang$core$List$append,
		{ctor: '[]'},
		lists);
};
var _elm_lang$core$List$concatMap = F2(
	function (f, list) {
		return _elm_lang$core$List$concat(
			_elm_lang$core$List$map.func(f, list));
	});
var _elm_lang$core$List$partition = F2(
	function (pred, list) {
		var step = F2(
			function (x, _p13) {
				var _p14 = _p13;
				var _p16 = _p14._0;
				var _p15 = _p14._1;
				return pred(x) ? {
					ctor: '_Tuple2',
					_0: {ctor: '::', _0: x, _1: _p16},
					_1: _p15
				} : {
					ctor: '_Tuple2',
					_0: _p16,
					_1: {ctor: '::', _0: x, _1: _p15}
				};
			});
		return A3(
			_elm_lang$core$List$foldr,
			step,
			{
				ctor: '_Tuple2',
				_0: {ctor: '[]'},
				_1: {ctor: '[]'}
			},
			list);
	});
var _elm_lang$core$List$unzip = function (pairs) {
	var step = F2(
		function (_p18, _p17) {
			var _p19 = _p18;
			var _p20 = _p17;
			return {
				ctor: '_Tuple2',
				_0: {ctor: '::', _0: _p19._0, _1: _p20._0},
				_1: {ctor: '::', _0: _p19._1, _1: _p20._1}
			};
		});
	return A3(
		_elm_lang$core$List$foldr,
		step,
		{
			ctor: '_Tuple2',
			_0: {ctor: '[]'},
			_1: {ctor: '[]'}
		},
		pairs);
};
var _elm_lang$core$List$intersperse = F2(
	function (sep, xs) {
		var _p21 = xs;
		if (_p21.ctor === '[]') {
			return {ctor: '[]'};
		} else {
			var step = F2(
				function (x, rest) {
					return {
						ctor: '::',
						_0: sep,
						_1: {ctor: '::', _0: x, _1: rest}
					};
				});
			var spersed = A3(
				_elm_lang$core$List$foldr,
				step,
				{ctor: '[]'},
				_p21._1);
			return {ctor: '::', _0: _p21._0, _1: spersed};
		}
	});
var _elm_lang$core$List$takeReverse = F3(
	function (n, list, taken) {
		takeReverse:
		while (true) {
			if (_elm_lang$core$Native_Utils.cmp(n, 0) < 1) {
				return taken;
			} else {
				var _p22 = list;
				if (_p22.ctor === '[]') {
					return taken;
				} else {
					var _v23 = n - 1,
						_v24 = _p22._1,
						_v25 = {ctor: '::', _0: _p22._0, _1: taken};
					n = _v23;
					list = _v24;
					taken = _v25;
					continue takeReverse;
				}
			}
		}
	});
var _elm_lang$core$List$takeTailRec = F2(
	function (n, list) {
		return _elm_lang$core$List$reverse(
			_elm_lang$core$List$takeReverse.func(n, list, {ctor: '[]'}));
	});
var _elm_lang$core$List$takeFast = F3(
	function (ctr, n, list) {
		if (_elm_lang$core$Native_Utils.cmp(n, 0) < 1) {
			return {ctor: '[]'};
		} else {
			var _p23 = {ctor: '_Tuple2', _0: n, _1: list};
			_v26_5:
			do {
				_v26_1:
				do {
					if (_p23.ctor === '_Tuple2') {
						if (_p23._1.ctor === '[]') {
							return list;
						} else {
							if (_p23._1._1.ctor === '::') {
								switch (_p23._0) {
									case 1:
										break _v26_1;
									case 2:
										return {
											ctor: '::',
											_0: _p23._1._0,
											_1: {
												ctor: '::',
												_0: _p23._1._1._0,
												_1: {ctor: '[]'}
											}
										};
									case 3:
										if (_p23._1._1._1.ctor === '::') {
											return {
												ctor: '::',
												_0: _p23._1._0,
												_1: {
													ctor: '::',
													_0: _p23._1._1._0,
													_1: {
														ctor: '::',
														_0: _p23._1._1._1._0,
														_1: {ctor: '[]'}
													}
												}
											};
										} else {
											break _v26_5;
										}
									default:
										if ((_p23._1._1._1.ctor === '::') && (_p23._1._1._1._1.ctor === '::')) {
											var _p28 = _p23._1._1._1._0;
											var _p27 = _p23._1._1._0;
											var _p26 = _p23._1._0;
											var _p25 = _p23._1._1._1._1._0;
											var _p24 = _p23._1._1._1._1._1;
											return (_elm_lang$core$Native_Utils.cmp(ctr, 1000) > 0) ? {
												ctor: '::',
												_0: _p26,
												_1: {
													ctor: '::',
													_0: _p27,
													_1: {
														ctor: '::',
														_0: _p28,
														_1: {
															ctor: '::',
															_0: _p25,
															_1: _elm_lang$core$List$takeTailRec.func(n - 4, _p24)
														}
													}
												}
											} : {
												ctor: '::',
												_0: _p26,
												_1: {
													ctor: '::',
													_0: _p27,
													_1: {
														ctor: '::',
														_0: _p28,
														_1: {
															ctor: '::',
															_0: _p25,
															_1: _elm_lang$core$List$takeFast.func(ctr + 1, n - 4, _p24)
														}
													}
												}
											};
										} else {
											break _v26_5;
										}
								}
							} else {
								if (_p23._0 === 1) {
									break _v26_1;
								} else {
									break _v26_5;
								}
							}
						}
					} else {
						break _v26_5;
					}
				} while(false);
				return {
					ctor: '::',
					_0: _p23._1._0,
					_1: {ctor: '[]'}
				};
			} while(false);
			return list;
		}
	});
var _elm_lang$core$List$take = F2(
	function (n, list) {
		return _elm_lang$core$List$takeFast.func(0, n, list);
	});
var _elm_lang$core$List$repeatHelp = F3(
	function (result, n, value) {
		repeatHelp:
		while (true) {
			if (_elm_lang$core$Native_Utils.cmp(n, 0) < 1) {
				return result;
			} else {
				var _v27 = {ctor: '::', _0: value, _1: result},
					_v28 = n - 1,
					_v29 = value;
				result = _v27;
				n = _v28;
				value = _v29;
				continue repeatHelp;
			}
		}
	});
var _elm_lang$core$List$repeat = F2(
	function (n, value) {
		return _elm_lang$core$List$repeatHelp.func({ctor: '[]'}, n, value);
	});
var _elm_lang$core$List$rangeHelp = F3(
	function (lo, hi, list) {
		rangeHelp:
		while (true) {
			if (_elm_lang$core$Native_Utils.cmp(lo, hi) < 1) {
				var _v30 = lo,
					_v31 = hi - 1,
					_v32 = {ctor: '::', _0: hi, _1: list};
				lo = _v30;
				hi = _v31;
				list = _v32;
				continue rangeHelp;
			} else {
				return list;
			}
		}
	});
var _elm_lang$core$List$range = F2(
	function (lo, hi) {
		return _elm_lang$core$List$rangeHelp.func(lo, hi, {ctor: '[]'});
	});
var _elm_lang$core$List$indexedMap = F2(
	function (f, xs) {
		return A3(
			_elm_lang$core$List$map2,
			f,
			_elm_lang$core$List$range.func(0, _elm_lang$core$List$length(xs) - 1),
			xs);
	});

var _elm_lang$core$Result$toMaybe = function (result) {
	var _p0 = result;
	if (_p0.ctor === 'Ok') {
		return _elm_lang$core$Maybe$Just(_p0._0);
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$Result$withDefault = F2(
	function (def, result) {
		var _p1 = result;
		if (_p1.ctor === 'Ok') {
			return _p1._0;
		} else {
			return def;
		}
	});
var _elm_lang$core$Result$Err = function (a) {
	return {ctor: 'Err', _0: a};
};
var _elm_lang$core$Result$andThen = F2(
	function (callback, result) {
		var _p2 = result;
		if (_p2.ctor === 'Ok') {
			return callback(_p2._0);
		} else {
			return _elm_lang$core$Result$Err(_p2._0);
		}
	});
var _elm_lang$core$Result$Ok = function (a) {
	return {ctor: 'Ok', _0: a};
};
var _elm_lang$core$Result$map = F2(
	function (func, ra) {
		var _p3 = ra;
		if (_p3.ctor === 'Ok') {
			return _elm_lang$core$Result$Ok(
				func(_p3._0));
		} else {
			return _elm_lang$core$Result$Err(_p3._0);
		}
	});
var _elm_lang$core$Result$map2 = F3(
	function (func, ra, rb) {
		var _p4 = {ctor: '_Tuple2', _0: ra, _1: rb};
		if (_p4._0.ctor === 'Ok') {
			if (_p4._1.ctor === 'Ok') {
				return _elm_lang$core$Result$Ok(
					A2(func, _p4._0._0, _p4._1._0));
			} else {
				return _elm_lang$core$Result$Err(_p4._1._0);
			}
		} else {
			return _elm_lang$core$Result$Err(_p4._0._0);
		}
	});
var _elm_lang$core$Result$map3 = F4(
	function (func, ra, rb, rc) {
		var _p5 = {ctor: '_Tuple3', _0: ra, _1: rb, _2: rc};
		if (_p5._0.ctor === 'Ok') {
			if (_p5._1.ctor === 'Ok') {
				if (_p5._2.ctor === 'Ok') {
					return _elm_lang$core$Result$Ok(
						A3(func, _p5._0._0, _p5._1._0, _p5._2._0));
				} else {
					return _elm_lang$core$Result$Err(_p5._2._0);
				}
			} else {
				return _elm_lang$core$Result$Err(_p5._1._0);
			}
		} else {
			return _elm_lang$core$Result$Err(_p5._0._0);
		}
	});
var _elm_lang$core$Result$map4 = F5(
	function (func, ra, rb, rc, rd) {
		var _p6 = {ctor: '_Tuple4', _0: ra, _1: rb, _2: rc, _3: rd};
		if (_p6._0.ctor === 'Ok') {
			if (_p6._1.ctor === 'Ok') {
				if (_p6._2.ctor === 'Ok') {
					if (_p6._3.ctor === 'Ok') {
						return _elm_lang$core$Result$Ok(
							A4(func, _p6._0._0, _p6._1._0, _p6._2._0, _p6._3._0));
					} else {
						return _elm_lang$core$Result$Err(_p6._3._0);
					}
				} else {
					return _elm_lang$core$Result$Err(_p6._2._0);
				}
			} else {
				return _elm_lang$core$Result$Err(_p6._1._0);
			}
		} else {
			return _elm_lang$core$Result$Err(_p6._0._0);
		}
	});
var _elm_lang$core$Result$map5 = F6(
	function (func, ra, rb, rc, rd, re) {
		var _p7 = {ctor: '_Tuple5', _0: ra, _1: rb, _2: rc, _3: rd, _4: re};
		if (_p7._0.ctor === 'Ok') {
			if (_p7._1.ctor === 'Ok') {
				if (_p7._2.ctor === 'Ok') {
					if (_p7._3.ctor === 'Ok') {
						if (_p7._4.ctor === 'Ok') {
							return _elm_lang$core$Result$Ok(
								A5(func, _p7._0._0, _p7._1._0, _p7._2._0, _p7._3._0, _p7._4._0));
						} else {
							return _elm_lang$core$Result$Err(_p7._4._0);
						}
					} else {
						return _elm_lang$core$Result$Err(_p7._3._0);
					}
				} else {
					return _elm_lang$core$Result$Err(_p7._2._0);
				}
			} else {
				return _elm_lang$core$Result$Err(_p7._1._0);
			}
		} else {
			return _elm_lang$core$Result$Err(_p7._0._0);
		}
	});
var _elm_lang$core$Result$mapError = F2(
	function (f, result) {
		var _p8 = result;
		if (_p8.ctor === 'Ok') {
			return _elm_lang$core$Result$Ok(_p8._0);
		} else {
			return _elm_lang$core$Result$Err(
				f(_p8._0));
		}
	});
var _elm_lang$core$Result$fromMaybe = F2(
	function (err, maybe) {
		var _p9 = maybe;
		if (_p9.ctor === 'Just') {
			return _elm_lang$core$Result$Ok(_p9._0);
		} else {
			return _elm_lang$core$Result$Err(err);
		}
	});

//import Maybe, Native.List, Native.Utils, Result //

var _elm_lang$core$Native_String = function() {

function isEmpty(str)
{
	return str.length === 0;
}
function cons(chr, str)
{
	return chr + str;
}
function uncons(str)
{
	var hd = str[0];
	if (hd)
	{
		return _elm_lang$core$Maybe$Just(_elm_lang$core$Native_Utils.Tuple2(_elm_lang$core$Native_Utils.chr(hd), str.slice(1)));
	}
	return _elm_lang$core$Maybe$Nothing;
}
function append(a, b)
{
	return a + b;
}
function concat(strs)
{
	return _elm_lang$core$Native_List.toArray(strs).join('');
}
function length(str)
{
	return str.length;
}
function map(f, str)
{
	var out = str.split('');
	for (var i = out.length; i--; )
	{
		out[i] = f(_elm_lang$core$Native_Utils.chr(out[i]));
	}
	return out.join('');
}
function filter(pred, str)
{
	return str.split('').map(_elm_lang$core$Native_Utils.chr).filter(pred).join('');
}
function reverse(str)
{
	return str.split('').reverse().join('');
}
function foldl(f, b, str)
{
	var len = str.length;
	for (var i = 0; i < len; ++i)
	{
		b = A2(f, _elm_lang$core$Native_Utils.chr(str[i]), b);
	}
	return b;
}
function foldr(f, b, str)
{
	for (var i = str.length; i--; )
	{
		b = A2(f, _elm_lang$core$Native_Utils.chr(str[i]), b);
	}
	return b;
}
function split(sep, str)
{
	return _elm_lang$core$Native_List.fromArray(str.split(sep));
}
function join(sep, strs)
{
	return _elm_lang$core$Native_List.toArray(strs).join(sep);
}
function repeat(n, str)
{
	var result = '';
	while (n > 0)
	{
		if (n & 1)
		{
			result += str;
		}
		n >>= 1, str += str;
	}
	return result;
}
function slice(start, end, str)
{
	return str.slice(start, end);
}
function left(n, str)
{
	return n < 1 ? '' : str.slice(0, n);
}
function right(n, str)
{
	return n < 1 ? '' : str.slice(-n);
}
function dropLeft(n, str)
{
	return n < 1 ? str : str.slice(n);
}
function dropRight(n, str)
{
	return n < 1 ? str : str.slice(0, -n);
}
function pad(n, chr, str)
{
	var half = (n - str.length) / 2;
	return repeat(Math.ceil(half), chr) + str + repeat(half | 0, chr);
}
function padRight(n, chr, str)
{
	return str + repeat(n - str.length, chr);
}
function padLeft(n, chr, str)
{
	return repeat(n - str.length, chr) + str;
}

function trim(str)
{
	return str.trim();
}
function trimLeft(str)
{
	return str.replace(/^\s+/, '');
}
function trimRight(str)
{
	return str.replace(/\s+$/, '');
}

function words(str)
{
	return _elm_lang$core$Native_List.fromArray(str.trim().split(/\s+/g));
}
function lines(str)
{
	return _elm_lang$core$Native_List.fromArray(str.split(/\r\n|\r|\n/g));
}

function toUpper(str)
{
	return str.toUpperCase();
}
function toLower(str)
{
	return str.toLowerCase();
}

function any(pred, str)
{
	for (var i = str.length; i--; )
	{
		if (pred(_elm_lang$core$Native_Utils.chr(str[i])))
		{
			return true;
		}
	}
	return false;
}
function all(pred, str)
{
	for (var i = str.length; i--; )
	{
		if (!pred(_elm_lang$core$Native_Utils.chr(str[i])))
		{
			return false;
		}
	}
	return true;
}

function contains(sub, str)
{
	return str.indexOf(sub) > -1;
}
function startsWith(sub, str)
{
	return str.indexOf(sub) === 0;
}
function endsWith(sub, str)
{
	return str.length >= sub.length &&
		str.lastIndexOf(sub) === str.length - sub.length;
}
function indexes(sub, str)
{
	var subLen = sub.length;

	if (subLen < 1)
	{
		return _elm_lang$core$Native_List.Nil;
	}

	var i = 0;
	var is = [];

	while ((i = str.indexOf(sub, i)) > -1)
	{
		is.push(i);
		i = i + subLen;
	}

	return _elm_lang$core$Native_List.fromArray(is);
}


function toInt(s)
{
	var len = s.length;

	// if empty
	if (len === 0)
	{
		return intErr(s);
	}

	// if hex
	var c = s[0];
	if (c === '0' && s[1] === 'x')
	{
		for (var i = 2; i < len; ++i)
		{
			var c = s[i];
			if (('0' <= c && c <= '9') || ('A' <= c && c <= 'F') || ('a' <= c && c <= 'f'))
			{
				continue;
			}
			return intErr(s);
		}
		return _elm_lang$core$Result$Ok(parseInt(s, 16));
	}

	// is decimal
	if (c > '9' || (c < '0' && c !== '-' && c !== '+'))
	{
		return intErr(s);
	}
	for (var i = 1; i < len; ++i)
	{
		var c = s[i];
		if (c < '0' || '9' < c)
		{
			return intErr(s);
		}
	}

	return _elm_lang$core$Result$Ok(parseInt(s, 10));
}

function intErr(s)
{
	return _elm_lang$core$Result$Err("could not convert string '" + s + "' to an Int");
}


function toFloat(s)
{
	// check if it is a hex, octal, or binary number
	if (s.length === 0 || /[\sxbo]/.test(s))
	{
		return floatErr(s);
	}
	var n = +s;
	// faster isNaN check
	return n === n ? _elm_lang$core$Result$Ok(n) : floatErr(s);
}

function floatErr(s)
{
	return _elm_lang$core$Result$Err("could not convert string '" + s + "' to a Float");
}


function toList(str)
{
	return _elm_lang$core$Native_List.fromArray(str.split('').map(_elm_lang$core$Native_Utils.chr));
}
function fromList(chars)
{
	return _elm_lang$core$Native_List.toArray(chars).join('');
}

return {
	isEmpty: isEmpty,
	cons: F2(cons),
	uncons: uncons,
	append: F2(append),
	concat: concat,
	length: length,
	map: F2(map),
	filter: F2(filter),
	reverse: reverse,
	foldl: F3(foldl),
	foldr: F3(foldr),

	split: F2(split),
	join: F2(join),
	repeat: F2(repeat),

	slice: F3(slice),
	left: F2(left),
	right: F2(right),
	dropLeft: F2(dropLeft),
	dropRight: F2(dropRight),

	pad: F3(pad),
	padLeft: F3(padLeft),
	padRight: F3(padRight),

	trim: trim,
	trimLeft: trimLeft,
	trimRight: trimRight,

	words: words,
	lines: lines,

	toUpper: toUpper,
	toLower: toLower,

	any: F2(any),
	all: F2(all),

	contains: F2(contains),
	startsWith: F2(startsWith),
	endsWith: F2(endsWith),
	indexes: F2(indexes),

	toInt: toInt,
	toFloat: toFloat,
	toList: toList,
	fromList: fromList
};

}();

//import Native.Utils //

var _elm_lang$core$Native_Char = function() {

return {
	fromCode: function(c) { return _elm_lang$core$Native_Utils.chr(String.fromCharCode(c)); },
	toCode: function(c) { return c.charCodeAt(0); },
	toUpper: function(c) { return _elm_lang$core$Native_Utils.chr(c.toUpperCase()); },
	toLower: function(c) { return _elm_lang$core$Native_Utils.chr(c.toLowerCase()); },
	toLocaleUpper: function(c) { return _elm_lang$core$Native_Utils.chr(c.toLocaleUpperCase()); },
	toLocaleLower: function(c) { return _elm_lang$core$Native_Utils.chr(c.toLocaleLowerCase()); }
};

}();
var _elm_lang$core$Char$fromCode = _elm_lang$core$Native_Char.fromCode;
var _elm_lang$core$Char$toCode = _elm_lang$core$Native_Char.toCode;
var _elm_lang$core$Char$toLocaleLower = _elm_lang$core$Native_Char.toLocaleLower;
var _elm_lang$core$Char$toLocaleUpper = _elm_lang$core$Native_Char.toLocaleUpper;
var _elm_lang$core$Char$toLower = _elm_lang$core$Native_Char.toLower;
var _elm_lang$core$Char$toUpper = _elm_lang$core$Native_Char.toUpper;
var _elm_lang$core$Char$isBetween = F3(
	function (low, high, $char) {
		var code = _elm_lang$core$Char$toCode($char);
		return (_elm_lang$core$Native_Utils.cmp(
			code,
			_elm_lang$core$Char$toCode(low)) > -1) && (_elm_lang$core$Native_Utils.cmp(
			code,
			_elm_lang$core$Char$toCode(high)) < 1);
	});
var _elm_lang$core$Char$isUpper = A2(
	_elm_lang$core$Char$isBetween,
	_elm_lang$core$Native_Utils.chr('A'),
	_elm_lang$core$Native_Utils.chr('Z'));
var _elm_lang$core$Char$isLower = A2(
	_elm_lang$core$Char$isBetween,
	_elm_lang$core$Native_Utils.chr('a'),
	_elm_lang$core$Native_Utils.chr('z'));
var _elm_lang$core$Char$isDigit = A2(
	_elm_lang$core$Char$isBetween,
	_elm_lang$core$Native_Utils.chr('0'),
	_elm_lang$core$Native_Utils.chr('9'));
var _elm_lang$core$Char$isOctDigit = A2(
	_elm_lang$core$Char$isBetween,
	_elm_lang$core$Native_Utils.chr('0'),
	_elm_lang$core$Native_Utils.chr('7'));
var _elm_lang$core$Char$isHexDigit = function ($char) {
	return _elm_lang$core$Char$isDigit($char) || (_elm_lang$core$Char$isBetween.func(
        _elm_lang$core$Native_Utils.chr('a'),
        _elm_lang$core$Native_Utils.chr('f'),
        $char
    ) || _elm_lang$core$Char$isBetween.func(
        _elm_lang$core$Native_Utils.chr('A'),
        _elm_lang$core$Native_Utils.chr('F'),
        $char
    ));
};

var _elm_lang$core$String$fromList = _elm_lang$core$Native_String.fromList;
var _elm_lang$core$String$toList = _elm_lang$core$Native_String.toList;
var _elm_lang$core$String$toFloat = _elm_lang$core$Native_String.toFloat;
var _elm_lang$core$String$toInt = _elm_lang$core$Native_String.toInt;
var _elm_lang$core$String$indices = _elm_lang$core$Native_String.indexes;
var _elm_lang$core$String$indexes = _elm_lang$core$Native_String.indexes;
var _elm_lang$core$String$endsWith = _elm_lang$core$Native_String.endsWith;
var _elm_lang$core$String$startsWith = _elm_lang$core$Native_String.startsWith;
var _elm_lang$core$String$contains = _elm_lang$core$Native_String.contains;
var _elm_lang$core$String$all = _elm_lang$core$Native_String.all;
var _elm_lang$core$String$any = _elm_lang$core$Native_String.any;
var _elm_lang$core$String$toLower = _elm_lang$core$Native_String.toLower;
var _elm_lang$core$String$toUpper = _elm_lang$core$Native_String.toUpper;
var _elm_lang$core$String$lines = _elm_lang$core$Native_String.lines;
var _elm_lang$core$String$words = _elm_lang$core$Native_String.words;
var _elm_lang$core$String$trimRight = _elm_lang$core$Native_String.trimRight;
var _elm_lang$core$String$trimLeft = _elm_lang$core$Native_String.trimLeft;
var _elm_lang$core$String$trim = _elm_lang$core$Native_String.trim;
var _elm_lang$core$String$padRight = _elm_lang$core$Native_String.padRight;
var _elm_lang$core$String$padLeft = _elm_lang$core$Native_String.padLeft;
var _elm_lang$core$String$pad = _elm_lang$core$Native_String.pad;
var _elm_lang$core$String$dropRight = _elm_lang$core$Native_String.dropRight;
var _elm_lang$core$String$dropLeft = _elm_lang$core$Native_String.dropLeft;
var _elm_lang$core$String$right = _elm_lang$core$Native_String.right;
var _elm_lang$core$String$left = _elm_lang$core$Native_String.left;
var _elm_lang$core$String$slice = _elm_lang$core$Native_String.slice;
var _elm_lang$core$String$repeat = _elm_lang$core$Native_String.repeat;
var _elm_lang$core$String$join = _elm_lang$core$Native_String.join;
var _elm_lang$core$String$split = _elm_lang$core$Native_String.split;
var _elm_lang$core$String$foldr = _elm_lang$core$Native_String.foldr;
var _elm_lang$core$String$foldl = _elm_lang$core$Native_String.foldl;
var _elm_lang$core$String$reverse = _elm_lang$core$Native_String.reverse;
var _elm_lang$core$String$filter = _elm_lang$core$Native_String.filter;
var _elm_lang$core$String$map = _elm_lang$core$Native_String.map;
var _elm_lang$core$String$length = _elm_lang$core$Native_String.length;
var _elm_lang$core$String$concat = _elm_lang$core$Native_String.concat;
var _elm_lang$core$String$append = _elm_lang$core$Native_String.append;
var _elm_lang$core$String$uncons = _elm_lang$core$Native_String.uncons;
var _elm_lang$core$String$cons = _elm_lang$core$Native_String.cons;
var _elm_lang$core$String$fromChar = function ($char) {
	return A2(_elm_lang$core$String$cons, $char, '');
};
var _elm_lang$core$String$isEmpty = _elm_lang$core$Native_String.isEmpty;

var _elm_lang$core$Tuple$mapSecond = F2(
	function (func, _p0) {
		var _p1 = _p0;
		return {
			ctor: '_Tuple2',
			_0: _p1._0,
			_1: func(_p1._1)
		};
	});
var _elm_lang$core$Tuple$mapFirst = F2(
	function (func, _p2) {
		var _p3 = _p2;
		return {
			ctor: '_Tuple2',
			_0: func(_p3._0),
			_1: _p3._1
		};
	});
var _elm_lang$core$Tuple$second = function (_p4) {
	var _p5 = _p4;
	return _p5._1;
};
var _elm_lang$core$Tuple$first = function (_p6) {
	var _p7 = _p6;
	return _p7._0;
};

//import //

var _elm_lang$core$Native_Platform = function() {


// PROGRAMS

function program(impl)
{
	return function(flagDecoder)
	{
		return function(object, moduleName)
		{
			object['worker'] = function worker(flags)
			{
				if (typeof flags !== 'undefined')
				{
					throw new Error(
						'The `' + moduleName + '` module does not need flags.\n'
						+ 'Call ' + moduleName + '.worker() with no arguments and you should be all set!'
					);
				}

				return initialize(
					impl.init,
					impl.update,
					impl.subscriptions,
					renderer
				);
			};
		};
	};
}

function programWithFlags(impl)
{
	return function(flagDecoder)
	{
		return function(object, moduleName)
		{
			object['worker'] = function worker(flags)
			{
				if (typeof flagDecoder === 'undefined')
				{
					throw new Error(
						'Are you trying to sneak a Never value into Elm? Trickster!\n'
						+ 'It looks like ' + moduleName + '.main is defined with `programWithFlags` but has type `Program Never`.\n'
						+ 'Use `program` instead if you do not want flags.'
					);
				}

				var result = A2(_elm_lang$core$Native_Json.run, flagDecoder, flags);
				if (result.ctor === 'Err')
				{
					throw new Error(
						moduleName + '.worker(...) was called with an unexpected argument.\n'
						+ 'I tried to convert it to an Elm value, but ran into this problem:\n\n'
						+ result._0
					);
				}

				return initialize(
					impl.init(result._0),
					impl.update,
					impl.subscriptions,
					renderer
				);
			};
		};
	};
}

function renderer(enqueue, _)
{
	return function(_) {};
}


// HTML TO PROGRAM

function htmlToProgram(vnode)
{
	var emptyBag = batch(_elm_lang$core$Native_List.Nil);
	var noChange = _elm_lang$core$Native_Utils.Tuple2(
		_elm_lang$core$Native_Utils.Tuple0,
		emptyBag
	);

	return _elm_lang$virtual_dom$VirtualDom$program({
		init: noChange,
		view: function(model) { return main; },
		update: F2(function(msg, model) { return noChange; }),
		subscriptions: function (model) { return emptyBag; }
	});
}


// INITIALIZE A PROGRAM

function initialize(init, update, subscriptions, renderer)
{
	// ambient state
	var managers = {};
	var updateView;

	// init and update state in main process
	var initApp = _elm_lang$core$Native_Scheduler.nativeBinding(function(callback) {
		var model = init._0;
		updateView = renderer(enqueue, model);
		var cmds = init._1;
		var subs = subscriptions(model);
		dispatchEffects(managers, cmds, subs);
		callback(_elm_lang$core$Native_Scheduler.succeed(model));
	});

	function onMessage(msg, model)
	{
		return _elm_lang$core$Native_Scheduler.nativeBinding(function(callback) {
			var results = A2(update, msg, model);
			model = results._0;
			updateView(model);
			var cmds = results._1;
			var subs = subscriptions(model);
			dispatchEffects(managers, cmds, subs);
			callback(_elm_lang$core$Native_Scheduler.succeed(model));
		});
	}

	var mainProcess = spawnLoop(initApp, onMessage);

	function enqueue(msg)
	{
		_elm_lang$core$Native_Scheduler.rawSend(mainProcess, msg);
	}

	var ports = setupEffects(managers, enqueue);

	return ports ? { ports: ports } : {};
}


// EFFECT MANAGERS

var effectManagers = {};

function setupEffects(managers, callback)
{
	var ports;

	// setup all necessary effect managers
	for (var key in effectManagers)
	{
		var manager = effectManagers[key];

		if (manager.isForeign)
		{
			ports = ports || {};
			ports[key] = manager.tag === 'cmd'
				? setupOutgoingPort(key)
				: setupIncomingPort(key, callback);
		}

		managers[key] = makeManager(manager, callback);
	}

	return ports;
}

function makeManager(info, callback)
{
	var router = {
		main: callback,
		self: undefined
	};

	var tag = info.tag;
	var onEffects = info.onEffects;
	var onSelfMsg = info.onSelfMsg;

	function onMessage(msg, state)
	{
		if (msg.ctor === 'self')
		{
			return A3(onSelfMsg, router, msg._0, state);
		}

		var fx = msg._0;
		switch (tag)
		{
			case 'cmd':
				return A3(onEffects, router, fx.cmds, state);

			case 'sub':
				return A3(onEffects, router, fx.subs, state);

			case 'fx':
				return A4(onEffects, router, fx.cmds, fx.subs, state);
		}
	}

	var process = spawnLoop(info.init, onMessage);
	router.self = process;
	return process;
}

function sendToApp(router, msg)
{
	return _elm_lang$core$Native_Scheduler.nativeBinding(function(callback)
	{
		router.main(msg);
		callback(_elm_lang$core$Native_Scheduler.succeed(_elm_lang$core$Native_Utils.Tuple0));
	});
}

function sendToSelf(router, msg)
{
	return A2(_elm_lang$core$Native_Scheduler.send, router.self, {
		ctor: 'self',
		_0: msg
	});
}


// HELPER for STATEFUL LOOPS

function spawnLoop(init, onMessage)
{
	var andThen = _elm_lang$core$Native_Scheduler.andThen;

	function loop(state)
	{
		var handleMsg = _elm_lang$core$Native_Scheduler.receive(function(msg) {
			return onMessage(msg, state);
		});
		return A2(andThen, loop, handleMsg);
	}

	var task = A2(andThen, loop, init);

	return _elm_lang$core$Native_Scheduler.rawSpawn(task);
}


// BAGS

function leaf(home)
{
	return function(value)
	{
		return {
			type: 'leaf',
			home: home,
			value: value
		};
	};
}

function batch(list)
{
	return {
		type: 'node',
		branches: list
	};
}

function map(tagger, bag)
{
	return {
		type: 'map',
		tagger: tagger,
		tree: bag
	}
}


// PIPE BAGS INTO EFFECT MANAGERS

function dispatchEffects(managers, cmdBag, subBag)
{
	var effectsDict = {};
	gatherEffects(true, cmdBag, effectsDict, null);
	gatherEffects(false, subBag, effectsDict, null);

	for (var home in managers)
	{
		var fx = home in effectsDict
			? effectsDict[home]
			: {
				cmds: _elm_lang$core$Native_List.Nil,
				subs: _elm_lang$core$Native_List.Nil
			};

		_elm_lang$core$Native_Scheduler.rawSend(managers[home], { ctor: 'fx', _0: fx });
	}
}

function gatherEffects(isCmd, bag, effectsDict, taggers)
{
	switch (bag.type)
	{
		case 'leaf':
			var home = bag.home;
			var effect = toEffect(isCmd, home, taggers, bag.value);
			effectsDict[home] = insert(isCmd, effect, effectsDict[home]);
			return;

		case 'node':
			var list = bag.branches;
			while (list.ctor !== '[]')
			{
				gatherEffects(isCmd, list._0, effectsDict, taggers);
				list = list._1;
			}
			return;

		case 'map':
			gatherEffects(isCmd, bag.tree, effectsDict, {
				tagger: bag.tagger,
				rest: taggers
			});
			return;
	}
}

function toEffect(isCmd, home, taggers, value)
{
	function applyTaggers(x)
	{
		var temp = taggers;
		while (temp)
		{
			x = temp.tagger(x);
			temp = temp.rest;
		}
		return x;
	}

	var map = isCmd
		? effectManagers[home].cmdMap
		: effectManagers[home].subMap;

	return A2(map, applyTaggers, value)
}

function insert(isCmd, newEffect, effects)
{
	effects = effects || {
		cmds: _elm_lang$core$Native_List.Nil,
		subs: _elm_lang$core$Native_List.Nil
	};
	if (isCmd)
	{
		effects.cmds = _elm_lang$core$Native_List.Cons(newEffect, effects.cmds);
		return effects;
	}
	effects.subs = _elm_lang$core$Native_List.Cons(newEffect, effects.subs);
	return effects;
}


// PORTS

function checkPortName(name)
{
	if (name in effectManagers)
	{
		throw new Error('There can only be one port named `' + name + '`, but your program has multiple.');
	}
}


// OUTGOING PORTS

function outgoingPort(name, converter)
{
	checkPortName(name);
	effectManagers[name] = {
		tag: 'cmd',
		cmdMap: outgoingPortMap,
		converter: converter,
		isForeign: true
	};
	return leaf(name);
}

var outgoingPortMap = F2(function cmdMap(tagger, value) {
	return value;
});

function setupOutgoingPort(name)
{
	var subs = [];
	var converter = effectManagers[name].converter;

	// CREATE MANAGER

	var init = _elm_lang$core$Native_Scheduler.succeed(null);

	function onEffects(router, cmdList, state)
	{
		while (cmdList.ctor !== '[]')
		{
			// grab a separate reference to subs in case unsubscribe is called
			var currentSubs = subs;
			var value = converter(cmdList._0);
			for (var i = 0; i < currentSubs.length; i++)
			{
				currentSubs[i](value);
			}
			cmdList = cmdList._1;
		}
		return init;
	}

	effectManagers[name].init = init;
	effectManagers[name].onEffects = F3(onEffects);

	// PUBLIC API

	function subscribe(callback)
	{
		subs.push(callback);
	}

	function unsubscribe(callback)
	{
		// copy subs into a new array in case unsubscribe is called within a
		// subscribed callback
		subs = subs.slice();
		var index = subs.indexOf(callback);
		if (index >= 0)
		{
			subs.splice(index, 1);
		}
	}

	return {
		subscribe: subscribe,
		unsubscribe: unsubscribe
	};
}


// INCOMING PORTS

function incomingPort(name, converter)
{
	checkPortName(name);
	effectManagers[name] = {
		tag: 'sub',
		subMap: incomingPortMap,
		converter: converter,
		isForeign: true
	};
	return leaf(name);
}

var incomingPortMap = F2(function subMap(tagger, finalTagger)
{
	return function(value)
	{
		return tagger(finalTagger(value));
	};
});

function setupIncomingPort(name, callback)
{
	var sentBeforeInit = [];
	var subs = _elm_lang$core$Native_List.Nil;
	var converter = effectManagers[name].converter;
	var currentOnEffects = preInitOnEffects;
	var currentSend = preInitSend;

	// CREATE MANAGER

	var init = _elm_lang$core$Native_Scheduler.succeed(null);

	function preInitOnEffects(router, subList, state)
	{
		var postInitResult = postInitOnEffects(router, subList, state);

		for(var i = 0; i < sentBeforeInit.length; i++)
		{
			postInitSend(sentBeforeInit[i]);
		}

		sentBeforeInit = null; // to release objects held in queue
		currentSend = postInitSend;
		currentOnEffects = postInitOnEffects;
		return postInitResult;
	}

	function postInitOnEffects(router, subList, state)
	{
		subs = subList;
		return init;
	}

	function onEffects(router, subList, state)
	{
		return currentOnEffects(router, subList, state);
	}

	effectManagers[name].init = init;
	effectManagers[name].onEffects = F3(onEffects);

	// PUBLIC API

	function preInitSend(value)
	{
		sentBeforeInit.push(value);
	}

	function postInitSend(value)
	{
		var temp = subs;
		while (temp.ctor !== '[]')
		{
			callback(temp._0(value));
			temp = temp._1;
		}
	}

	function send(incomingValue)
	{
		var result = A2(_elm_lang$core$Json_Decode$decodeValue, converter, incomingValue);
		if (result.ctor === 'Err')
		{
			throw new Error('Trying to send an unexpected type of value through port `' + name + '`:\n' + result._0);
		}

		currentSend(result._0);
	}

	return { send: send };
}

return {
	// routers
	sendToApp: F2(sendToApp),
	sendToSelf: F2(sendToSelf),

	// global setup
	effectManagers: effectManagers,
	outgoingPort: outgoingPort,
	incomingPort: incomingPort,

	htmlToProgram: htmlToProgram,
	program: program,
	programWithFlags: programWithFlags,
	initialize: initialize,

	// effect bags
	leaf: leaf,
	batch: batch,
	map: F2(map)
};

}();

//import Native.Utils //

var _elm_lang$core$Native_Scheduler = function() {

var MAX_STEPS = 10000;


// TASKS

function succeed(value)
{
	return {
		ctor: '_Task_succeed',
		value: value
	};
}

function fail(error)
{
	return {
		ctor: '_Task_fail',
		value: error
	};
}

function nativeBinding(callback)
{
	return {
		ctor: '_Task_nativeBinding',
		callback: callback,
		cancel: null
	};
}

function andThen(callback, task)
{
	return {
		ctor: '_Task_andThen',
		callback: callback,
		task: task
	};
}

function onError(callback, task)
{
	return {
		ctor: '_Task_onError',
		callback: callback,
		task: task
	};
}

function receive(callback)
{
	return {
		ctor: '_Task_receive',
		callback: callback
	};
}


// PROCESSES

function rawSpawn(task)
{
	var process = {
		ctor: '_Process',
		id: _elm_lang$core$Native_Utils.guid(),
		root: task,
		stack: null,
		mailbox: []
	};

	enqueue(process);

	return process;
}

function spawn(task)
{
	return nativeBinding(function(callback) {
		var process = rawSpawn(task);
		callback(succeed(process));
	});
}

function rawSend(process, msg)
{
	process.mailbox.push(msg);
	enqueue(process);
}

function send(process, msg)
{
	return nativeBinding(function(callback) {
		rawSend(process, msg);
		callback(succeed(_elm_lang$core$Native_Utils.Tuple0));
	});
}

function kill(process)
{
	return nativeBinding(function(callback) {
		var root = process.root;
		if (root.ctor === '_Task_nativeBinding' && root.cancel)
		{
			root.cancel();
		}

		process.root = null;

		callback(succeed(_elm_lang$core$Native_Utils.Tuple0));
	});
}

function sleep(time)
{
	return nativeBinding(function(callback) {
		var id = setTimeout(function() {
			callback(succeed(_elm_lang$core$Native_Utils.Tuple0));
		}, time);

		return function() { clearTimeout(id); };
	});
}


// STEP PROCESSES

function step(numSteps, process)
{
	while (numSteps < MAX_STEPS)
	{
		var ctor = process.root.ctor;

		if (ctor === '_Task_succeed')
		{
			while (process.stack && process.stack.ctor === '_Task_onError')
			{
				process.stack = process.stack.rest;
			}
			if (process.stack === null)
			{
				break;
			}
			process.root = process.stack.callback(process.root.value);
			process.stack = process.stack.rest;
			++numSteps;
			continue;
		}

		if (ctor === '_Task_fail')
		{
			while (process.stack && process.stack.ctor === '_Task_andThen')
			{
				process.stack = process.stack.rest;
			}
			if (process.stack === null)
			{
				break;
			}
			process.root = process.stack.callback(process.root.value);
			process.stack = process.stack.rest;
			++numSteps;
			continue;
		}

		if (ctor === '_Task_andThen')
		{
			process.stack = {
				ctor: '_Task_andThen',
				callback: process.root.callback,
				rest: process.stack
			};
			process.root = process.root.task;
			++numSteps;
			continue;
		}

		if (ctor === '_Task_onError')
		{
			process.stack = {
				ctor: '_Task_onError',
				callback: process.root.callback,
				rest: process.stack
			};
			process.root = process.root.task;
			++numSteps;
			continue;
		}

		if (ctor === '_Task_nativeBinding')
		{
			process.root.cancel = process.root.callback(function(newRoot) {
				process.root = newRoot;
				enqueue(process);
			});

			break;
		}

		if (ctor === '_Task_receive')
		{
			var mailbox = process.mailbox;
			if (mailbox.length === 0)
			{
				break;
			}

			process.root = process.root.callback(mailbox.shift());
			++numSteps;
			continue;
		}

		throw new Error(ctor);
	}

	if (numSteps < MAX_STEPS)
	{
		return numSteps + 1;
	}
	enqueue(process);

	return numSteps;
}


// WORK QUEUE

var working = false;
var workQueue = [];

function enqueue(process)
{
	workQueue.push(process);

	if (!working)
	{
		setTimeout(work, 0);
		working = true;
	}
}

function work()
{
	var numSteps = 0;
	var process;
	while (numSteps < MAX_STEPS && (process = workQueue.shift()))
	{
		if (process.root)
		{
			numSteps = step(numSteps, process);
		}
	}
	if (!process)
	{
		working = false;
		return;
	}
	setTimeout(work, 0);
}


return {
	succeed: succeed,
	fail: fail,
	nativeBinding: nativeBinding,
	andThen: F2(andThen),
	onError: F2(onError),
	receive: receive,

	spawn: spawn,
	kill: kill,
	sleep: sleep,
	send: F2(send),

	rawSpawn: rawSpawn,
	rawSend: rawSend
};

}();
var _elm_lang$core$Platform_Cmd$batch = _elm_lang$core$Native_Platform.batch;
var _elm_lang$core$Platform_Cmd$none = _elm_lang$core$Platform_Cmd$batch(
	{ctor: '[]'});
var _elm_lang$core$Platform_Cmd_ops = _elm_lang$core$Platform_Cmd_ops || {};
_elm_lang$core$Platform_Cmd_ops['!'] = F2(
	function (model, commands) {
		return {
			ctor: '_Tuple2',
			_0: model,
			_1: _elm_lang$core$Platform_Cmd$batch(commands)
		};
	});
var _elm_lang$core$Platform_Cmd$map = _elm_lang$core$Native_Platform.map;
var _elm_lang$core$Platform_Cmd$Cmd = {ctor: 'Cmd'};

var _elm_lang$core$Platform_Sub$batch = _elm_lang$core$Native_Platform.batch;
var _elm_lang$core$Platform_Sub$none = _elm_lang$core$Platform_Sub$batch(
	{ctor: '[]'});
var _elm_lang$core$Platform_Sub$map = _elm_lang$core$Native_Platform.map;
var _elm_lang$core$Platform_Sub$Sub = {ctor: 'Sub'};

var _elm_lang$core$Platform$hack = _elm_lang$core$Native_Scheduler.succeed;
var _elm_lang$core$Platform$sendToSelf = _elm_lang$core$Native_Platform.sendToSelf;
var _elm_lang$core$Platform$sendToApp = _elm_lang$core$Native_Platform.sendToApp;
var _elm_lang$core$Platform$programWithFlags = _elm_lang$core$Native_Platform.programWithFlags;
var _elm_lang$core$Platform$program = _elm_lang$core$Native_Platform.program;
var _elm_lang$core$Platform$Program = {ctor: 'Program'};
var _elm_lang$core$Platform$Task = {ctor: 'Task'};
var _elm_lang$core$Platform$ProcessId = {ctor: 'ProcessId'};
var _elm_lang$core$Platform$Router = {ctor: 'Router'};

var _Skinney$elm_array_exploration$Array_JsArray$appendN = _Skinney$elm_array_exploration$Native_JsArray.appendN;
var _Skinney$elm_array_exploration$Array_JsArray$slice = _Skinney$elm_array_exploration$Native_JsArray.slice;
var _Skinney$elm_array_exploration$Array_JsArray$indexedMap = _Skinney$elm_array_exploration$Native_JsArray.indexedMap;
var _Skinney$elm_array_exploration$Array_JsArray$map = _Skinney$elm_array_exploration$Native_JsArray.map;
var _Skinney$elm_array_exploration$Array_JsArray$foldr = _Skinney$elm_array_exploration$Native_JsArray.foldr;
var _Skinney$elm_array_exploration$Array_JsArray$foldl = _Skinney$elm_array_exploration$Native_JsArray.foldl;
var _Skinney$elm_array_exploration$Array_JsArray$push = _Skinney$elm_array_exploration$Native_JsArray.push;
var _Skinney$elm_array_exploration$Array_JsArray$unsafeSet = _Skinney$elm_array_exploration$Native_JsArray.unsafeSet;
var _Skinney$elm_array_exploration$Array_JsArray$unsafeGet = _Skinney$elm_array_exploration$Native_JsArray.unsafeGet;
var _Skinney$elm_array_exploration$Array_JsArray$initializeFromList = _Skinney$elm_array_exploration$Native_JsArray.initializeFromList;
var _Skinney$elm_array_exploration$Array_JsArray$initialize = _Skinney$elm_array_exploration$Native_JsArray.initialize;
var _Skinney$elm_array_exploration$Array_JsArray$length = _Skinney$elm_array_exploration$Native_JsArray.length;
var _Skinney$elm_array_exploration$Array_JsArray$singleton = _Skinney$elm_array_exploration$Native_JsArray.singleton;
var _Skinney$elm_array_exploration$Array_JsArray$empty = _Skinney$elm_array_exploration$Native_JsArray.empty;
var _Skinney$elm_array_exploration$Array_JsArray$JsArray = function (a) {
	return {ctor: 'JsArray', _0: a};
};

var _Skinney$elm_array_exploration$Array_Hamt$emptyBuilder = {
	tail: _Skinney$elm_array_exploration$Array_JsArray$empty,
	nodeList: {ctor: '[]'},
	nodeListSize: 0
};
var _Skinney$elm_array_exploration$Array_Hamt$translateIndex = F2(
	function (idx, _p0) {
		var _p1 = _p0;
		var _p2 = _p1._0;
		var posIndex = (_elm_lang$core$Native_Utils.cmp(idx, 0) < 0) ? (_p2 + idx) : idx;
		return (_elm_lang$core$Native_Utils.cmp(posIndex, 0) < 0) ? 0 : ((_elm_lang$core$Native_Utils.cmp(posIndex, _p2) > 0) ? _p2 : posIndex);
	});
var _Skinney$elm_array_exploration$Array_Hamt$foldl = F3(
	function (f, init, _p3) {
		var _p4 = _p3;
		var helper = F2(
			function (i, acc) {
				var _p5 = i;
				if (_p5.ctor === 'SubTree') {
					return A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, helper, acc, _p5._0);
				} else {
					return A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, f, acc, _p5._0);
				}
			});
		var acc = A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, helper, init, _p4._2);
		return A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, f, acc, _p4._3);
	});
var _Skinney$elm_array_exploration$Array_Hamt$foldr = F3(
	function (f, init, _p6) {
		var _p7 = _p6;
		var acc = A3(_Skinney$elm_array_exploration$Array_JsArray$foldr, f, init, _p7._3);
		var helper = F2(
			function (i, acc) {
				var _p8 = i;
				if (_p8.ctor === 'SubTree') {
					return A3(_Skinney$elm_array_exploration$Array_JsArray$foldr, helper, acc, _p8._0);
				} else {
					return A3(_Skinney$elm_array_exploration$Array_JsArray$foldr, f, acc, _p8._0);
				}
			});
		return A3(_Skinney$elm_array_exploration$Array_JsArray$foldr, helper, acc, _p7._2);
	});
var _Skinney$elm_array_exploration$Array_Hamt$toIndexedList = function (_p9) {
	var _p10 = _p9;
	var helper = F2(
		function (n, _p11) {
			var _p12 = _p11;
			var _p13 = _p12._0;
			return {
				ctor: '_Tuple2',
				_0: _p13 - 1,
				_1: {
					ctor: '::',
					_0: {ctor: '_Tuple2', _0: _p13, _1: n},
					_1: _p12._1
				}
			};
		});
	return _elm_lang$core$Tuple$second(
		_Skinney$elm_array_exploration$Array_Hamt$foldr.func(helper, {
            ctor: '_Tuple2',
            _0: _p10._0 - 1,
            _1: {ctor: '[]'}
        }, _p10));
};
var _Skinney$elm_array_exploration$Array_Hamt$toList = function (arr) {
	return _Skinney$elm_array_exploration$Array_Hamt$foldr.func(F2(
        function (x, y) {
            return {ctor: '::', _0: x, _1: y};
        }), {ctor: '[]'}, arr);
};
var _Skinney$elm_array_exploration$Array_Hamt$tailIndex = function (len) {
	return (len >>> 5) << 5;
};
var _Skinney$elm_array_exploration$Array_Hamt$length = function (_p14) {
	var _p15 = _p14;
	return _p15._0;
};
var _Skinney$elm_array_exploration$Array_Hamt$isEmpty = function (_p16) {
	var _p17 = _p16;
	return _elm_lang$core$Native_Utils.eq(_p17._0, 0);
};
var _Skinney$elm_array_exploration$Array_Hamt$branchFactor = 32;
var _Skinney$elm_array_exploration$Array_Hamt$shiftStep = _elm_lang$core$Basics$ceiling(
	_elm_lang$core$Basics$logBase.func(
        2,
        _elm_lang$core$Basics$toFloat(_Skinney$elm_array_exploration$Array_Hamt$branchFactor)
    ));
var _Skinney$elm_array_exploration$Array_Hamt$bitMask = 4294967295 >>> (32 - _Skinney$elm_array_exploration$Array_Hamt$shiftStep);
var _Skinney$elm_array_exploration$Array_Hamt$getHelp = F3(
	function (shift, idx, tree) {
		getHelp:
		while (true) {
			var pos = _Skinney$elm_array_exploration$Array_Hamt$bitMask & (idx >>> shift);
			var _p18 = A2(_Skinney$elm_array_exploration$Array_JsArray$unsafeGet, pos, tree);
			if (_p18.ctor === 'SubTree') {
				var _v10 = shift - _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
					_v11 = idx,
					_v12 = _p18._0;
				shift = _v10;
				idx = _v11;
				tree = _v12;
				continue getHelp;
			} else {
				return A2(_Skinney$elm_array_exploration$Array_JsArray$unsafeGet, _Skinney$elm_array_exploration$Array_Hamt$bitMask & idx, _p18._0);
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$get = F2(
	function (idx, _p19) {
		var _p20 = _p19;
		var _p21 = _p20._0;
		return ((_elm_lang$core$Native_Utils.cmp(idx, 0) < 0) || (_elm_lang$core$Native_Utils.cmp(idx, _p21) > -1)) ? _elm_lang$core$Maybe$Nothing : ((_elm_lang$core$Native_Utils.cmp(
			idx,
			_Skinney$elm_array_exploration$Array_Hamt$tailIndex(_p21)) > -1) ? _elm_lang$core$Maybe$Just(
			A2(_Skinney$elm_array_exploration$Array_JsArray$unsafeGet, _Skinney$elm_array_exploration$Array_Hamt$bitMask & idx, _p20._3)) : _elm_lang$core$Maybe$Just(
			_Skinney$elm_array_exploration$Array_Hamt$getHelp.func(_p20._1, idx, _p20._2)));
	});
var _Skinney$elm_array_exploration$Array_Hamt$fetchNewTail = F4(
	function (shift, end, treeEnd, tree) {
		fetchNewTail:
		while (true) {
			var pos = _Skinney$elm_array_exploration$Array_Hamt$bitMask & (treeEnd >>> shift);
			var _p22 = A2(_Skinney$elm_array_exploration$Array_JsArray$unsafeGet, pos, tree);
			if (_p22.ctor === 'SubTree') {
				var _v15 = shift - _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
					_v16 = end,
					_v17 = treeEnd,
					_v18 = _p22._0;
				shift = _v15;
				end = _v16;
				treeEnd = _v17;
				tree = _v18;
				continue fetchNewTail;
			} else {
				return A3(_Skinney$elm_array_exploration$Array_JsArray$slice, 0, _Skinney$elm_array_exploration$Array_Hamt$bitMask & end, _p22._0);
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$hoistTree = F3(
	function (oldShift, newShift, tree) {
		hoistTree:
		while (true) {
			if ((_elm_lang$core$Native_Utils.cmp(oldShift, newShift) < 1) || _elm_lang$core$Native_Utils.eq(
				_Skinney$elm_array_exploration$Array_JsArray$length(tree),
				0)) {
				return tree;
			} else {
				var _p23 = A2(_Skinney$elm_array_exploration$Array_JsArray$unsafeGet, 0, tree);
				if (_p23.ctor === 'SubTree') {
					var _v20 = oldShift - _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
						_v21 = newShift,
						_v22 = _p23._0;
					oldShift = _v20;
					newShift = _v21;
					tree = _v22;
					continue hoistTree;
				} else {
					return tree;
				}
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$builderFromArray = function (_p24) {
	var _p25 = _p24;
	var helper = F2(
		function (node, acc) {
			var _p26 = node;
			if (_p26.ctor === 'SubTree') {
				return A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, helper, acc, _p26._0);
			} else {
				return {ctor: '::', _0: node, _1: acc};
			}
		});
	return {
		tail: _p25._3,
		nodeList: A3(
			_Skinney$elm_array_exploration$Array_JsArray$foldl,
			helper,
			{ctor: '[]'},
			_p25._2),
		nodeListSize: (_p25._0 / _Skinney$elm_array_exploration$Array_Hamt$branchFactor) | 0
	};
};
var _Skinney$elm_array_exploration$Array_Hamt$Builder = F3(
	function (a, b, c) {
		return {tail: a, nodeList: b, nodeListSize: c};
	});
var _Skinney$elm_array_exploration$Array_Hamt$Array = F4(
	function (a, b, c, d) {
		return {ctor: 'Array', _0: a, _1: b, _2: c, _3: d};
	});
var _Skinney$elm_array_exploration$Array_Hamt$empty = _Skinney$elm_array_exploration$Array_Hamt$Array.func(
    0,
    _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
    _Skinney$elm_array_exploration$Array_JsArray$empty,
    _Skinney$elm_array_exploration$Array_JsArray$empty
);
var _Skinney$elm_array_exploration$Array_Hamt$Leaf = function (a) {
	return {ctor: 'Leaf', _0: a};
};
var _Skinney$elm_array_exploration$Array_Hamt$appendHelpBuilder = F2(
	function (tail, builder) {
		var tailLen = _Skinney$elm_array_exploration$Array_JsArray$length(tail);
		var notAppended = (_Skinney$elm_array_exploration$Array_Hamt$branchFactor - _Skinney$elm_array_exploration$Array_JsArray$length(builder.tail)) - tailLen;
		var appended = A3(_Skinney$elm_array_exploration$Array_JsArray$appendN, _Skinney$elm_array_exploration$Array_Hamt$branchFactor, builder.tail, tail);
		return (_elm_lang$core$Native_Utils.cmp(notAppended, 0) < 0) ? {
			tail: A3(_Skinney$elm_array_exploration$Array_JsArray$slice, notAppended, tailLen, tail),
			nodeList: {
				ctor: '::',
				_0: _Skinney$elm_array_exploration$Array_Hamt$Leaf(appended),
				_1: builder.nodeList
			},
			nodeListSize: builder.nodeListSize + 1
		} : (_elm_lang$core$Native_Utils.eq(notAppended, 0) ? {
			tail: _Skinney$elm_array_exploration$Array_JsArray$empty,
			nodeList: {
				ctor: '::',
				_0: _Skinney$elm_array_exploration$Array_Hamt$Leaf(appended),
				_1: builder.nodeList
			},
			nodeListSize: builder.nodeListSize + 1
		} : {tail: appended, nodeList: builder.nodeList, nodeListSize: builder.nodeListSize});
	});
var _Skinney$elm_array_exploration$Array_Hamt$SubTree = function (a) {
	return {ctor: 'SubTree', _0: a};
};
var _Skinney$elm_array_exploration$Array_Hamt$setHelp = F4(
	function (shift, idx, val, tree) {
		var pos = _Skinney$elm_array_exploration$Array_Hamt$bitMask & (idx >>> shift);
		var _p27 = A2(_Skinney$elm_array_exploration$Array_JsArray$unsafeGet, pos, tree);
		if (_p27.ctor === 'SubTree') {
			var newSub = _Skinney$elm_array_exploration$Array_Hamt$setHelp.func(
                shift - _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
                idx,
                val,
                _p27._0
            );
			return A3(
				_Skinney$elm_array_exploration$Array_JsArray$unsafeSet,
				pos,
				_Skinney$elm_array_exploration$Array_Hamt$SubTree(newSub),
				tree);
		} else {
			var newLeaf = A3(_Skinney$elm_array_exploration$Array_JsArray$unsafeSet, _Skinney$elm_array_exploration$Array_Hamt$bitMask & idx, val, _p27._0);
			return A3(
				_Skinney$elm_array_exploration$Array_JsArray$unsafeSet,
				pos,
				_Skinney$elm_array_exploration$Array_Hamt$Leaf(newLeaf),
				tree);
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$set = F3(
	function (idx, val, _p28) {
		var _p29 = _p28;
		var _p33 = _p29._2;
		var _p32 = _p29._3;
		var _p31 = _p29._1;
		var _p30 = _p29._0;
		return ((_elm_lang$core$Native_Utils.cmp(idx, 0) < 0) || (_elm_lang$core$Native_Utils.cmp(idx, _p30) > -1)) ? _p29 : ((_elm_lang$core$Native_Utils.cmp(
			idx,
			_Skinney$elm_array_exploration$Array_Hamt$tailIndex(_p30)) > -1) ? _Skinney$elm_array_exploration$Array_Hamt$Array.func(
            _p30,
            _p31,
            _p33,
            A3(_Skinney$elm_array_exploration$Array_JsArray$unsafeSet, _Skinney$elm_array_exploration$Array_Hamt$bitMask & idx, val, _p32)
        ) : _Skinney$elm_array_exploration$Array_Hamt$Array.func(
            _p30,
            _p31,
            _Skinney$elm_array_exploration$Array_Hamt$setHelp.func(_p31, idx, val, _p33),
            _p32
        ));
	});
var _Skinney$elm_array_exploration$Array_Hamt$insertTailInTree = F4(
	function (shift, idx, tail, tree) {
		var pos = _Skinney$elm_array_exploration$Array_Hamt$bitMask & (idx >>> shift);
		if (_elm_lang$core$Native_Utils.cmp(
			pos,
			_Skinney$elm_array_exploration$Array_JsArray$length(tree)) > -1) {
			if (_elm_lang$core$Native_Utils.eq(shift, 5)) {
				return A2(
					_Skinney$elm_array_exploration$Array_JsArray$push,
					_Skinney$elm_array_exploration$Array_Hamt$Leaf(tail),
					tree);
			} else {
				var newSub = _Skinney$elm_array_exploration$Array_Hamt$SubTree(
					_Skinney$elm_array_exploration$Array_Hamt$insertTailInTree.func(
                        shift - _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
                        idx,
                        tail,
                        _Skinney$elm_array_exploration$Array_JsArray$empty
                    ));
				return A2(_Skinney$elm_array_exploration$Array_JsArray$push, newSub, tree);
			}
		} else {
			var val = A2(_Skinney$elm_array_exploration$Array_JsArray$unsafeGet, pos, tree);
			var _p34 = val;
			if (_p34.ctor === 'SubTree') {
				var newSub = _Skinney$elm_array_exploration$Array_Hamt$SubTree(
					_Skinney$elm_array_exploration$Array_Hamt$insertTailInTree.func(
                        shift - _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
                        idx,
                        tail,
                        _p34._0
                    ));
				return A3(_Skinney$elm_array_exploration$Array_JsArray$unsafeSet, pos, newSub, tree);
			} else {
				var newSub = _Skinney$elm_array_exploration$Array_Hamt$SubTree(
					_Skinney$elm_array_exploration$Array_Hamt$insertTailInTree.func(
                        shift - _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
                        idx,
                        tail,
                        _Skinney$elm_array_exploration$Array_JsArray$singleton(val)
                    ));
				return A3(_Skinney$elm_array_exploration$Array_JsArray$unsafeSet, pos, newSub, tree);
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$unsafeReplaceTail = F2(
	function (newTail, _p35) {
		var _p36 = _p35;
		var _p39 = _p36._2;
		var _p38 = _p36._1;
		var _p37 = _p36._0;
		var newTailLen = _Skinney$elm_array_exploration$Array_JsArray$length(newTail);
		var originalTailLen = _Skinney$elm_array_exploration$Array_JsArray$length(_p36._3);
		var newArrayLen = _p37 + (newTailLen - originalTailLen);
		if (_elm_lang$core$Native_Utils.eq(newTailLen, _Skinney$elm_array_exploration$Array_Hamt$branchFactor)) {
			var overflow = _elm_lang$core$Native_Utils.cmp(newArrayLen >>> _Skinney$elm_array_exploration$Array_Hamt$shiftStep, 1 << _p38) > 0;
			if (overflow) {
				var newShift = _p38 + _Skinney$elm_array_exploration$Array_Hamt$shiftStep;
				var newTree = _Skinney$elm_array_exploration$Array_Hamt$insertTailInTree.func(
                    newShift,
                    _p37,
                    newTail,
                    _Skinney$elm_array_exploration$Array_JsArray$singleton(
						_Skinney$elm_array_exploration$Array_Hamt$SubTree(_p39))
                );
				return _Skinney$elm_array_exploration$Array_Hamt$Array.func(
                    newArrayLen,
                    newShift,
                    newTree,
                    _Skinney$elm_array_exploration$Array_JsArray$empty
                );
			} else {
				return _Skinney$elm_array_exploration$Array_Hamt$Array.func(
                    newArrayLen,
                    _p38,
                    _Skinney$elm_array_exploration$Array_Hamt$insertTailInTree.func(_p38, _p37, newTail, _p39),
                    _Skinney$elm_array_exploration$Array_JsArray$empty
                );
			}
		} else {
			return _Skinney$elm_array_exploration$Array_Hamt$Array.func(newArrayLen, _p38, _p39, newTail);
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$push = F2(
	function (a, _p40) {
		var _p41 = _p40;
		return _Skinney$elm_array_exploration$Array_Hamt$unsafeReplaceTail.func(A2(_Skinney$elm_array_exploration$Array_JsArray$push, a, _p41._3), _p41);
	});
var _Skinney$elm_array_exploration$Array_Hamt$appendHelpTree = F2(
	function (toAppend, _p42) {
		var _p43 = _p42;
		var _p44 = _p43._3;
		var itemsToAppend = _Skinney$elm_array_exploration$Array_JsArray$length(toAppend);
		var notAppended = (_Skinney$elm_array_exploration$Array_Hamt$branchFactor - _Skinney$elm_array_exploration$Array_JsArray$length(_p44)) - itemsToAppend;
		var appended = A3(_Skinney$elm_array_exploration$Array_JsArray$appendN, _Skinney$elm_array_exploration$Array_Hamt$branchFactor, _p44, toAppend);
		var newArray = _Skinney$elm_array_exploration$Array_Hamt$unsafeReplaceTail.func(appended, _p43);
		if (_elm_lang$core$Native_Utils.cmp(notAppended, 0) < 0) {
			var nextTail = A3(_Skinney$elm_array_exploration$Array_JsArray$slice, notAppended, itemsToAppend, toAppend);
			return _Skinney$elm_array_exploration$Array_Hamt$unsafeReplaceTail.func(nextTail, newArray);
		} else {
			return newArray;
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$map = F2(
	function (f, _p45) {
		var _p46 = _p45;
		var helper = function (i) {
			var _p47 = i;
			if (_p47.ctor === 'SubTree') {
				return _Skinney$elm_array_exploration$Array_Hamt$SubTree(
					A2(_Skinney$elm_array_exploration$Array_JsArray$map, helper, _p47._0));
			} else {
				return _Skinney$elm_array_exploration$Array_Hamt$Leaf(
					A2(_Skinney$elm_array_exploration$Array_JsArray$map, f, _p47._0));
			}
		};
		return _Skinney$elm_array_exploration$Array_Hamt$Array.func(
            _p46._0,
            _p46._1,
            A2(_Skinney$elm_array_exploration$Array_JsArray$map, helper, _p46._2),
            A2(_Skinney$elm_array_exploration$Array_JsArray$map, f, _p46._3)
        );
	});
var _Skinney$elm_array_exploration$Array_Hamt$toString = function (array) {
	var content = A2(
		_elm_lang$core$String$join,
		',',
		_Skinney$elm_array_exploration$Array_Hamt$toList(
			_Skinney$elm_array_exploration$Array_Hamt$map.func(_elm_lang$core$Basics$toString, array)));
	return A2(
		_elm_lang$core$Basics_ops['++'],
		'Array [',
		A2(_elm_lang$core$Basics_ops['++'], content, ']'));
};
var _Skinney$elm_array_exploration$Array_Hamt$sliceTree = F3(
	function (shift, endIdx, tree) {
		var lastPos = _Skinney$elm_array_exploration$Array_Hamt$bitMask & (endIdx >>> shift);
		var _p48 = A2(_Skinney$elm_array_exploration$Array_JsArray$unsafeGet, lastPos, tree);
		if (_p48.ctor === 'SubTree') {
			var newSub = _Skinney$elm_array_exploration$Array_Hamt$sliceTree.func(
                shift - _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
                endIdx,
                _p48._0
            );
			return _elm_lang$core$Native_Utils.eq(
				_Skinney$elm_array_exploration$Array_JsArray$length(newSub),
				0) ? A3(_Skinney$elm_array_exploration$Array_JsArray$slice, 0, lastPos, tree) : A3(
				_Skinney$elm_array_exploration$Array_JsArray$unsafeSet,
				lastPos,
				_Skinney$elm_array_exploration$Array_Hamt$SubTree(newSub),
				A3(_Skinney$elm_array_exploration$Array_JsArray$slice, 0, lastPos + 1, tree));
		} else {
			return A3(_Skinney$elm_array_exploration$Array_JsArray$slice, 0, lastPos, tree);
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$sliceRight = F2(
	function (end, _p49) {
		var _p50 = _p49;
		var _p53 = _p50._2;
		var _p52 = _p50._1;
		var _p51 = _p50._0;
		if (_elm_lang$core$Native_Utils.eq(end, _p51)) {
			return _p50;
		} else {
			if (_elm_lang$core$Native_Utils.cmp(
				end,
				_Skinney$elm_array_exploration$Array_Hamt$tailIndex(_p51)) > -1) {
				return _Skinney$elm_array_exploration$Array_Hamt$Array.func(
                    end,
                    _p52,
                    _p53,
                    A3(_Skinney$elm_array_exploration$Array_JsArray$slice, 0, _Skinney$elm_array_exploration$Array_Hamt$bitMask & end, _p50._3)
                );
			} else {
				var endIdx = _Skinney$elm_array_exploration$Array_Hamt$tailIndex(end);
				var depth = _elm_lang$core$Basics$floor(
					_elm_lang$core$Basics$logBase.func(
                        _elm_lang$core$Basics$toFloat(_Skinney$elm_array_exploration$Array_Hamt$branchFactor),
                        _elm_lang$core$Basics$toFloat(
							_elm_lang$core$Basics$max.func(1, endIdx - 1))
                    ));
				var newShift = _elm_lang$core$Basics$max.func(5, depth * _Skinney$elm_array_exploration$Array_Hamt$shiftStep);
				return _Skinney$elm_array_exploration$Array_Hamt$Array.func(end, newShift, _Skinney$elm_array_exploration$Array_Hamt$hoistTree.func(
                    _p52,
                    newShift,
                    _Skinney$elm_array_exploration$Array_Hamt$sliceTree.func(_p52, endIdx, _p53)
                ), _Skinney$elm_array_exploration$Array_Hamt$fetchNewTail.func(_p52, end, endIdx, _p53));
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$compressNodes = F2(
	function (nodes, acc) {
		compressNodes:
		while (true) {
			var _p54 = A2(_Skinney$elm_array_exploration$Array_JsArray$initializeFromList, _Skinney$elm_array_exploration$Array_Hamt$branchFactor, nodes);
			var node = _p54._0;
			var remainingNodes = _p54._1;
			var newAcc = {
				ctor: '::',
				_0: _Skinney$elm_array_exploration$Array_Hamt$SubTree(node),
				_1: acc
			};
			var _p55 = remainingNodes;
			if (_p55.ctor === '[]') {
				return _elm_lang$core$List$reverse(newAcc);
			} else {
				var _v36 = remainingNodes,
					_v37 = newAcc;
				nodes = _v36;
				acc = _v37;
				continue compressNodes;
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$treeFromBuilder = F2(
	function (nodeList, nodeListSize) {
		treeFromBuilder:
		while (true) {
			var newNodeSize = _elm_lang$core$Basics$ceiling(
				_elm_lang$core$Basics$toFloat(nodeListSize) / _elm_lang$core$Basics$toFloat(_Skinney$elm_array_exploration$Array_Hamt$branchFactor));
			if (_elm_lang$core$Native_Utils.eq(newNodeSize, 1)) {
				return _elm_lang$core$Tuple$first(
					A2(_Skinney$elm_array_exploration$Array_JsArray$initializeFromList, _Skinney$elm_array_exploration$Array_Hamt$branchFactor, nodeList));
			} else {
				var _v38 = _Skinney$elm_array_exploration$Array_Hamt$compressNodes.func(nodeList, {ctor: '[]'}),
					_v39 = newNodeSize;
				nodeList = _v38;
				nodeListSize = _v39;
				continue treeFromBuilder;
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$builderToArray = F2(
	function (reverseNodeList, builder) {
		if (_elm_lang$core$Native_Utils.eq(builder.nodeListSize, 0)) {
			return _Skinney$elm_array_exploration$Array_Hamt$Array.func(
                _Skinney$elm_array_exploration$Array_JsArray$length(builder.tail),
                _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
                _Skinney$elm_array_exploration$Array_JsArray$empty,
                builder.tail
            );
		} else {
			var correctNodeList = reverseNodeList ? _elm_lang$core$List$reverse(builder.nodeList) : builder.nodeList;
			var tree = _Skinney$elm_array_exploration$Array_Hamt$treeFromBuilder.func(correctNodeList, builder.nodeListSize);
			var treeLen = builder.nodeListSize * _Skinney$elm_array_exploration$Array_Hamt$branchFactor;
			var depth = _elm_lang$core$Basics$floor(
				_elm_lang$core$Basics$logBase.func(
                    _elm_lang$core$Basics$toFloat(_Skinney$elm_array_exploration$Array_Hamt$branchFactor),
                    _elm_lang$core$Basics$toFloat(treeLen - 1)
                ));
			return _Skinney$elm_array_exploration$Array_Hamt$Array.func(
                _Skinney$elm_array_exploration$Array_JsArray$length(builder.tail) + treeLen,
                _elm_lang$core$Basics$max.func(5, depth * _Skinney$elm_array_exploration$Array_Hamt$shiftStep),
                tree,
                builder.tail
            );
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$initializeHelp = F5(
	function (fn, fromIndex, length, nodeList, tail) {
		initializeHelp:
		while (true) {
			if (_elm_lang$core$Native_Utils.cmp(fromIndex, 0) < 0) {
				return _Skinney$elm_array_exploration$Array_Hamt$builderToArray.func(
                    false,
                    {tail: tail, nodeList: nodeList, nodeListSize: (length / _Skinney$elm_array_exploration$Array_Hamt$branchFactor) | 0}
                );
			} else {
				var leaf = _Skinney$elm_array_exploration$Array_Hamt$Leaf(
					A3(_Skinney$elm_array_exploration$Array_JsArray$initialize, _Skinney$elm_array_exploration$Array_Hamt$branchFactor, fromIndex, fn));
				var _v40 = fn,
					_v41 = fromIndex - _Skinney$elm_array_exploration$Array_Hamt$branchFactor,
					_v42 = length,
					_v43 = {ctor: '::', _0: leaf, _1: nodeList},
					_v44 = tail;
				fn = _v40;
				fromIndex = _v41;
				length = _v42;
				nodeList = _v43;
				tail = _v44;
				continue initializeHelp;
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$initialize = F2(
	function (length, fn) {
		if (_elm_lang$core$Native_Utils.cmp(length, 0) < 1) {
			return _Skinney$elm_array_exploration$Array_Hamt$empty;
		} else {
			var tailLen = _elm_lang$core$Basics$rem.func(length, _Skinney$elm_array_exploration$Array_Hamt$branchFactor);
			var tail = A3(_Skinney$elm_array_exploration$Array_JsArray$initialize, tailLen, length - tailLen, fn);
			var initialFromIndex = (length - tailLen) - _Skinney$elm_array_exploration$Array_Hamt$branchFactor;
			return _Skinney$elm_array_exploration$Array_Hamt$initializeHelp.func(fn, initialFromIndex, length, {ctor: '[]'}, tail);
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$repeat = F2(
	function (n, e) {
		return _Skinney$elm_array_exploration$Array_Hamt$initialize.func(n, function (_p56) {
            return e;
        });
	});
var _Skinney$elm_array_exploration$Array_Hamt$fromListHelp = F3(
	function (list, nodeList, nodeListSize) {
		fromListHelp:
		while (true) {
			var _p57 = A2(_Skinney$elm_array_exploration$Array_JsArray$initializeFromList, _Skinney$elm_array_exploration$Array_Hamt$branchFactor, list);
			var jsArray = _p57._0;
			var remainingItems = _p57._1;
			if (_elm_lang$core$Native_Utils.cmp(
				_Skinney$elm_array_exploration$Array_JsArray$length(jsArray),
				_Skinney$elm_array_exploration$Array_Hamt$branchFactor) < 0) {
				return _Skinney$elm_array_exploration$Array_Hamt$builderToArray.func(true, {tail: jsArray, nodeList: nodeList, nodeListSize: nodeListSize});
			} else {
				var _v45 = remainingItems,
					_v46 = {
					ctor: '::',
					_0: _Skinney$elm_array_exploration$Array_Hamt$Leaf(jsArray),
					_1: nodeList
				},
					_v47 = nodeListSize + 1;
				list = _v45;
				nodeList = _v46;
				nodeListSize = _v47;
				continue fromListHelp;
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$fromList = function (ls) {
	var _p58 = ls;
	if (_p58.ctor === '[]') {
		return _Skinney$elm_array_exploration$Array_Hamt$empty;
	} else {
		return _Skinney$elm_array_exploration$Array_Hamt$fromListHelp.func(ls, {ctor: '[]'}, 0);
	}
};
var _Skinney$elm_array_exploration$Array_Hamt$filter = F2(
	function (f, arr) {
		var helper = F2(
			function (n, acc) {
				return f(n) ? {ctor: '::', _0: n, _1: acc} : acc;
			});
		return _Skinney$elm_array_exploration$Array_Hamt$fromList(
			_Skinney$elm_array_exploration$Array_Hamt$foldr.func(helper, {ctor: '[]'}, arr));
	});
var _Skinney$elm_array_exploration$Array_Hamt$indexedMap = F2(
	function (f, _p59) {
		var _p60 = _p59;
		var initialBuilder = {
			tail: A3(
				_Skinney$elm_array_exploration$Array_JsArray$indexedMap,
				f,
				_Skinney$elm_array_exploration$Array_Hamt$tailIndex(_p60._0),
				_p60._3),
			nodeList: {ctor: '[]'},
			nodeListSize: 0
		};
		var helper = F2(
			function (node, builder) {
				var _p61 = node;
				if (_p61.ctor === 'SubTree') {
					return A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, helper, builder, _p61._0);
				} else {
					var offset = builder.nodeListSize * _Skinney$elm_array_exploration$Array_Hamt$branchFactor;
					var mappedLeaf = _Skinney$elm_array_exploration$Array_Hamt$Leaf(
						A3(_Skinney$elm_array_exploration$Array_JsArray$indexedMap, f, offset, _p61._0));
					return {
						tail: builder.tail,
						nodeList: {ctor: '::', _0: mappedLeaf, _1: builder.nodeList},
						nodeListSize: builder.nodeListSize + 1
					};
				}
			});
		return _Skinney$elm_array_exploration$Array_Hamt$builderToArray.func(
            true,
            A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, helper, initialBuilder, _p60._2)
        );
	});
var _Skinney$elm_array_exploration$Array_Hamt$append = F2(
	function (_p63, _p62) {
		var _p64 = _p63;
		var _p70 = _p64;
		var _p65 = _p62;
		var _p69 = _p65._2;
		var _p68 = _p65._3;
		if (_elm_lang$core$Native_Utils.cmp(_p65._0, _Skinney$elm_array_exploration$Array_Hamt$branchFactor * 4) < 1) {
			var foldHelper = F2(
				function (node, arr) {
					var _p66 = node;
					if (_p66.ctor === 'SubTree') {
						return A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, foldHelper, arr, _p66._0);
					} else {
						return _Skinney$elm_array_exploration$Array_Hamt$appendHelpTree.func(_p66._0, arr);
					}
				});
			return _Skinney$elm_array_exploration$Array_Hamt$appendHelpTree.func(
                _p68,
                A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, foldHelper, _p70, _p69)
            );
		} else {
			var foldHelper = F2(
				function (node, builder) {
					var _p67 = node;
					if (_p67.ctor === 'SubTree') {
						return A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, foldHelper, builder, _p67._0);
					} else {
						return _Skinney$elm_array_exploration$Array_Hamt$appendHelpBuilder.func(_p67._0, builder);
					}
				});
			var builder = _Skinney$elm_array_exploration$Array_Hamt$builderFromArray(_p70);
			return _Skinney$elm_array_exploration$Array_Hamt$builderToArray.func(true, _Skinney$elm_array_exploration$Array_Hamt$appendHelpBuilder.func(
                _p68,
                A3(_Skinney$elm_array_exploration$Array_JsArray$foldl, foldHelper, builder, _p69)
            ));
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$sliceLeft = F2(
	function (from, _p71) {
		var _p72 = _p71;
		var _p77 = _p72._3;
		var _p76 = _p72._0;
		if (_elm_lang$core$Native_Utils.eq(from, 0)) {
			return _p72;
		} else {
			if (_elm_lang$core$Native_Utils.cmp(
				from,
				_Skinney$elm_array_exploration$Array_Hamt$tailIndex(_p76)) > -1) {
				return _Skinney$elm_array_exploration$Array_Hamt$Array.func(
                    _p76 - from,
                    _Skinney$elm_array_exploration$Array_Hamt$shiftStep,
                    _Skinney$elm_array_exploration$Array_JsArray$empty,
                    A3(
						_Skinney$elm_array_exploration$Array_JsArray$slice,
						from - _Skinney$elm_array_exploration$Array_Hamt$tailIndex(_p76),
						_Skinney$elm_array_exploration$Array_JsArray$length(_p77),
						_p77)
                );
			} else {
				var skipNodes = (from / _Skinney$elm_array_exploration$Array_Hamt$branchFactor) | 0;
				var helper = F2(
					function (node, acc) {
						var _p73 = node;
						if (_p73.ctor === 'SubTree') {
							return A3(_Skinney$elm_array_exploration$Array_JsArray$foldr, helper, acc, _p73._0);
						} else {
							return {ctor: '::', _0: _p73._0, _1: acc};
						}
					});
				var leafNodes = A3(
					_Skinney$elm_array_exploration$Array_JsArray$foldr,
					helper,
					{
						ctor: '::',
						_0: _p77,
						_1: {ctor: '[]'}
					},
					_p72._2);
				var nodesToInsert = _elm_lang$core$List$drop.func(skipNodes, leafNodes);
				var _p74 = nodesToInsert;
				if (_p74.ctor === '[]') {
					return _Skinney$elm_array_exploration$Array_Hamt$empty;
				} else {
					var _p75 = _p74._0;
					var firstSlice = from - (skipNodes * _Skinney$elm_array_exploration$Array_Hamt$branchFactor);
					var initialBuilder = {
						tail: A3(
							_Skinney$elm_array_exploration$Array_JsArray$slice,
							firstSlice,
							_Skinney$elm_array_exploration$Array_JsArray$length(_p75),
							_p75),
						nodeList: {ctor: '[]'},
						nodeListSize: 0
					};
					return _Skinney$elm_array_exploration$Array_Hamt$builderToArray.func(true, _elm_lang$core$List$foldl.func(
                        _Skinney$elm_array_exploration$Array_Hamt$appendHelpBuilder,
                        initialBuilder,
                        _p74._1
                    ));
				}
			}
		}
	});
var _Skinney$elm_array_exploration$Array_Hamt$slice = F3(
	function (from, to, arr) {
		var correctTo = _Skinney$elm_array_exploration$Array_Hamt$translateIndex.func(to, arr);
		var correctFrom = _Skinney$elm_array_exploration$Array_Hamt$translateIndex.func(from, arr);
		return (_elm_lang$core$Native_Utils.cmp(correctFrom, correctTo) > 0) ? _Skinney$elm_array_exploration$Array_Hamt$empty : _Skinney$elm_array_exploration$Array_Hamt$sliceLeft.func(
            correctFrom,
            _Skinney$elm_array_exploration$Array_Hamt$sliceRight.func(correctTo, arr)
        );
	});

var _Skinney$elm_dict_exploration$Dict_LLRB$isRed = function (dict) {
	var _p0 = dict;
	if ((_p0.ctor === 'Node') && (_p0._0.ctor === 'Red')) {
		return true;
	} else {
		return false;
	}
};
var _Skinney$elm_dict_exploration$Dict_LLRB$isBSTHelper = F2(
	function (acc, keys) {
		isBSTHelper:
		while (true) {
			var _p1 = keys;
			if (_p1.ctor === '[]') {
				return acc;
			} else {
				if (_p1._1.ctor === '[]') {
					return acc;
				} else {
					var _p2 = _p1._1._0;
					var _v2 = acc && (_elm_lang$core$Native_Utils.cmp(_p1._0, _p2) < 0),
						_v3 = {ctor: '::', _0: _p2, _1: _p1._1._1};
					acc = _v2;
					keys = _v3;
					continue isBSTHelper;
				}
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$splitSortedHelp = F3(
	function (sorted, _p3, list) {
		splitSortedHelp:
		while (true) {
			var _p4 = _p3;
			var _p6 = _p4;
			var _p5 = list;
			if (_p5.ctor === '::') {
				if (_elm_lang$core$Native_Utils.cmp(_p4._0, _p5._0._0) < 0) {
					var _v6 = {ctor: '::', _0: _p6, _1: sorted},
						_v7 = _p5._0,
						_v8 = _p5._1;
					sorted = _v6;
					_p3 = _v7;
					list = _v8;
					continue splitSortedHelp;
				} else {
					return {
						ctor: '_Tuple2',
						_0: sorted,
						_1: {ctor: '::', _0: _p6, _1: list}
					};
				}
			} else {
				return {
					ctor: '_Tuple2',
					_0: {ctor: '::', _0: _p6, _1: sorted},
					_1: {ctor: '[]'}
				};
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$getMaxKeyHelp = F2(
	function (maxKey, dict) {
		getMaxKeyHelp:
		while (true) {
			var _p7 = dict;
			if (_p7.ctor === 'Leaf') {
				return maxKey;
			} else {
				var _v10 = _p7._1,
					_v11 = _p7._4;
				maxKey = _v10;
				dict = _v11;
				continue getMaxKeyHelp;
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$getMinKeyHelp = F2(
	function (minKey, dict) {
		getMinKeyHelp:
		while (true) {
			var _p8 = dict;
			if (_p8.ctor === 'Leaf') {
				return minKey;
			} else {
				var _v13 = _p8._1,
					_v14 = _p8._3;
				minKey = _v13;
				dict = _v14;
				continue getMinKeyHelp;
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$getRange = function (dict) {
	var _p9 = dict;
	if (_p9.ctor === 'Leaf') {
		return _elm_lang$core$Maybe$Nothing;
	} else {
		var _p10 = _p9._1;
		return _elm_lang$core$Maybe$Just(
			{
				ctor: '_Tuple2',
				_0: _Skinney$elm_dict_exploration$Dict_LLRB$getMinKeyHelp.func(_p10, _p9._3),
				_1: _Skinney$elm_dict_exploration$Dict_LLRB$getMaxKeyHelp.func(_p10, _p9._4)
			});
	}
};
var _Skinney$elm_dict_exploration$Dict_LLRB$diffAccumulator = F3(
	function (lKey, lVal, _p11) {
		diffAccumulator:
		while (true) {
			var _p12 = _p11;
			var _p17 = _p12._0;
			var _p16 = _p12._1;
			var _p13 = _p16;
			if (_p13.ctor === '[]') {
				return {
					ctor: '_Tuple2',
					_0: {
						ctor: '::',
						_0: {ctor: '_Tuple2', _0: lKey, _1: lVal},
						_1: _p17
					},
					_1: {ctor: '[]'}
				};
			} else {
				var _p15 = _p13._1;
				var _p14 = _elm_lang$core$Basics$compare.func(lKey, _p13._0._0);
				switch (_p14.ctor) {
					case 'LT':
						return {
							ctor: '_Tuple2',
							_0: {
								ctor: '::',
								_0: {ctor: '_Tuple2', _0: lKey, _1: lVal},
								_1: _p17
							},
							_1: _p16
						};
					case 'GT':
						var _v19 = lKey,
							_v20 = lVal,
							_v21 = {ctor: '_Tuple2', _0: _p17, _1: _p15};
						lKey = _v19;
						lVal = _v20;
						_p11 = _v21;
						continue diffAccumulator;
					default:
						return {ctor: '_Tuple2', _0: _p17, _1: _p15};
				}
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$intersectAccumulator = F3(
	function (lKey, lVal, _p18) {
		intersectAccumulator:
		while (true) {
			var _p19 = _p18;
			var _p24 = _p19;
			var _p23 = _p19._0;
			var _p20 = _p19._1;
			if (_p20.ctor === '[]') {
				return _p24;
			} else {
				var _p22 = _p20._1;
				var _p21 = _elm_lang$core$Basics$compare.func(lKey, _p20._0._0);
				switch (_p21.ctor) {
					case 'LT':
						return _p24;
					case 'GT':
						var _v25 = lKey,
							_v26 = lVal,
							_v27 = {ctor: '_Tuple2', _0: _p23, _1: _p22};
						lKey = _v25;
						lVal = _v26;
						_p18 = _v27;
						continue intersectAccumulator;
					default:
						return {
							ctor: '_Tuple2',
							_0: {
								ctor: '::',
								_0: {ctor: '_Tuple2', _0: lKey, _1: lVal},
								_1: _p23
							},
							_1: _p22
						};
				}
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$unionAccumulator = F3(
	function (lKey, lVal, _p25) {
		unionAccumulator:
		while (true) {
			var _p26 = _p25;
			var _p32 = _p26._0;
			var _p31 = _p26._1;
			var _p27 = _p31;
			if (_p27.ctor === '[]') {
				return {
					ctor: '_Tuple2',
					_0: {
						ctor: '::',
						_0: {ctor: '_Tuple2', _0: lKey, _1: lVal},
						_1: _p32
					},
					_1: {ctor: '[]'}
				};
			} else {
				var _p30 = _p27._1;
				var _p29 = _p27._0._0;
				var _p28 = _elm_lang$core$Basics$compare.func(lKey, _p29);
				switch (_p28.ctor) {
					case 'LT':
						return {
							ctor: '_Tuple2',
							_0: {
								ctor: '::',
								_0: {ctor: '_Tuple2', _0: lKey, _1: lVal},
								_1: _p32
							},
							_1: _p31
						};
					case 'GT':
						var _v31 = lKey,
							_v32 = lVal,
							_v33 = {
							ctor: '_Tuple2',
							_0: {
								ctor: '::',
								_0: {ctor: '_Tuple2', _0: _p29, _1: _p27._0._1},
								_1: _p32
							},
							_1: _p30
						};
						lKey = _v31;
						lVal = _v32;
						_p25 = _v33;
						continue unionAccumulator;
					default:
						return {
							ctor: '_Tuple2',
							_0: {
								ctor: '::',
								_0: {ctor: '_Tuple2', _0: lKey, _1: lVal},
								_1: _p32
							},
							_1: _p30
						};
				}
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$foldr = F3(
	function (f, acc, dict) {
		foldr:
		while (true) {
			var _p33 = dict;
			if (_p33.ctor === 'Leaf') {
				return acc;
			} else {
				var _v35 = f,
					_v36 = A3(
					f,
					_p33._1,
					_p33._2,
					_Skinney$elm_dict_exploration$Dict_LLRB$foldr.func(f, acc, _p33._4)),
					_v37 = _p33._3;
				f = _v35;
				acc = _v36;
				dict = _v37;
				continue foldr;
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$keys = function (dict) {
	return _Skinney$elm_dict_exploration$Dict_LLRB$foldr.func(F3(
        function (key, _p34, keyList) {
            return {ctor: '::', _0: key, _1: keyList};
        }), {ctor: '[]'}, dict);
};
var _Skinney$elm_dict_exploration$Dict_LLRB$isBST = function (dict) {
	return _Skinney$elm_dict_exploration$Dict_LLRB$isBSTHelper.func(true, _Skinney$elm_dict_exploration$Dict_LLRB$keys(dict));
};
var _Skinney$elm_dict_exploration$Dict_LLRB$values = function (dict) {
	return _Skinney$elm_dict_exploration$Dict_LLRB$foldr.func(F3(
        function (_p35, value, valueList) {
            return {ctor: '::', _0: value, _1: valueList};
        }), {ctor: '[]'}, dict);
};
var _Skinney$elm_dict_exploration$Dict_LLRB$toList = function (dict) {
	return _Skinney$elm_dict_exploration$Dict_LLRB$foldr.func(F3(
        function (key, value, list) {
            return {
                ctor: '::',
                _0: {ctor: '_Tuple2', _0: key, _1: value},
                _1: list
            };
        }), {ctor: '[]'}, dict);
};
var _Skinney$elm_dict_exploration$Dict_LLRB$foldl = F3(
	function (f, acc, dict) {
		foldl:
		while (true) {
			var _p36 = dict;
			if (_p36.ctor === 'Leaf') {
				return acc;
			} else {
				var _v39 = f,
					_v40 = A3(
					f,
					_p36._1,
					_p36._2,
					_Skinney$elm_dict_exploration$Dict_LLRB$foldl.func(f, acc, _p36._3)),
					_v41 = _p36._4;
				f = _v39;
				acc = _v40;
				dict = _v41;
				continue foldl;
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$merge = F6(
	function (leftStep, bothStep, rightStep, leftDict, rightDict, initialResult) {
		var stepState = F3(
			function (rKey, rValue, _p37) {
				stepState:
				while (true) {
					var _p38 = _p37;
					var _p44 = _p38._1;
					var _p43 = _p38._0;
					var _p39 = _p43;
					if (_p39.ctor === '[]') {
						return {
							ctor: '_Tuple2',
							_0: _p43,
							_1: A3(rightStep, rKey, rValue, _p44)
						};
					} else {
						var _p42 = _p39._1;
						var _p41 = _p39._0._1;
						var _p40 = _p39._0._0;
						if (_elm_lang$core$Native_Utils.cmp(_p40, rKey) < 0) {
							var _v44 = rKey,
								_v45 = rValue,
								_v46 = {
								ctor: '_Tuple2',
								_0: _p42,
								_1: A3(leftStep, _p40, _p41, _p44)
							};
							rKey = _v44;
							rValue = _v45;
							_p37 = _v46;
							continue stepState;
						} else {
							if (_elm_lang$core$Native_Utils.cmp(_p40, rKey) > 0) {
								return {
									ctor: '_Tuple2',
									_0: _p43,
									_1: A3(rightStep, rKey, rValue, _p44)
								};
							} else {
								return {
									ctor: '_Tuple2',
									_0: _p42,
									_1: A4(bothStep, _p40, _p41, rValue, _p44)
								};
							}
						}
					}
				}
			});
		var _p45 = _Skinney$elm_dict_exploration$Dict_LLRB$foldl.func(stepState, {
            ctor: '_Tuple2',
            _0: _Skinney$elm_dict_exploration$Dict_LLRB$toList(leftDict),
            _1: initialResult
        }, rightDict);
		var leftovers = _p45._0;
		var intermediateResult = _p45._1;
		return _elm_lang$core$List$foldl.func(F2(
            function (_p46, result) {
                var _p47 = _p46;
                return A3(leftStep, _p47._0, _p47._1, result);
            }), intermediateResult, leftovers);
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$getMin = function (dict) {
	getMin:
	while (true) {
		var _p48 = dict;
		if ((_p48.ctor === 'Node') && (_p48._3.ctor === 'Node')) {
			var _v49 = _p48._3;
			dict = _v49;
			continue getMin;
		} else {
			return dict;
		}
	}
};
var _Skinney$elm_dict_exploration$Dict_LLRB$get = F2(
	function (targetKey, dict) {
		get:
		while (true) {
			var _p49 = dict;
			if (_p49.ctor === 'Leaf') {
				return _elm_lang$core$Maybe$Nothing;
			} else {
				var _p50 = _elm_lang$core$Basics$compare.func(targetKey, _p49._1);
				switch (_p50.ctor) {
					case 'LT':
						var _v52 = targetKey,
							_v53 = _p49._3;
						targetKey = _v52;
						dict = _v53;
						continue get;
					case 'GT':
						var _v54 = targetKey,
							_v55 = _p49._4;
						targetKey = _v54;
						dict = _v55;
						continue get;
					default:
						return _elm_lang$core$Maybe$Just(_p49._2);
				}
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$member = F2(
	function (key, dict) {
		var _p51 = _Skinney$elm_dict_exploration$Dict_LLRB$get.func(key, dict);
		if (_p51.ctor === 'Just') {
			return true;
		} else {
			return false;
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$sizeHelp = F2(
	function (n, dict) {
		sizeHelp:
		while (true) {
			var _p52 = dict;
			if (_p52.ctor === 'Leaf') {
				return n;
			} else {
				var _v58 = _Skinney$elm_dict_exploration$Dict_LLRB$sizeHelp.func(n + 1, _p52._4),
					_v59 = _p52._3;
				n = _v58;
				dict = _v59;
				continue sizeHelp;
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$size = function (dict) {
	return _Skinney$elm_dict_exploration$Dict_LLRB$sizeHelp.func(0, dict);
};
var _Skinney$elm_dict_exploration$Dict_LLRB$Node = F5(
	function (a, b, c, d, e) {
		return {ctor: 'Node', _0: a, _1: b, _2: c, _3: d, _4: e};
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$Leaf = {ctor: 'Leaf'};
var _Skinney$elm_dict_exploration$Dict_LLRB$empty = _Skinney$elm_dict_exploration$Dict_LLRB$Leaf;
var _Skinney$elm_dict_exploration$Dict_LLRB$isEmpty = function (dict) {
	return _elm_lang$core$Native_Utils.eq(dict, _Skinney$elm_dict_exploration$Dict_LLRB$empty);
};
var _Skinney$elm_dict_exploration$Dict_LLRB$map = F2(
	function (f, dict) {
		var _p53 = dict;
		if (_p53.ctor === 'Leaf') {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Leaf;
		} else {
			var _p54 = _p53._1;
			return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                _p53._0,
                _p54,
                A2(f, _p54, _p53._2),
                _Skinney$elm_dict_exploration$Dict_LLRB$map.func(f, _p53._3),
                _Skinney$elm_dict_exploration$Dict_LLRB$map.func(f, _p53._4)
            );
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$Red = {ctor: 'Red'};
var _Skinney$elm_dict_exploration$Dict_LLRB$is23Helper = F2(
	function (root, node) {
		var _p55 = node;
		if (_p55.ctor === 'Leaf') {
			return true;
		} else {
			var _p57 = _p55._4;
			var _p56 = _p55._3;
			return _Skinney$elm_dict_exploration$Dict_LLRB$isRed(_p57) ? false : (((!_elm_lang$core$Native_Utils.eq(node, root)) && (_elm_lang$core$Native_Utils.eq(_p55._0, _Skinney$elm_dict_exploration$Dict_LLRB$Red) && _Skinney$elm_dict_exploration$Dict_LLRB$isRed(_p56))) ? false : (_Skinney$elm_dict_exploration$Dict_LLRB$is23Helper.func(root, _p56) && _Skinney$elm_dict_exploration$Dict_LLRB$is23Helper.func(root, _p57)));
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$is23 = function (dict) {
	return _Skinney$elm_dict_exploration$Dict_LLRB$is23Helper.func(dict, dict);
};
var _Skinney$elm_dict_exploration$Dict_LLRB$isBalancedBlacksHelper = F2(
	function (node, blacks) {
		isBalancedBlacksHelper:
		while (true) {
			var _p58 = node;
			if (_p58.ctor === 'Leaf') {
				return blacks;
			} else {
				var _p59 = _p58._3;
				if (_elm_lang$core$Native_Utils.eq(_p58._0, _Skinney$elm_dict_exploration$Dict_LLRB$Red)) {
					var _v63 = _p59,
						_v64 = blacks;
					node = _v63;
					blacks = _v64;
					continue isBalancedBlacksHelper;
				} else {
					var _v65 = _p59,
						_v66 = blacks + 1;
					node = _v65;
					blacks = _v66;
					continue isBalancedBlacksHelper;
				}
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$isBalancedHelper = F2(
	function (node, blacks) {
		var _p60 = node;
		if (_p60.ctor === 'Leaf') {
			return _elm_lang$core$Native_Utils.eq(blacks, 0);
		} else {
			var nextBlacks = _elm_lang$core$Native_Utils.eq(_p60._0, _Skinney$elm_dict_exploration$Dict_LLRB$Red) ? blacks : (blacks - 1);
			return _Skinney$elm_dict_exploration$Dict_LLRB$isBalancedHelper.func(_p60._3, nextBlacks) && _Skinney$elm_dict_exploration$Dict_LLRB$isBalancedHelper.func(_p60._4, nextBlacks);
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$isBalanced = function (dict) {
	return _Skinney$elm_dict_exploration$Dict_LLRB$isBalancedHelper.func(
        dict,
        _Skinney$elm_dict_exploration$Dict_LLRB$isBalancedBlacksHelper.func(dict, 0)
    );
};
var _Skinney$elm_dict_exploration$Dict_LLRB$validateInvariants = function (dict) {
	return (!_Skinney$elm_dict_exploration$Dict_LLRB$isBST(dict)) ? 'Not in symmetric order' : ((!_Skinney$elm_dict_exploration$Dict_LLRB$is23(dict)) ? 'Not a 2-3 tree' : ((!_Skinney$elm_dict_exploration$Dict_LLRB$isBalanced(dict)) ? 'Not balanced' : ''));
};
var _Skinney$elm_dict_exploration$Dict_LLRB$Black = {ctor: 'Black'};
var _Skinney$elm_dict_exploration$Dict_LLRB$singleton = F2(
	function (key, value) {
		return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
            _Skinney$elm_dict_exploration$Dict_LLRB$Black,
            key,
            value,
            _Skinney$elm_dict_exploration$Dict_LLRB$Leaf,
            _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
        );
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$balance = F5(
	function (color, key, value, left, right) {
		var _p61 = right;
		if ((_p61.ctor === 'Node') && (_p61._0.ctor === 'Red')) {
			var _p66 = _p61._2;
			var _p65 = _p61._4;
			var _p64 = _p61._3;
			var _p63 = _p61._1;
			var _p62 = left;
			if ((_p62.ctor === 'Node') && (_p62._0.ctor === 'Red')) {
				return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                    key,
                    value,
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                        _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                        _p62._1,
                        _p62._2,
                        _p62._3,
                        _p62._4
                    ),
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Black, _p63, _p66, _p64, _p65)
                );
			} else {
				return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    color,
                    _p63,
                    _p66,
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, key, value, left, _p64),
                    _p65
                );
			}
		} else {
			var _p67 = left;
			if ((((_p67.ctor === 'Node') && (_p67._0.ctor === 'Red')) && (_p67._3.ctor === 'Node')) && (_p67._3._0.ctor === 'Red')) {
				return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                    _p67._1,
                    _p67._2,
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                        _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                        _p67._3._1,
                        _p67._3._2,
                        _p67._3._3,
                        _p67._3._4
                    ),
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Black, key, value, _p67._4, right)
                );
			} else {
				return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(color, key, value, left, right);
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$insertHelp = F3(
	function (key, value, dict) {
		var _p68 = dict;
		if (_p68.ctor === 'Leaf') {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                key,
                value,
                _Skinney$elm_dict_exploration$Dict_LLRB$Leaf,
                _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
            );
		} else {
			var _p74 = _p68._2;
			var _p73 = _p68._4;
			var _p72 = _p68._3;
			var _p71 = _p68._1;
			var _p70 = _p68._0;
			var _p69 = _elm_lang$core$Basics$compare.func(key, _p71);
			switch (_p69.ctor) {
				case 'LT':
					return _Skinney$elm_dict_exploration$Dict_LLRB$balance.func(
                        _p70,
                        _p71,
                        _p74,
                        _Skinney$elm_dict_exploration$Dict_LLRB$insertHelp.func(key, value, _p72),
                        _p73
                    );
				case 'GT':
					return _Skinney$elm_dict_exploration$Dict_LLRB$balance.func(
                        _p70,
                        _p71,
                        _p74,
                        _p72,
                        _Skinney$elm_dict_exploration$Dict_LLRB$insertHelp.func(key, value, _p73)
                    );
				default:
					return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_p70, _p71, value, _p72, _p73);
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$insert = F3(
	function (key, value, dict) {
		var _p75 = _Skinney$elm_dict_exploration$Dict_LLRB$insertHelp.func(key, value, dict);
		if ((_p75.ctor === 'Node') && (_p75._0.ctor === 'Red')) {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                _p75._1,
                _p75._2,
                _p75._3,
                _p75._4
            );
		} else {
			return _p75;
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$moveRedLeft = function (dict) {
	var _p76 = dict;
	if (((_p76.ctor === 'Node') && (_p76._3.ctor === 'Node')) && (_p76._4.ctor === 'Node')) {
		if ((_p76._4._3.ctor === 'Node') && (_p76._4._3._0.ctor === 'Red')) {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                _p76._4._3._1,
                _p76._4._3._2,
                _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                    _p76._1,
                    _p76._2,
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                        _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                        _p76._3._1,
                        _p76._3._2,
                        _p76._3._3,
                        _p76._3._4
                    ),
                    _p76._4._3._3
                ),
                _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                    _p76._4._1,
                    _p76._4._2,
                    _p76._4._3._4,
                    _p76._4._4
                )
            );
		} else {
			var _p87 = _p76._2;
			var _p86 = _p76._4._2;
			var _p85 = _p76._4._4;
			var _p84 = _p76._4._3;
			var _p83 = _p76._4._1;
			var _p82 = _p76._3._2;
			var _p81 = _p76._3._4;
			var _p80 = _p76._3._3;
			var _p79 = _p76._3._1;
			var _p78 = _p76._1;
			var _p77 = _p76._0;
			if (_p77.ctor === 'Black') {
				return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                    _p78,
                    _p87,
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p79, _p82, _p80, _p81),
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p83, _p86, _p84, _p85)
                );
			} else {
				return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                    _p78,
                    _p87,
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p79, _p82, _p80, _p81),
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p83, _p86, _p84, _p85)
                );
			}
		}
	} else {
		return dict;
	}
};
var _Skinney$elm_dict_exploration$Dict_LLRB$removeMin = function (dict) {
	var _p88 = dict;
	if ((_p88.ctor === 'Node') && (_p88._3.ctor === 'Node')) {
		var _p96 = _p88._2;
		var _p95 = _p88._4;
		var _p94 = _p88._3;
		var _p93 = _p88._1;
		var _p92 = _p88._0;
		var _p89 = _p88._3._0;
		if (_p89.ctor === 'Black') {
			var _p90 = _p88._3._3;
			if ((_p90.ctor === 'Node') && (_p90._0.ctor === 'Red')) {
				return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _p92,
                    _p93,
                    _p96,
                    _Skinney$elm_dict_exploration$Dict_LLRB$removeMin(_p94),
                    _p95
                );
			} else {
				var _p91 = _Skinney$elm_dict_exploration$Dict_LLRB$moveRedLeft(dict);
				if (_p91.ctor === 'Node') {
					return _Skinney$elm_dict_exploration$Dict_LLRB$balance.func(
                        _p91._0,
                        _p91._1,
                        _p91._2,
                        _Skinney$elm_dict_exploration$Dict_LLRB$removeMin(_p91._3),
                        _p91._4
                    );
				} else {
					return _Skinney$elm_dict_exploration$Dict_LLRB$Leaf;
				}
			}
		} else {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                _p92,
                _p93,
                _p96,
                _Skinney$elm_dict_exploration$Dict_LLRB$removeMin(_p94),
                _p95
            );
		}
	} else {
		return _Skinney$elm_dict_exploration$Dict_LLRB$Leaf;
	}
};
var _Skinney$elm_dict_exploration$Dict_LLRB$moveRedRight = function (dict) {
	var _p97 = dict;
	if (((_p97.ctor === 'Node') && (_p97._3.ctor === 'Node')) && (_p97._4.ctor === 'Node')) {
		if ((_p97._3._3.ctor === 'Node') && (_p97._3._3._0.ctor === 'Red')) {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                _p97._3._1,
                _p97._3._2,
                _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                    _p97._3._3._1,
                    _p97._3._3._2,
                    _p97._3._3._3,
                    _p97._3._3._4
                ),
                _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                    _p97._1,
                    _p97._2,
                    _p97._3._4,
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                        _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                        _p97._4._1,
                        _p97._4._2,
                        _p97._4._3,
                        _p97._4._4
                    )
                )
            );
		} else {
			var _p108 = _p97._2;
			var _p107 = _p97._4._2;
			var _p106 = _p97._4._4;
			var _p105 = _p97._4._3;
			var _p104 = _p97._4._1;
			var _p103 = _p97._3._2;
			var _p102 = _p97._3._4;
			var _p101 = _p97._3._3;
			var _p100 = _p97._3._1;
			var _p99 = _p97._1;
			var _p98 = _p97._0;
			if (_p98.ctor === 'Black') {
				return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                    _p99,
                    _p108,
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p100, _p103, _p101, _p102),
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p104, _p107, _p105, _p106)
                );
			} else {
				return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                    _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                    _p99,
                    _p108,
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p100, _p103, _p101, _p102),
                    _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p104, _p107, _p105, _p106)
                );
			}
		}
	} else {
		return dict;
	}
};
var _Skinney$elm_dict_exploration$Dict_LLRB$removeHelpPrepEQGT = F7(
	function (targetKey, dict, color, key, value, left, right) {
		var _p109 = left;
		if ((_p109.ctor === 'Node') && (_p109._0.ctor === 'Red')) {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                color,
                _p109._1,
                _p109._2,
                _p109._3,
                _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, key, value, _p109._4, right)
            );
		} else {
			var _p110 = right;
			_v83_2:
			do {
				if ((_p110.ctor === 'Node') && (_p110._0.ctor === 'Black')) {
					if (_p110._3.ctor === 'Node') {
						if (_p110._3._0.ctor === 'Black') {
							return _Skinney$elm_dict_exploration$Dict_LLRB$moveRedRight(dict);
						} else {
							break _v83_2;
						}
					} else {
						return _Skinney$elm_dict_exploration$Dict_LLRB$moveRedRight(dict);
					}
				} else {
					break _v83_2;
				}
			} while(false);
			return dict;
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$removeHelp = F2(
	function (targetKey, dict) {
		var _p111 = dict;
		if (_p111.ctor === 'Leaf') {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Leaf;
		} else {
			var _p119 = _p111._2;
			var _p118 = _p111._4;
			var _p117 = _p111._3;
			var _p116 = _p111._1;
			var _p115 = _p111._0;
			if (_elm_lang$core$Native_Utils.cmp(targetKey, _p116) < 0) {
				var _p112 = _p117;
				if ((_p112.ctor === 'Node') && (_p112._0.ctor === 'Black')) {
					var _p113 = _p112._3;
					if ((_p113.ctor === 'Node') && (_p113._0.ctor === 'Red')) {
						return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                            _p115,
                            _p116,
                            _p119,
                            _Skinney$elm_dict_exploration$Dict_LLRB$removeHelp.func(targetKey, _p117),
                            _p118
                        );
					} else {
						var _p114 = _Skinney$elm_dict_exploration$Dict_LLRB$moveRedLeft(dict);
						if (_p114.ctor === 'Node') {
							return _Skinney$elm_dict_exploration$Dict_LLRB$balance.func(
                                _p114._0,
                                _p114._1,
                                _p114._2,
                                _Skinney$elm_dict_exploration$Dict_LLRB$removeHelp.func(targetKey, _p114._3),
                                _p114._4
                            );
						} else {
							return _Skinney$elm_dict_exploration$Dict_LLRB$Leaf;
						}
					}
				} else {
					return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                        _p115,
                        _p116,
                        _p119,
                        _Skinney$elm_dict_exploration$Dict_LLRB$removeHelp.func(targetKey, _p117),
                        _p118
                    );
				}
			} else {
				return _Skinney$elm_dict_exploration$Dict_LLRB$removeHelpEQGT.func(
                    targetKey,
                    _Skinney$elm_dict_exploration$Dict_LLRB$removeHelpPrepEQGT.func(targetKey, dict, _p115, _p116, _p119, _p117, _p118)
                );
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$removeHelpEQGT = F2(
	function (targetKey, dict) {
		var _p120 = dict;
		if (_p120.ctor === 'Node') {
			var _p125 = _p120._4;
			var _p124 = _p120._3;
			var _p123 = _p120._1;
			var _p122 = _p120._0;
			if (_elm_lang$core$Native_Utils.eq(targetKey, _p123)) {
				var _p121 = _Skinney$elm_dict_exploration$Dict_LLRB$getMin(_p125);
				if (_p121.ctor === 'Node') {
					return _Skinney$elm_dict_exploration$Dict_LLRB$balance.func(
                        _p122,
                        _p121._1,
                        _p121._2,
                        _p124,
                        _Skinney$elm_dict_exploration$Dict_LLRB$removeMin(_p125)
                    );
				} else {
					return _Skinney$elm_dict_exploration$Dict_LLRB$Leaf;
				}
			} else {
				return _Skinney$elm_dict_exploration$Dict_LLRB$balance.func(
                    _p122,
                    _p123,
                    _p120._2,
                    _p124,
                    _Skinney$elm_dict_exploration$Dict_LLRB$removeHelp.func(targetKey, _p125)
                );
			}
		} else {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Leaf;
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$remove = F2(
	function (targetKey, dict) {
		var _p126 = _Skinney$elm_dict_exploration$Dict_LLRB$removeHelp.func(targetKey, dict);
		if ((_p126.ctor === 'Node') && (_p126._0.ctor === 'Red')) {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                _p126._1,
                _p126._2,
                _p126._3,
                _p126._4
            );
		} else {
			return _p126;
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$update = F3(
	function (key, alter, dict) {
		var _p127 = alter(
			_Skinney$elm_dict_exploration$Dict_LLRB$get.func(key, dict));
		if (_p127.ctor === 'Nothing') {
			return _Skinney$elm_dict_exploration$Dict_LLRB$remove.func(key, dict);
		} else {
			return _Skinney$elm_dict_exploration$Dict_LLRB$insert.func(key, _p127._0, dict);
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$sortedListToNodeList = F4(
	function (isAsc, revList, _p128, list) {
		sortedListToNodeList:
		while (true) {
			var _p129 = _p128;
			var _p139 = _p129._1;
			var _p138 = _p129._0;
			var _p130 = list;
			if (_p130.ctor === '[]') {
				return {
					ctor: '_Tuple2',
					_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                        _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                        _p138,
                        _p139,
                        _Skinney$elm_dict_exploration$Dict_LLRB$Leaf,
                        _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                    ),
					_1: revList
				};
			} else {
				if (_p130._1.ctor === '[]') {
					var _p132 = _p130._0._1;
					var _p131 = _p130._0._0;
					return isAsc ? {
						ctor: '_Tuple2',
						_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                            _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                            _p131,
                            _p132,
                            _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                                _p138,
                                _p139,
                                _Skinney$elm_dict_exploration$Dict_LLRB$Leaf,
                                _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                            ),
                            _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                        ),
						_1: revList
					} : {
						ctor: '_Tuple2',
						_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                            _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                            _p138,
                            _p139,
                            _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                                _p131,
                                _p132,
                                _Skinney$elm_dict_exploration$Dict_LLRB$Leaf,
                                _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                            ),
                            _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                        ),
						_1: revList
					};
				} else {
					if (_p130._1._1.ctor === '[]') {
						return {
							ctor: '_Tuple2',
							_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                                _p130._1._0._0,
                                _p130._1._0._1,
                                _Skinney$elm_dict_exploration$Dict_LLRB$Leaf,
                                _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                            ),
							_1: {
								ctor: '::',
								_0: {
									ctor: '_Tuple2',
									_0: _p130._0,
									_1: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                                        _p138,
                                        _p139,
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Leaf,
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                                    )
								},
								_1: revList
							}
						};
					} else {
						var _p137 = _p130._0._1;
						var _p136 = _p130._1._1._1;
						var _p135 = _p130._1._1._0;
						var _p134 = _p130._1._0;
						var _p133 = _p130._0._0;
						if (isAsc) {
							var _v94 = isAsc,
								_v95 = {
								ctor: '::',
								_0: {
									ctor: '_Tuple2',
									_0: _p134,
									_1: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                                        _p133,
                                        _p137,
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                            _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                                            _p138,
                                            _p139,
                                            _Skinney$elm_dict_exploration$Dict_LLRB$Leaf,
                                            _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                                        ),
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                                    )
								},
								_1: revList
							},
								_v96 = _p135,
								_v97 = _p136;
							isAsc = _v94;
							revList = _v95;
							_p128 = _v96;
							list = _v97;
							continue sortedListToNodeList;
						} else {
							var _v98 = isAsc,
								_v99 = {
								ctor: '::',
								_0: {
									ctor: '_Tuple2',
									_0: _p134,
									_1: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                                        _p138,
                                        _p139,
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                            _Skinney$elm_dict_exploration$Dict_LLRB$Red,
                                            _p133,
                                            _p137,
                                            _Skinney$elm_dict_exploration$Dict_LLRB$Leaf,
                                            _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                                        ),
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Leaf
                                    )
								},
								_1: revList
							},
								_v100 = _p135,
								_v101 = _p136;
							isAsc = _v98;
							revList = _v99;
							_p128 = _v100;
							list = _v101;
							continue sortedListToNodeList;
						}
					}
				}
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$accumulateNodeList = F6(
	function (isReversed, revList, a, _p140, b, list) {
		accumulateNodeList:
		while (true) {
			var _p141 = _p140;
			var _p160 = _p141._1;
			var _p159 = _p141._0;
			var _p142 = list;
			if (_p142.ctor === '[]') {
				return isReversed ? {
					ctor: '_Tuple2',
					_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Black, _p159, _p160, b, a),
					_1: revList
				} : {
					ctor: '_Tuple2',
					_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Black, _p159, _p160, a, b),
					_1: revList
				};
			} else {
				if (_p142._1.ctor === '[]') {
					var _p145 = _p142._0._0._1;
					var _p144 = _p142._0._0._0;
					var _p143 = _p142._0._1;
					return isReversed ? {
						ctor: '_Tuple2',
						_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                            _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                            _p159,
                            _p160,
                            _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p144, _p145, _p143, b),
                            a
                        ),
						_1: revList
					} : {
						ctor: '_Tuple2',
						_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                            _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                            _p144,
                            _p145,
                            _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p159, _p160, a, b),
                            _p143
                        ),
						_1: revList
					};
				} else {
					if (_p142._1._1.ctor === '[]') {
						var _p150 = _p142._1._0._0._1;
						var _p149 = _p142._0._0;
						var _p148 = _p142._1._0._0._0;
						var _p147 = _p142._1._0._1;
						var _p146 = _p142._0._1;
						return isReversed ? {
							ctor: '_Tuple2',
							_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Black, _p148, _p150, _p147, _p146),
							_1: {
								ctor: '::',
								_0: {
									ctor: '_Tuple2',
									_0: _p149,
									_1: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Black, _p159, _p160, b, a)
								},
								_1: revList
							}
						} : {
							ctor: '_Tuple2',
							_0: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Black, _p148, _p150, _p146, _p147),
							_1: {
								ctor: '::',
								_0: {
									ctor: '_Tuple2',
									_0: _p149,
									_1: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Black, _p159, _p160, a, b)
								},
								_1: revList
							}
						};
					} else {
						var _p158 = _p142._0._0._1;
						var _p157 = _p142._1._1._1;
						var _p156 = _p142._1._1._0._0;
						var _p155 = _p142._1._0._0;
						var _p154 = _p142._0._0._0;
						var _p153 = _p142._1._1._0._1;
						var _p152 = _p142._1._0._1;
						var _p151 = _p142._0._1;
						if (isReversed) {
							var _v104 = isReversed,
								_v105 = {
								ctor: '::',
								_0: {
									ctor: '_Tuple2',
									_0: _p155,
									_1: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                                        _p159,
                                        _p160,
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p154, _p158, _p151, b),
                                        a
                                    )
								},
								_1: revList
							},
								_v106 = _p152,
								_v107 = _p156,
								_v108 = _p153,
								_v109 = _p157;
							isReversed = _v104;
							revList = _v105;
							a = _v106;
							_p140 = _v107;
							b = _v108;
							list = _v109;
							continue accumulateNodeList;
						} else {
							var _v110 = isReversed,
								_v111 = {
								ctor: '::',
								_0: {
									ctor: '_Tuple2',
									_0: _p155,
									_1: _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Black,
                                        _p154,
                                        _p158,
                                        _Skinney$elm_dict_exploration$Dict_LLRB$Node.func(_Skinney$elm_dict_exploration$Dict_LLRB$Red, _p159, _p160, a, b),
                                        _p151
                                    )
								},
								_1: revList
							},
								_v112 = _p152,
								_v113 = _p156,
								_v114 = _p153,
								_v115 = _p157;
							isReversed = _v110;
							revList = _v111;
							a = _v112;
							_p140 = _v113;
							b = _v114;
							list = _v115;
							continue accumulateNodeList;
						}
					}
				}
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$fromNodeList = F2(
	function (isReversed, nodeList) {
		fromNodeList:
		while (true) {
			var _p161 = nodeList;
			if (_p161._1.ctor === '[]') {
				return _p161._0;
			} else {
				var _v117 = !isReversed,
					_v118 = _Skinney$elm_dict_exploration$Dict_LLRB$accumulateNodeList.func(
                        isReversed,
                        {ctor: '[]'},
                        _p161._0,
                        _p161._1._0._0,
                        _p161._1._0._1,
                        _p161._1._1
                    );
				isReversed = _v117;
				nodeList = _v118;
				continue fromNodeList;
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$fromSortedList = F2(
	function (isAsc, list) {
		var _p162 = list;
		if (_p162.ctor === '[]') {
			return _Skinney$elm_dict_exploration$Dict_LLRB$Leaf;
		} else {
			return _Skinney$elm_dict_exploration$Dict_LLRB$fromNodeList.func(
                isAsc,
                _Skinney$elm_dict_exploration$Dict_LLRB$sortedListToNodeList.func(isAsc, {ctor: '[]'}, _p162._0, _p162._1)
            );
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$filter = F2(
	function (predicate, dict) {
		var helper = F3(
			function (key, value, list) {
				return A2(predicate, key, value) ? {
					ctor: '::',
					_0: {ctor: '_Tuple2', _0: key, _1: value},
					_1: list
				} : list;
			});
		return _Skinney$elm_dict_exploration$Dict_LLRB$fromSortedList.func(
            true,
            _Skinney$elm_dict_exploration$Dict_LLRB$foldr.func(helper, {ctor: '[]'}, dict)
        );
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$partition = F2(
	function (predicate, dict) {
		var helper = F3(
			function (key, value, _p163) {
				var _p164 = _p163;
				var _p166 = _p164._0;
				var _p165 = _p164._1;
				return A2(predicate, key, value) ? {
					ctor: '_Tuple2',
					_0: {
						ctor: '::',
						_0: {ctor: '_Tuple2', _0: key, _1: value},
						_1: _p166
					},
					_1: _p165
				} : {
					ctor: '_Tuple2',
					_0: _p166,
					_1: {
						ctor: '::',
						_0: {ctor: '_Tuple2', _0: key, _1: value},
						_1: _p165
					}
				};
			});
		var _p167 = _Skinney$elm_dict_exploration$Dict_LLRB$foldr.func(helper, {
            ctor: '_Tuple2',
            _0: {ctor: '[]'},
            _1: {ctor: '[]'}
        }, dict);
		var trues = _p167._0;
		var falses = _p167._1;
		return {
			ctor: '_Tuple2',
			_0: _Skinney$elm_dict_exploration$Dict_LLRB$fromSortedList.func(true, trues),
			_1: _Skinney$elm_dict_exploration$Dict_LLRB$fromSortedList.func(true, falses)
		};
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$union = F2(
	function (left, right) {
		var _p168 = {ctor: '_Tuple2', _0: left, _1: right};
		_v121_2:
		do {
			if (_p168.ctor === '_Tuple2') {
				if (_p168._1.ctor === 'Leaf') {
					return left;
				} else {
					if (_p168._0.ctor === 'Leaf') {
						return right;
					} else {
						break _v121_2;
					}
				}
			} else {
				break _v121_2;
			}
		} while(false);
		var _p169 = _Skinney$elm_dict_exploration$Dict_LLRB$foldl.func(_Skinney$elm_dict_exploration$Dict_LLRB$unionAccumulator, {
            ctor: '_Tuple2',
            _0: {ctor: '[]'},
            _1: _Skinney$elm_dict_exploration$Dict_LLRB$toList(right)
        }, left);
		var lt = _p169._0;
		var gt = _p169._1;
		return _Skinney$elm_dict_exploration$Dict_LLRB$fromSortedList.func(false, _elm_lang$core$List$foldl.func(F2(
            function (e, acc) {
                return {ctor: '::', _0: e, _1: acc};
            }), lt, gt));
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$intersect = F2(
	function (left, right) {
		var _p170 = {
			ctor: '_Tuple2',
			_0: _Skinney$elm_dict_exploration$Dict_LLRB$getRange(left),
			_1: _Skinney$elm_dict_exploration$Dict_LLRB$getRange(right)
		};
		if (_p170._1.ctor === 'Nothing') {
			return _Skinney$elm_dict_exploration$Dict_LLRB$empty;
		} else {
			if (_p170._0.ctor === 'Nothing') {
				return _Skinney$elm_dict_exploration$Dict_LLRB$empty;
			} else {
				return ((_elm_lang$core$Native_Utils.cmp(_p170._0._0._1, _p170._1._0._0) < 0) || (_elm_lang$core$Native_Utils.cmp(_p170._1._0._1, _p170._0._0._0) < 0)) ? _Skinney$elm_dict_exploration$Dict_LLRB$empty : _Skinney$elm_dict_exploration$Dict_LLRB$fromSortedList.func(false, _elm_lang$core$Tuple$first(
                    _Skinney$elm_dict_exploration$Dict_LLRB$foldl.func(_Skinney$elm_dict_exploration$Dict_LLRB$intersectAccumulator, {
                        ctor: '_Tuple2',
                        _0: {ctor: '[]'},
                        _1: _Skinney$elm_dict_exploration$Dict_LLRB$toList(right)
                    }, left)));
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$diff = F2(
	function (left, right) {
		var _p171 = {
			ctor: '_Tuple2',
			_0: _Skinney$elm_dict_exploration$Dict_LLRB$getRange(left),
			_1: _Skinney$elm_dict_exploration$Dict_LLRB$getRange(right)
		};
		if (_p171._1.ctor === 'Nothing') {
			return left;
		} else {
			if (_p171._0.ctor === 'Nothing') {
				return _Skinney$elm_dict_exploration$Dict_LLRB$empty;
			} else {
				return ((_elm_lang$core$Native_Utils.cmp(_p171._0._0._1, _p171._1._0._0) < 0) || (_elm_lang$core$Native_Utils.cmp(_p171._1._0._1, _p171._0._0._0) < 0)) ? left : _Skinney$elm_dict_exploration$Dict_LLRB$fromSortedList.func(false, _elm_lang$core$Tuple$first(
                    _Skinney$elm_dict_exploration$Dict_LLRB$foldl.func(_Skinney$elm_dict_exploration$Dict_LLRB$diffAccumulator, {
                        ctor: '_Tuple2',
                        _0: {ctor: '[]'},
                        _1: _Skinney$elm_dict_exploration$Dict_LLRB$toList(right)
                    }, left)));
			}
		}
	});
var _Skinney$elm_dict_exploration$Dict_LLRB$fromList = function (list) {
	var _p172 = list;
	if (_p172.ctor === '::') {
		var _p173 = _Skinney$elm_dict_exploration$Dict_LLRB$splitSortedHelp.func({ctor: '[]'}, _p172._0, _p172._1);
		var sorted = _p173._0;
		var remainder = _p173._1;
		return _elm_lang$core$List$foldl.func(F2(
            function (_p174, dict) {
                var _p175 = _p174;
                return _Skinney$elm_dict_exploration$Dict_LLRB$insert.func(_p175._0, _p175._1, dict);
            }), _Skinney$elm_dict_exploration$Dict_LLRB$fromSortedList.func(false, sorted), remainder);
	} else {
		return _Skinney$elm_dict_exploration$Dict_LLRB$empty;
	}
};

//import Native.List //

var _elm_lang$core$Native_Array = function() {

// A RRB-Tree has two distinct data types.
// Leaf -> "height"  is always 0
//         "table"   is an array of elements
// Node -> "height"  is always greater than 0
//         "table"   is an array of child nodes
//         "lengths" is an array of accumulated lengths of the child nodes

// M is the maximal table size. 32 seems fast. E is the allowed increase
// of search steps when concatting to find an index. Lower values will
// decrease balancing, but will increase search steps.
var M = 32;
var E = 2;

// An empty array.
var empty = {
	ctor: '_Array',
	height: 0,
	table: []
};


function get(i, array)
{
	if (i < 0 || i >= length(array))
	{
		throw new Error(
			'Index ' + i + ' is out of range. Check the length of ' +
			'your array first or use getMaybe or getWithDefault.');
	}
	return unsafeGet(i, array);
}


function unsafeGet(i, array)
{
	for (var x = array.height; x > 0; x--)
	{
		var slot = i >> (x * 5);
		while (array.lengths[slot] <= i)
		{
			slot++;
		}
		if (slot > 0)
		{
			i -= array.lengths[slot - 1];
		}
		array = array.table[slot];
	}
	return array.table[i];
}


// Sets the value at the index i. Only the nodes leading to i will get
// copied and updated.
function set(i, item, array)
{
	if (i < 0 || length(array) <= i)
	{
		return array;
	}
	return unsafeSet(i, item, array);
}


function unsafeSet(i, item, array)
{
	array = nodeCopy(array);

	if (array.height === 0)
	{
		array.table[i] = item;
	}
	else
	{
		var slot = getSlot(i, array);
		if (slot > 0)
		{
			i -= array.lengths[slot - 1];
		}
		array.table[slot] = unsafeSet(i, item, array.table[slot]);
	}
	return array;
}


function initialize(len, f)
{
	if (len <= 0)
	{
		return empty;
	}
	var h = Math.floor( Math.log(len) / Math.log(M) );
	return initialize_(f, h, 0, len);
}

function initialize_(f, h, from, to)
{
	if (h === 0)
	{
		var table = new Array((to - from) % (M + 1));
		for (var i = 0; i < table.length; i++)
		{
		  table[i] = f(from + i);
		}
		return {
			ctor: '_Array',
			height: 0,
			table: table
		};
	}

	var step = Math.pow(M, h);
	var table = new Array(Math.ceil((to - from) / step));
	var lengths = new Array(table.length);
	for (var i = 0; i < table.length; i++)
	{
		table[i] = initialize_(f, h - 1, from + (i * step), Math.min(from + ((i + 1) * step), to));
		lengths[i] = length(table[i]) + (i > 0 ? lengths[i-1] : 0);
	}
	return {
		ctor: '_Array',
		height: h,
		table: table,
		lengths: lengths
	};
}

function fromList(list)
{
	if (list.ctor === '[]')
	{
		return empty;
	}

	// Allocate M sized blocks (table) and write list elements to it.
	var table = new Array(M);
	var nodes = [];
	var i = 0;

	while (list.ctor !== '[]')
	{
		table[i] = list._0;
		list = list._1;
		i++;

		// table is full, so we can push a leaf containing it into the
		// next node.
		if (i === M)
		{
			var leaf = {
				ctor: '_Array',
				height: 0,
				table: table
			};
			fromListPush(leaf, nodes);
			table = new Array(M);
			i = 0;
		}
	}

	// Maybe there is something left on the table.
	if (i > 0)
	{
		var leaf = {
			ctor: '_Array',
			height: 0,
			table: table.splice(0, i)
		};
		fromListPush(leaf, nodes);
	}

	// Go through all of the nodes and eventually push them into higher nodes.
	for (var h = 0; h < nodes.length - 1; h++)
	{
		if (nodes[h].table.length > 0)
		{
			fromListPush(nodes[h], nodes);
		}
	}

	var head = nodes[nodes.length - 1];
	if (head.height > 0 && head.table.length === 1)
	{
		return head.table[0];
	}
	else
	{
		return head;
	}
}

// Push a node into a higher node as a child.
function fromListPush(toPush, nodes)
{
	var h = toPush.height;

	// Maybe the node on this height does not exist.
	if (nodes.length === h)
	{
		var node = {
			ctor: '_Array',
			height: h + 1,
			table: [],
			lengths: []
		};
		nodes.push(node);
	}

	nodes[h].table.push(toPush);
	var len = length(toPush);
	if (nodes[h].lengths.length > 0)
	{
		len += nodes[h].lengths[nodes[h].lengths.length - 1];
	}
	nodes[h].lengths.push(len);

	if (nodes[h].table.length === M)
	{
		fromListPush(nodes[h], nodes);
		nodes[h] = {
			ctor: '_Array',
			height: h + 1,
			table: [],
			lengths: []
		};
	}
}

// Pushes an item via push_ to the bottom right of a tree.
function push(item, a)
{
	var pushed = push_(item, a);
	if (pushed !== null)
	{
		return pushed;
	}

	var newTree = create(item, a.height);
	return siblise(a, newTree);
}

// Recursively tries to push an item to the bottom-right most
// tree possible. If there is no space left for the item,
// null will be returned.
function push_(item, a)
{
	// Handle resursion stop at leaf level.
	if (a.height === 0)
	{
		if (a.table.length < M)
		{
			var newA = {
				ctor: '_Array',
				height: 0,
				table: a.table.slice()
			};
			newA.table.push(item);
			return newA;
		}
		else
		{
		  return null;
		}
	}

	// Recursively push
	var pushed = push_(item, botRight(a));

	// There was space in the bottom right tree, so the slot will
	// be updated.
	if (pushed !== null)
	{
		var newA = nodeCopy(a);
		newA.table[newA.table.length - 1] = pushed;
		newA.lengths[newA.lengths.length - 1]++;
		return newA;
	}

	// When there was no space left, check if there is space left
	// for a new slot with a tree which contains only the item
	// at the bottom.
	if (a.table.length < M)
	{
		var newSlot = create(item, a.height - 1);
		var newA = nodeCopy(a);
		newA.table.push(newSlot);
		newA.lengths.push(newA.lengths[newA.lengths.length - 1] + length(newSlot));
		return newA;
	}
	else
	{
		return null;
	}
}

// Converts an array into a list of elements.
function toList(a)
{
	return toList_(_elm_lang$core$Native_List.Nil, a);
}

function toList_(list, a)
{
	for (var i = a.table.length - 1; i >= 0; i--)
	{
		list =
			a.height === 0
				? _elm_lang$core$Native_List.Cons(a.table[i], list)
				: toList_(list, a.table[i]);
	}
	return list;
}

// Maps a function over the elements of an array.
function map(f, a)
{
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: new Array(a.table.length)
	};
	if (a.height > 0)
	{
		newA.lengths = a.lengths;
	}
	for (var i = 0; i < a.table.length; i++)
	{
		newA.table[i] =
			a.height === 0
				? f(a.table[i])
				: map(f, a.table[i]);
	}
	return newA;
}

// Maps a function over the elements with their index as first argument.
function indexedMap(f, a)
{
	return indexedMap_(f, a, 0);
}

function indexedMap_(f, a, from)
{
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: new Array(a.table.length)
	};
	if (a.height > 0)
	{
		newA.lengths = a.lengths;
	}
	for (var i = 0; i < a.table.length; i++)
	{
		newA.table[i] =
			a.height === 0
				? A2(f, from + i, a.table[i])
				: indexedMap_(f, a.table[i], i == 0 ? from : from + a.lengths[i - 1]);
	}
	return newA;
}

function foldl(f, b, a)
{
	if (a.height === 0)
	{
		for (var i = 0; i < a.table.length; i++)
		{
			b = A2(f, a.table[i], b);
		}
	}
	else
	{
		for (var i = 0; i < a.table.length; i++)
		{
			b = foldl(f, b, a.table[i]);
		}
	}
	return b;
}

function foldr(f, b, a)
{
	if (a.height === 0)
	{
		for (var i = a.table.length; i--; )
		{
			b = A2(f, a.table[i], b);
		}
	}
	else
	{
		for (var i = a.table.length; i--; )
		{
			b = foldr(f, b, a.table[i]);
		}
	}
	return b;
}

// TODO: currently, it slices the right, then the left. This can be
// optimized.
function slice(from, to, a)
{
	if (from < 0)
	{
		from += length(a);
	}
	if (to < 0)
	{
		to += length(a);
	}
	return sliceLeft(from, sliceRight(to, a));
}

function sliceRight(to, a)
{
	if (to === length(a))
	{
		return a;
	}

	// Handle leaf level.
	if (a.height === 0)
	{
		var newA = { ctor:'_Array', height:0 };
		newA.table = a.table.slice(0, to);
		return newA;
	}

	// Slice the right recursively.
	var right = getSlot(to, a);
	var sliced = sliceRight(to - (right > 0 ? a.lengths[right - 1] : 0), a.table[right]);

	// Maybe the a node is not even needed, as sliced contains the whole slice.
	if (right === 0)
	{
		return sliced;
	}

	// Create new node.
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: a.table.slice(0, right),
		lengths: a.lengths.slice(0, right)
	};
	if (sliced.table.length > 0)
	{
		newA.table[right] = sliced;
		newA.lengths[right] = length(sliced) + (right > 0 ? newA.lengths[right - 1] : 0);
	}
	return newA;
}

function sliceLeft(from, a)
{
	if (from === 0)
	{
		return a;
	}

	// Handle leaf level.
	if (a.height === 0)
	{
		var newA = { ctor:'_Array', height:0 };
		newA.table = a.table.slice(from, a.table.length + 1);
		return newA;
	}

	// Slice the left recursively.
	var left = getSlot(from, a);
	var sliced = sliceLeft(from - (left > 0 ? a.lengths[left - 1] : 0), a.table[left]);

	// Maybe the a node is not even needed, as sliced contains the whole slice.
	if (left === a.table.length - 1)
	{
		return sliced;
	}

	// Create new node.
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: a.table.slice(left, a.table.length + 1),
		lengths: new Array(a.table.length - left)
	};
	newA.table[0] = sliced;
	var len = 0;
	for (var i = 0; i < newA.table.length; i++)
	{
		len += length(newA.table[i]);
		newA.lengths[i] = len;
	}

	return newA;
}

// Appends two trees.
function append(a,b)
{
	if (a.table.length === 0)
	{
		return b;
	}
	if (b.table.length === 0)
	{
		return a;
	}

	var c = append_(a, b);

	// Check if both nodes can be crunshed together.
	if (c[0].table.length + c[1].table.length <= M)
	{
		if (c[0].table.length === 0)
		{
			return c[1];
		}
		if (c[1].table.length === 0)
		{
			return c[0];
		}

		// Adjust .table and .lengths
		c[0].table = c[0].table.concat(c[1].table);
		if (c[0].height > 0)
		{
			var len = length(c[0]);
			for (var i = 0; i < c[1].lengths.length; i++)
			{
				c[1].lengths[i] += len;
			}
			c[0].lengths = c[0].lengths.concat(c[1].lengths);
		}

		return c[0];
	}

	if (c[0].height > 0)
	{
		var toRemove = calcToRemove(a, b);
		if (toRemove > E)
		{
			c = shuffle(c[0], c[1], toRemove);
		}
	}

	return siblise(c[0], c[1]);
}

// Returns an array of two nodes; right and left. One node _may_ be empty.
function append_(a, b)
{
	if (a.height === 0 && b.height === 0)
	{
		return [a, b];
	}

	if (a.height !== 1 || b.height !== 1)
	{
		if (a.height === b.height)
		{
			a = nodeCopy(a);
			b = nodeCopy(b);
			var appended = append_(botRight(a), botLeft(b));

			insertRight(a, appended[1]);
			insertLeft(b, appended[0]);
		}
		else if (a.height > b.height)
		{
			a = nodeCopy(a);
			var appended = append_(botRight(a), b);

			insertRight(a, appended[0]);
			b = parentise(appended[1], appended[1].height + 1);
		}
		else
		{
			b = nodeCopy(b);
			var appended = append_(a, botLeft(b));

			var left = appended[0].table.length === 0 ? 0 : 1;
			var right = left === 0 ? 1 : 0;
			insertLeft(b, appended[left]);
			a = parentise(appended[right], appended[right].height + 1);
		}
	}

	// Check if balancing is needed and return based on that.
	if (a.table.length === 0 || b.table.length === 0)
	{
		return [a, b];
	}

	var toRemove = calcToRemove(a, b);
	if (toRemove <= E)
	{
		return [a, b];
	}
	return shuffle(a, b, toRemove);
}

// Helperfunctions for append_. Replaces a child node at the side of the parent.
function insertRight(parent, node)
{
	var index = parent.table.length - 1;
	parent.table[index] = node;
	parent.lengths[index] = length(node);
	parent.lengths[index] += index > 0 ? parent.lengths[index - 1] : 0;
}

function insertLeft(parent, node)
{
	if (node.table.length > 0)
	{
		parent.table[0] = node;
		parent.lengths[0] = length(node);

		var len = length(parent.table[0]);
		for (var i = 1; i < parent.lengths.length; i++)
		{
			len += length(parent.table[i]);
			parent.lengths[i] = len;
		}
	}
	else
	{
		parent.table.shift();
		for (var i = 1; i < parent.lengths.length; i++)
		{
			parent.lengths[i] = parent.lengths[i] - parent.lengths[0];
		}
		parent.lengths.shift();
	}
}

// Returns the extra search steps for E. Refer to the paper.
function calcToRemove(a, b)
{
	var subLengths = 0;
	for (var i = 0; i < a.table.length; i++)
	{
		subLengths += a.table[i].table.length;
	}
	for (var i = 0; i < b.table.length; i++)
	{
		subLengths += b.table[i].table.length;
	}

	var toRemove = a.table.length + b.table.length;
	return toRemove - (Math.floor((subLengths - 1) / M) + 1);
}

// get2, set2 and saveSlot are helpers for accessing elements over two arrays.
function get2(a, b, index)
{
	return index < a.length
		? a[index]
		: b[index - a.length];
}

function set2(a, b, index, value)
{
	if (index < a.length)
	{
		a[index] = value;
	}
	else
	{
		b[index - a.length] = value;
	}
}

function saveSlot(a, b, index, slot)
{
	set2(a.table, b.table, index, slot);

	var l = (index === 0 || index === a.lengths.length)
		? 0
		: get2(a.lengths, a.lengths, index - 1);

	set2(a.lengths, b.lengths, index, l + length(slot));
}

// Creates a node or leaf with a given length at their arrays for perfomance.
// Is only used by shuffle.
function createNode(h, length)
{
	if (length < 0)
	{
		length = 0;
	}
	var a = {
		ctor: '_Array',
		height: h,
		table: new Array(length)
	};
	if (h > 0)
	{
		a.lengths = new Array(length);
	}
	return a;
}

// Returns an array of two balanced nodes.
function shuffle(a, b, toRemove)
{
	var newA = createNode(a.height, Math.min(M, a.table.length + b.table.length - toRemove));
	var newB = createNode(a.height, newA.table.length - (a.table.length + b.table.length - toRemove));

	// Skip the slots with size M. More precise: copy the slot references
	// to the new node
	var read = 0;
	while (get2(a.table, b.table, read).table.length % M === 0)
	{
		set2(newA.table, newB.table, read, get2(a.table, b.table, read));
		set2(newA.lengths, newB.lengths, read, get2(a.lengths, b.lengths, read));
		read++;
	}

	// Pulling items from left to right, caching in a slot before writing
	// it into the new nodes.
	var write = read;
	var slot = new createNode(a.height - 1, 0);
	var from = 0;

	// If the current slot is still containing data, then there will be at
	// least one more write, so we do not break this loop yet.
	while (read - write - (slot.table.length > 0 ? 1 : 0) < toRemove)
	{
		// Find out the max possible items for copying.
		var source = get2(a.table, b.table, read);
		var to = Math.min(M - slot.table.length, source.table.length);

		// Copy and adjust size table.
		slot.table = slot.table.concat(source.table.slice(from, to));
		if (slot.height > 0)
		{
			var len = slot.lengths.length;
			for (var i = len; i < len + to - from; i++)
			{
				slot.lengths[i] = length(slot.table[i]);
				slot.lengths[i] += (i > 0 ? slot.lengths[i - 1] : 0);
			}
		}

		from += to;

		// Only proceed to next slots[i] if the current one was
		// fully copied.
		if (source.table.length <= to)
		{
			read++; from = 0;
		}

		// Only create a new slot if the current one is filled up.
		if (slot.table.length === M)
		{
			saveSlot(newA, newB, write, slot);
			slot = createNode(a.height - 1, 0);
			write++;
		}
	}

	// Cleanup after the loop. Copy the last slot into the new nodes.
	if (slot.table.length > 0)
	{
		saveSlot(newA, newB, write, slot);
		write++;
	}

	// Shift the untouched slots to the left
	while (read < a.table.length + b.table.length )
	{
		saveSlot(newA, newB, write, get2(a.table, b.table, read));
		read++;
		write++;
	}

	return [newA, newB];
}

// Navigation functions
function botRight(a)
{
	return a.table[a.table.length - 1];
}
function botLeft(a)
{
	return a.table[0];
}

// Copies a node for updating. Note that you should not use this if
// only updating only one of "table" or "lengths" for performance reasons.
function nodeCopy(a)
{
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: a.table.slice()
	};
	if (a.height > 0)
	{
		newA.lengths = a.lengths.slice();
	}
	return newA;
}

// Returns how many items are in the tree.
function length(array)
{
	if (array.height === 0)
	{
		return array.table.length;
	}
	else
	{
		return array.lengths[array.lengths.length - 1];
	}
}

// Calculates in which slot of "table" the item probably is, then
// find the exact slot via forward searching in  "lengths". Returns the index.
function getSlot(i, a)
{
	var slot = i >> (5 * a.height);
	while (a.lengths[slot] <= i)
	{
		slot++;
	}
	return slot;
}

// Recursively creates a tree with a given height containing
// only the given item.
function create(item, h)
{
	if (h === 0)
	{
		return {
			ctor: '_Array',
			height: 0,
			table: [item]
		};
	}
	return {
		ctor: '_Array',
		height: h,
		table: [create(item, h - 1)],
		lengths: [1]
	};
}

// Recursively creates a tree that contains the given tree.
function parentise(tree, h)
{
	if (h === tree.height)
	{
		return tree;
	}

	return {
		ctor: '_Array',
		height: h,
		table: [parentise(tree, h - 1)],
		lengths: [length(tree)]
	};
}

// Emphasizes blood brotherhood beneath two trees.
function siblise(a, b)
{
	return {
		ctor: '_Array',
		height: a.height + 1,
		table: [a, b],
		lengths: [length(a), length(a) + length(b)]
	};
}

function toJSArray(a)
{
	var jsArray = new Array(length(a));
	toJSArray_(jsArray, 0, a);
	return jsArray;
}

function toJSArray_(jsArray, i, a)
{
	for (var t = 0; t < a.table.length; t++)
	{
		if (a.height === 0)
		{
			jsArray[i + t] = a.table[t];
		}
		else
		{
			var inc = t === 0 ? 0 : a.lengths[t - 1];
			toJSArray_(jsArray, i + inc, a.table[t]);
		}
	}
}

function fromJSArray(jsArray)
{
	if (jsArray.length === 0)
	{
		return empty;
	}
	var h = Math.floor(Math.log(jsArray.length) / Math.log(M));
	return fromJSArray_(jsArray, h, 0, jsArray.length);
}

function fromJSArray_(jsArray, h, from, to)
{
	if (h === 0)
	{
		return {
			ctor: '_Array',
			height: 0,
			table: jsArray.slice(from, to)
		};
	}

	var step = Math.pow(M, h);
	var table = new Array(Math.ceil((to - from) / step));
	var lengths = new Array(table.length);
	for (var i = 0; i < table.length; i++)
	{
		table[i] = fromJSArray_(jsArray, h - 1, from + (i * step), Math.min(from + ((i + 1) * step), to));
		lengths[i] = length(table[i]) + (i > 0 ? lengths[i - 1] : 0);
	}
	return {
		ctor: '_Array',
		height: h,
		table: table,
		lengths: lengths
	};
}

return {
	empty: empty,
	fromList: fromList,
	toList: toList,
	initialize: F2(initialize),
	append: F2(append),
	push: F2(push),
	slice: F3(slice),
	get: F2(get),
	set: F3(set),
	map: F2(map),
	indexedMap: F2(indexedMap),
	foldl: F3(foldl),
	foldr: F3(foldr),
	length: length,

	toJSArray: toJSArray,
	fromJSArray: fromJSArray
};

}();
var _elm_lang$core$Array$append = _elm_lang$core$Native_Array.append;
var _elm_lang$core$Array$length = _elm_lang$core$Native_Array.length;
var _elm_lang$core$Array$isEmpty = function (array) {
	return _elm_lang$core$Native_Utils.eq(
		_elm_lang$core$Array$length(array),
		0);
};
var _elm_lang$core$Array$slice = _elm_lang$core$Native_Array.slice;
var _elm_lang$core$Array$set = _elm_lang$core$Native_Array.set;
var _elm_lang$core$Array$get = F2(
	function (i, array) {
		return ((_elm_lang$core$Native_Utils.cmp(0, i) < 1) && (_elm_lang$core$Native_Utils.cmp(
			i,
			_elm_lang$core$Native_Array.length(array)) < 0)) ? _elm_lang$core$Maybe$Just(
			A2(_elm_lang$core$Native_Array.get, i, array)) : _elm_lang$core$Maybe$Nothing;
	});
var _elm_lang$core$Array$push = _elm_lang$core$Native_Array.push;
var _elm_lang$core$Array$empty = _elm_lang$core$Native_Array.empty;
var _elm_lang$core$Array$filter = F2(
	function (isOkay, arr) {
		var update = F2(
			function (x, xs) {
				return isOkay(x) ? A2(_elm_lang$core$Native_Array.push, x, xs) : xs;
			});
		return A3(_elm_lang$core$Native_Array.foldl, update, _elm_lang$core$Native_Array.empty, arr);
	});
var _elm_lang$core$Array$foldr = _elm_lang$core$Native_Array.foldr;
var _elm_lang$core$Array$foldl = _elm_lang$core$Native_Array.foldl;
var _elm_lang$core$Array$indexedMap = _elm_lang$core$Native_Array.indexedMap;
var _elm_lang$core$Array$map = _elm_lang$core$Native_Array.map;
var _elm_lang$core$Array$toIndexedList = function (array) {
	return A3(
		_elm_lang$core$List$map2,
		F2(
			function (v0, v1) {
				return {ctor: '_Tuple2', _0: v0, _1: v1};
			}),
		_elm_lang$core$List$range.func(0, _elm_lang$core$Native_Array.length(array) - 1),
		_elm_lang$core$Native_Array.toList(array));
};
var _elm_lang$core$Array$toList = _elm_lang$core$Native_Array.toList;
var _elm_lang$core$Array$fromList = _elm_lang$core$Native_Array.fromList;
var _elm_lang$core$Array$initialize = _elm_lang$core$Native_Array.initialize;
var _elm_lang$core$Array$repeat = F2(
	function (n, e) {
		return A2(
			_elm_lang$core$Array$initialize,
			n,
			_elm_lang$core$Basics$always(e));
	});
var _elm_lang$core$Array$Array = {ctor: 'Array'};

var _elm_lang$core$Dict$foldr = F3(
	function (f, acc, t) {
		foldr:
		while (true) {
			var _p0 = t;
			if (_p0.ctor === 'RBEmpty_elm_builtin') {
				return acc;
			} else {
				var _v1 = f,
					_v2 = A3(
					f,
					_p0._1,
					_p0._2,
					_elm_lang$core$Dict$foldr.func(f, acc, _p0._4)),
					_v3 = _p0._3;
				f = _v1;
				acc = _v2;
				t = _v3;
				continue foldr;
			}
		}
	});
var _elm_lang$core$Dict$keys = function (dict) {
	return _elm_lang$core$Dict$foldr.func(F3(
        function (key, value, keyList) {
            return {ctor: '::', _0: key, _1: keyList};
        }), {ctor: '[]'}, dict);
};
var _elm_lang$core$Dict$values = function (dict) {
	return _elm_lang$core$Dict$foldr.func(F3(
        function (key, value, valueList) {
            return {ctor: '::', _0: value, _1: valueList};
        }), {ctor: '[]'}, dict);
};
var _elm_lang$core$Dict$toList = function (dict) {
	return _elm_lang$core$Dict$foldr.func(F3(
        function (key, value, list) {
            return {
                ctor: '::',
                _0: {ctor: '_Tuple2', _0: key, _1: value},
                _1: list
            };
        }), {ctor: '[]'}, dict);
};
var _elm_lang$core$Dict$foldl = F3(
	function (f, acc, dict) {
		foldl:
		while (true) {
			var _p1 = dict;
			if (_p1.ctor === 'RBEmpty_elm_builtin') {
				return acc;
			} else {
				var _v5 = f,
					_v6 = A3(
					f,
					_p1._1,
					_p1._2,
					_elm_lang$core$Dict$foldl.func(f, acc, _p1._3)),
					_v7 = _p1._4;
				f = _v5;
				acc = _v6;
				dict = _v7;
				continue foldl;
			}
		}
	});
var _elm_lang$core$Dict$merge = F6(
	function (leftStep, bothStep, rightStep, leftDict, rightDict, initialResult) {
		var stepState = F3(
			function (rKey, rValue, _p2) {
				stepState:
				while (true) {
					var _p3 = _p2;
					var _p9 = _p3._1;
					var _p8 = _p3._0;
					var _p4 = _p8;
					if (_p4.ctor === '[]') {
						return {
							ctor: '_Tuple2',
							_0: _p8,
							_1: A3(rightStep, rKey, rValue, _p9)
						};
					} else {
						var _p7 = _p4._1;
						var _p6 = _p4._0._1;
						var _p5 = _p4._0._0;
						if (_elm_lang$core$Native_Utils.cmp(_p5, rKey) < 0) {
							var _v10 = rKey,
								_v11 = rValue,
								_v12 = {
								ctor: '_Tuple2',
								_0: _p7,
								_1: A3(leftStep, _p5, _p6, _p9)
							};
							rKey = _v10;
							rValue = _v11;
							_p2 = _v12;
							continue stepState;
						} else {
							if (_elm_lang$core$Native_Utils.cmp(_p5, rKey) > 0) {
								return {
									ctor: '_Tuple2',
									_0: _p8,
									_1: A3(rightStep, rKey, rValue, _p9)
								};
							} else {
								return {
									ctor: '_Tuple2',
									_0: _p7,
									_1: A4(bothStep, _p5, _p6, rValue, _p9)
								};
							}
						}
					}
				}
			});
		var _p10 = _elm_lang$core$Dict$foldl.func(stepState, {
            ctor: '_Tuple2',
            _0: _elm_lang$core$Dict$toList(leftDict),
            _1: initialResult
        }, rightDict);
		var leftovers = _p10._0;
		var intermediateResult = _p10._1;
		return _elm_lang$core$List$foldl.func(F2(
            function (_p11, result) {
                var _p12 = _p11;
                return A3(leftStep, _p12._0, _p12._1, result);
            }), intermediateResult, leftovers);
	});
var _elm_lang$core$Dict$reportRemBug = F4(
	function (msg, c, lgot, rgot) {
		return _elm_lang$core$Native_Debug.crash(
			_elm_lang$core$String$concat(
				{
					ctor: '::',
					_0: 'Internal red-black tree invariant violated, expected ',
					_1: {
						ctor: '::',
						_0: msg,
						_1: {
							ctor: '::',
							_0: ' and got ',
							_1: {
								ctor: '::',
								_0: _elm_lang$core$Basics$toString(c),
								_1: {
									ctor: '::',
									_0: '/',
									_1: {
										ctor: '::',
										_0: lgot,
										_1: {
											ctor: '::',
											_0: '/',
											_1: {
												ctor: '::',
												_0: rgot,
												_1: {
													ctor: '::',
													_0: '\nPlease report this bug to <https://github.com/elm-lang/core/issues>',
													_1: {ctor: '[]'}
												}
											}
										}
									}
								}
							}
						}
					}
				}));
	});
var _elm_lang$core$Dict$isBBlack = function (dict) {
	var _p13 = dict;
	_v14_2:
	do {
		if (_p13.ctor === 'RBNode_elm_builtin') {
			if (_p13._0.ctor === 'BBlack') {
				return true;
			} else {
				break _v14_2;
			}
		} else {
			if (_p13._0.ctor === 'LBBlack') {
				return true;
			} else {
				break _v14_2;
			}
		}
	} while(false);
	return false;
};
var _elm_lang$core$Dict$sizeHelp = F2(
	function (n, dict) {
		sizeHelp:
		while (true) {
			var _p14 = dict;
			if (_p14.ctor === 'RBEmpty_elm_builtin') {
				return n;
			} else {
				var _v16 = _elm_lang$core$Dict$sizeHelp.func(n + 1, _p14._4),
					_v17 = _p14._3;
				n = _v16;
				dict = _v17;
				continue sizeHelp;
			}
		}
	});
var _elm_lang$core$Dict$size = function (dict) {
	return _elm_lang$core$Dict$sizeHelp.func(0, dict);
};
var _elm_lang$core$Dict$get = F2(
	function (targetKey, dict) {
		get:
		while (true) {
			var _p15 = dict;
			if (_p15.ctor === 'RBEmpty_elm_builtin') {
				return _elm_lang$core$Maybe$Nothing;
			} else {
				var _p16 = _elm_lang$core$Basics$compare.func(targetKey, _p15._1);
				switch (_p16.ctor) {
					case 'LT':
						var _v20 = targetKey,
							_v21 = _p15._3;
						targetKey = _v20;
						dict = _v21;
						continue get;
					case 'EQ':
						return _elm_lang$core$Maybe$Just(_p15._2);
					default:
						var _v22 = targetKey,
							_v23 = _p15._4;
						targetKey = _v22;
						dict = _v23;
						continue get;
				}
			}
		}
	});
var _elm_lang$core$Dict$member = F2(
	function (key, dict) {
		var _p17 = _elm_lang$core$Dict$get.func(key, dict);
		if (_p17.ctor === 'Just') {
			return true;
		} else {
			return false;
		}
	});
var _elm_lang$core$Dict$maxWithDefault = F3(
	function (k, v, r) {
		maxWithDefault:
		while (true) {
			var _p18 = r;
			if (_p18.ctor === 'RBEmpty_elm_builtin') {
				return {ctor: '_Tuple2', _0: k, _1: v};
			} else {
				var _v26 = _p18._1,
					_v27 = _p18._2,
					_v28 = _p18._4;
				k = _v26;
				v = _v27;
				r = _v28;
				continue maxWithDefault;
			}
		}
	});
var _elm_lang$core$Dict$NBlack = {ctor: 'NBlack'};
var _elm_lang$core$Dict$BBlack = {ctor: 'BBlack'};
var _elm_lang$core$Dict$Black = {ctor: 'Black'};
var _elm_lang$core$Dict$blackish = function (t) {
	var _p19 = t;
	if (_p19.ctor === 'RBNode_elm_builtin') {
		var _p20 = _p19._0;
		return _elm_lang$core$Native_Utils.eq(_p20, _elm_lang$core$Dict$Black) || _elm_lang$core$Native_Utils.eq(_p20, _elm_lang$core$Dict$BBlack);
	} else {
		return true;
	}
};
var _elm_lang$core$Dict$Red = {ctor: 'Red'};
var _elm_lang$core$Dict$moreBlack = function (color) {
	var _p21 = color;
	switch (_p21.ctor) {
		case 'Black':
			return _elm_lang$core$Dict$BBlack;
		case 'Red':
			return _elm_lang$core$Dict$Black;
		case 'NBlack':
			return _elm_lang$core$Dict$Red;
		default:
			return _elm_lang$core$Native_Debug.crash('Can\'t make a double black node more black!');
	}
};
var _elm_lang$core$Dict$lessBlack = function (color) {
	var _p22 = color;
	switch (_p22.ctor) {
		case 'BBlack':
			return _elm_lang$core$Dict$Black;
		case 'Black':
			return _elm_lang$core$Dict$Red;
		case 'Red':
			return _elm_lang$core$Dict$NBlack;
		default:
			return _elm_lang$core$Native_Debug.crash('Can\'t make a negative black node less black!');
	}
};
var _elm_lang$core$Dict$LBBlack = {ctor: 'LBBlack'};
var _elm_lang$core$Dict$LBlack = {ctor: 'LBlack'};
var _elm_lang$core$Dict$RBEmpty_elm_builtin = function (a) {
	return {ctor: 'RBEmpty_elm_builtin', _0: a};
};
var _elm_lang$core$Dict$empty = _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
var _elm_lang$core$Dict$isEmpty = function (dict) {
	return _elm_lang$core$Native_Utils.eq(dict, _elm_lang$core$Dict$empty);
};
var _elm_lang$core$Dict$RBNode_elm_builtin = F5(
	function (a, b, c, d, e) {
		return {ctor: 'RBNode_elm_builtin', _0: a, _1: b, _2: c, _3: d, _4: e};
	});
var _elm_lang$core$Dict$ensureBlackRoot = function (dict) {
	var _p23 = dict;
	if ((_p23.ctor === 'RBNode_elm_builtin') && (_p23._0.ctor === 'Red')) {
		return _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$Black, _p23._1, _p23._2, _p23._3, _p23._4);
	} else {
		return dict;
	}
};
var _elm_lang$core$Dict$lessBlackTree = function (dict) {
	var _p24 = dict;
	if (_p24.ctor === 'RBNode_elm_builtin') {
		return _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$lessBlack(_p24._0), _p24._1, _p24._2, _p24._3, _p24._4);
	} else {
		return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
	}
};
var _elm_lang$core$Dict$balancedTree = function (col) {
	return function (xk) {
		return function (xv) {
			return function (yk) {
				return function (yv) {
					return function (zk) {
						return function (zv) {
							return function (a) {
								return function (b) {
									return function (c) {
										return function (d) {
											return _elm_lang$core$Dict$RBNode_elm_builtin.func(
                                                _elm_lang$core$Dict$lessBlack(col),
                                                yk,
                                                yv,
                                                _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$Black, xk, xv, a, b),
                                                _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$Black, zk, zv, c, d)
                                            );
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var _elm_lang$core$Dict$blacken = function (t) {
	var _p25 = t;
	if (_p25.ctor === 'RBEmpty_elm_builtin') {
		return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
	} else {
		return _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$Black, _p25._1, _p25._2, _p25._3, _p25._4);
	}
};
var _elm_lang$core$Dict$redden = function (t) {
	var _p26 = t;
	if (_p26.ctor === 'RBEmpty_elm_builtin') {
		return _elm_lang$core$Native_Debug.crash('can\'t make a Leaf red');
	} else {
		return _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$Red, _p26._1, _p26._2, _p26._3, _p26._4);
	}
};
var _elm_lang$core$Dict$balanceHelp = function (tree) {
	var _p27 = tree;
	_v36_6:
	do {
		_v36_5:
		do {
			_v36_4:
			do {
				_v36_3:
				do {
					_v36_2:
					do {
						_v36_1:
						do {
							_v36_0:
							do {
								if (_p27.ctor === 'RBNode_elm_builtin') {
									if (_p27._3.ctor === 'RBNode_elm_builtin') {
										if (_p27._4.ctor === 'RBNode_elm_builtin') {
											switch (_p27._3._0.ctor) {
												case 'Red':
													switch (_p27._4._0.ctor) {
														case 'Red':
															if ((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Red')) {
																break _v36_0;
															} else {
																if ((_p27._3._4.ctor === 'RBNode_elm_builtin') && (_p27._3._4._0.ctor === 'Red')) {
																	break _v36_1;
																} else {
																	if ((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Red')) {
																		break _v36_2;
																	} else {
																		if ((_p27._4._4.ctor === 'RBNode_elm_builtin') && (_p27._4._4._0.ctor === 'Red')) {
																			break _v36_3;
																		} else {
																			break _v36_6;
																		}
																	}
																}
															}
														case 'NBlack':
															if ((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Red')) {
																break _v36_0;
															} else {
																if ((_p27._3._4.ctor === 'RBNode_elm_builtin') && (_p27._3._4._0.ctor === 'Red')) {
																	break _v36_1;
																} else {
																	if (((((_p27._0.ctor === 'BBlack') && (_p27._4._3.ctor === 'RBNode_elm_builtin')) && (_p27._4._3._0.ctor === 'Black')) && (_p27._4._4.ctor === 'RBNode_elm_builtin')) && (_p27._4._4._0.ctor === 'Black')) {
																		break _v36_4;
																	} else {
																		break _v36_6;
																	}
																}
															}
														default:
															if ((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Red')) {
																break _v36_0;
															} else {
																if ((_p27._3._4.ctor === 'RBNode_elm_builtin') && (_p27._3._4._0.ctor === 'Red')) {
																	break _v36_1;
																} else {
																	break _v36_6;
																}
															}
													}
												case 'NBlack':
													switch (_p27._4._0.ctor) {
														case 'Red':
															if ((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Red')) {
																break _v36_2;
															} else {
																if ((_p27._4._4.ctor === 'RBNode_elm_builtin') && (_p27._4._4._0.ctor === 'Red')) {
																	break _v36_3;
																} else {
																	if (((((_p27._0.ctor === 'BBlack') && (_p27._3._3.ctor === 'RBNode_elm_builtin')) && (_p27._3._3._0.ctor === 'Black')) && (_p27._3._4.ctor === 'RBNode_elm_builtin')) && (_p27._3._4._0.ctor === 'Black')) {
																		break _v36_5;
																	} else {
																		break _v36_6;
																	}
																}
															}
														case 'NBlack':
															if (_p27._0.ctor === 'BBlack') {
																if ((((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Black')) && (_p27._4._4.ctor === 'RBNode_elm_builtin')) && (_p27._4._4._0.ctor === 'Black')) {
																	break _v36_4;
																} else {
																	if ((((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Black')) && (_p27._3._4.ctor === 'RBNode_elm_builtin')) && (_p27._3._4._0.ctor === 'Black')) {
																		break _v36_5;
																	} else {
																		break _v36_6;
																	}
																}
															} else {
																break _v36_6;
															}
														default:
															if (((((_p27._0.ctor === 'BBlack') && (_p27._3._3.ctor === 'RBNode_elm_builtin')) && (_p27._3._3._0.ctor === 'Black')) && (_p27._3._4.ctor === 'RBNode_elm_builtin')) && (_p27._3._4._0.ctor === 'Black')) {
																break _v36_5;
															} else {
																break _v36_6;
															}
													}
												default:
													switch (_p27._4._0.ctor) {
														case 'Red':
															if ((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Red')) {
																break _v36_2;
															} else {
																if ((_p27._4._4.ctor === 'RBNode_elm_builtin') && (_p27._4._4._0.ctor === 'Red')) {
																	break _v36_3;
																} else {
																	break _v36_6;
																}
															}
														case 'NBlack':
															if (((((_p27._0.ctor === 'BBlack') && (_p27._4._3.ctor === 'RBNode_elm_builtin')) && (_p27._4._3._0.ctor === 'Black')) && (_p27._4._4.ctor === 'RBNode_elm_builtin')) && (_p27._4._4._0.ctor === 'Black')) {
																break _v36_4;
															} else {
																break _v36_6;
															}
														default:
															break _v36_6;
													}
											}
										} else {
											switch (_p27._3._0.ctor) {
												case 'Red':
													if ((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Red')) {
														break _v36_0;
													} else {
														if ((_p27._3._4.ctor === 'RBNode_elm_builtin') && (_p27._3._4._0.ctor === 'Red')) {
															break _v36_1;
														} else {
															break _v36_6;
														}
													}
												case 'NBlack':
													if (((((_p27._0.ctor === 'BBlack') && (_p27._3._3.ctor === 'RBNode_elm_builtin')) && (_p27._3._3._0.ctor === 'Black')) && (_p27._3._4.ctor === 'RBNode_elm_builtin')) && (_p27._3._4._0.ctor === 'Black')) {
														break _v36_5;
													} else {
														break _v36_6;
													}
												default:
													break _v36_6;
											}
										}
									} else {
										if (_p27._4.ctor === 'RBNode_elm_builtin') {
											switch (_p27._4._0.ctor) {
												case 'Red':
													if ((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Red')) {
														break _v36_2;
													} else {
														if ((_p27._4._4.ctor === 'RBNode_elm_builtin') && (_p27._4._4._0.ctor === 'Red')) {
															break _v36_3;
														} else {
															break _v36_6;
														}
													}
												case 'NBlack':
													if (((((_p27._0.ctor === 'BBlack') && (_p27._4._3.ctor === 'RBNode_elm_builtin')) && (_p27._4._3._0.ctor === 'Black')) && (_p27._4._4.ctor === 'RBNode_elm_builtin')) && (_p27._4._4._0.ctor === 'Black')) {
														break _v36_4;
													} else {
														break _v36_6;
													}
												default:
													break _v36_6;
											}
										} else {
											break _v36_6;
										}
									}
								} else {
									break _v36_6;
								}
							} while(false);
							return _elm_lang$core$Dict$balancedTree(_p27._0)(_p27._3._3._1)(_p27._3._3._2)(_p27._3._1)(_p27._3._2)(_p27._1)(_p27._2)(_p27._3._3._3)(_p27._3._3._4)(_p27._3._4)(_p27._4);
						} while(false);
						return _elm_lang$core$Dict$balancedTree(_p27._0)(_p27._3._1)(_p27._3._2)(_p27._3._4._1)(_p27._3._4._2)(_p27._1)(_p27._2)(_p27._3._3)(_p27._3._4._3)(_p27._3._4._4)(_p27._4);
					} while(false);
					return _elm_lang$core$Dict$balancedTree(_p27._0)(_p27._1)(_p27._2)(_p27._4._3._1)(_p27._4._3._2)(_p27._4._1)(_p27._4._2)(_p27._3)(_p27._4._3._3)(_p27._4._3._4)(_p27._4._4);
				} while(false);
				return _elm_lang$core$Dict$balancedTree(_p27._0)(_p27._1)(_p27._2)(_p27._4._1)(_p27._4._2)(_p27._4._4._1)(_p27._4._4._2)(_p27._3)(_p27._4._3)(_p27._4._4._3)(_p27._4._4._4);
			} while(false);
			return _elm_lang$core$Dict$RBNode_elm_builtin.func(
                _elm_lang$core$Dict$Black,
                _p27._4._3._1,
                _p27._4._3._2,
                _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$Black, _p27._1, _p27._2, _p27._3, _p27._4._3._3),
                _elm_lang$core$Dict$balance.func(
                    _elm_lang$core$Dict$Black,
                    _p27._4._1,
                    _p27._4._2,
                    _p27._4._3._4,
                    _elm_lang$core$Dict$redden(_p27._4._4)
                )
            );
		} while(false);
		return _elm_lang$core$Dict$RBNode_elm_builtin.func(
            _elm_lang$core$Dict$Black,
            _p27._3._4._1,
            _p27._3._4._2,
            _elm_lang$core$Dict$balance.func(
                _elm_lang$core$Dict$Black,
                _p27._3._1,
                _p27._3._2,
                _elm_lang$core$Dict$redden(_p27._3._3),
                _p27._3._4._3
            ),
            _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$Black, _p27._1, _p27._2, _p27._3._4._4, _p27._4)
        );
	} while(false);
	return tree;
};
var _elm_lang$core$Dict$balance = F5(
	function (c, k, v, l, r) {
		var tree = _elm_lang$core$Dict$RBNode_elm_builtin.func(c, k, v, l, r);
		return _elm_lang$core$Dict$blackish(tree) ? _elm_lang$core$Dict$balanceHelp(tree) : tree;
	});
var _elm_lang$core$Dict$bubble = F5(
	function (c, k, v, l, r) {
		return (_elm_lang$core$Dict$isBBlack(l) || _elm_lang$core$Dict$isBBlack(r)) ? _elm_lang$core$Dict$balance.func(
            _elm_lang$core$Dict$moreBlack(c),
            k,
            v,
            _elm_lang$core$Dict$lessBlackTree(l),
            _elm_lang$core$Dict$lessBlackTree(r)
        ) : _elm_lang$core$Dict$RBNode_elm_builtin.func(c, k, v, l, r);
	});
var _elm_lang$core$Dict$removeMax = F5(
	function (c, k, v, l, r) {
		var _p28 = r;
		if (_p28.ctor === 'RBEmpty_elm_builtin') {
			return _elm_lang$core$Dict$rem.func(c, l, r);
		} else {
			return _elm_lang$core$Dict$bubble.func(
                c,
                k,
                v,
                l,
                _elm_lang$core$Dict$removeMax.func(_p28._0, _p28._1, _p28._2, _p28._3, _p28._4)
            );
		}
	});
var _elm_lang$core$Dict$rem = F3(
	function (color, left, right) {
		var _p29 = {ctor: '_Tuple2', _0: left, _1: right};
		if (_p29._0.ctor === 'RBEmpty_elm_builtin') {
			if (_p29._1.ctor === 'RBEmpty_elm_builtin') {
				var _p30 = color;
				switch (_p30.ctor) {
					case 'Red':
						return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
					case 'Black':
						return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBBlack);
					default:
						return _elm_lang$core$Native_Debug.crash('cannot have bblack or nblack nodes at this point');
				}
			} else {
				var _p33 = _p29._1._0;
				var _p32 = _p29._0._0;
				var _p31 = {ctor: '_Tuple3', _0: color, _1: _p32, _2: _p33};
				if ((((_p31.ctor === '_Tuple3') && (_p31._0.ctor === 'Black')) && (_p31._1.ctor === 'LBlack')) && (_p31._2.ctor === 'Red')) {
					return _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$Black, _p29._1._1, _p29._1._2, _p29._1._3, _p29._1._4);
				} else {
					return _elm_lang$core$Dict$reportRemBug.func(
                        'Black/LBlack/Red',
                        color,
                        _elm_lang$core$Basics$toString(_p32),
                        _elm_lang$core$Basics$toString(_p33)
                    );
				}
			}
		} else {
			if (_p29._1.ctor === 'RBEmpty_elm_builtin') {
				var _p36 = _p29._1._0;
				var _p35 = _p29._0._0;
				var _p34 = {ctor: '_Tuple3', _0: color, _1: _p35, _2: _p36};
				if ((((_p34.ctor === '_Tuple3') && (_p34._0.ctor === 'Black')) && (_p34._1.ctor === 'Red')) && (_p34._2.ctor === 'LBlack')) {
					return _elm_lang$core$Dict$RBNode_elm_builtin.func(_elm_lang$core$Dict$Black, _p29._0._1, _p29._0._2, _p29._0._3, _p29._0._4);
				} else {
					return _elm_lang$core$Dict$reportRemBug.func(
                        'Black/Red/LBlack',
                        color,
                        _elm_lang$core$Basics$toString(_p35),
                        _elm_lang$core$Basics$toString(_p36)
                    );
				}
			} else {
				var _p40 = _p29._0._2;
				var _p39 = _p29._0._4;
				var _p38 = _p29._0._1;
				var newLeft = _elm_lang$core$Dict$removeMax.func(_p29._0._0, _p38, _p40, _p29._0._3, _p39);
				var _p37 = _elm_lang$core$Dict$maxWithDefault.func(_p38, _p40, _p39);
				var k = _p37._0;
				var v = _p37._1;
				return _elm_lang$core$Dict$bubble.func(color, k, v, newLeft, right);
			}
		}
	});
var _elm_lang$core$Dict$map = F2(
	function (f, dict) {
		var _p41 = dict;
		if (_p41.ctor === 'RBEmpty_elm_builtin') {
			return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
		} else {
			var _p42 = _p41._1;
			return _elm_lang$core$Dict$RBNode_elm_builtin.func(
                _p41._0,
                _p42,
                A2(f, _p42, _p41._2),
                _elm_lang$core$Dict$map.func(f, _p41._3),
                _elm_lang$core$Dict$map.func(f, _p41._4)
            );
		}
	});
var _elm_lang$core$Dict$Same = {ctor: 'Same'};
var _elm_lang$core$Dict$Remove = {ctor: 'Remove'};
var _elm_lang$core$Dict$Insert = {ctor: 'Insert'};
var _elm_lang$core$Dict$update = F3(
	function (k, alter, dict) {
		var up = function (dict) {
			var _p43 = dict;
			if (_p43.ctor === 'RBEmpty_elm_builtin') {
				var _p44 = alter(_elm_lang$core$Maybe$Nothing);
				if (_p44.ctor === 'Nothing') {
					return {ctor: '_Tuple2', _0: _elm_lang$core$Dict$Same, _1: _elm_lang$core$Dict$empty};
				} else {
					return {
						ctor: '_Tuple2',
						_0: _elm_lang$core$Dict$Insert,
						_1: _elm_lang$core$Dict$RBNode_elm_builtin.func(
                            _elm_lang$core$Dict$Red,
                            k,
                            _p44._0,
                            _elm_lang$core$Dict$empty,
                            _elm_lang$core$Dict$empty
                        )
					};
				}
			} else {
				var _p55 = _p43._2;
				var _p54 = _p43._4;
				var _p53 = _p43._3;
				var _p52 = _p43._1;
				var _p51 = _p43._0;
				var _p45 = _elm_lang$core$Basics$compare.func(k, _p52);
				switch (_p45.ctor) {
					case 'EQ':
						var _p46 = alter(
							_elm_lang$core$Maybe$Just(_p55));
						if (_p46.ctor === 'Nothing') {
							return {
								ctor: '_Tuple2',
								_0: _elm_lang$core$Dict$Remove,
								_1: _elm_lang$core$Dict$rem.func(_p51, _p53, _p54)
							};
						} else {
							return {
								ctor: '_Tuple2',
								_0: _elm_lang$core$Dict$Same,
								_1: _elm_lang$core$Dict$RBNode_elm_builtin.func(_p51, _p52, _p46._0, _p53, _p54)
							};
						}
					case 'LT':
						var _p47 = up(_p53);
						var flag = _p47._0;
						var newLeft = _p47._1;
						var _p48 = flag;
						switch (_p48.ctor) {
							case 'Same':
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Same,
									_1: _elm_lang$core$Dict$RBNode_elm_builtin.func(_p51, _p52, _p55, newLeft, _p54)
								};
							case 'Insert':
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Insert,
									_1: _elm_lang$core$Dict$balance.func(_p51, _p52, _p55, newLeft, _p54)
								};
							default:
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Remove,
									_1: _elm_lang$core$Dict$bubble.func(_p51, _p52, _p55, newLeft, _p54)
								};
						}
					default:
						var _p49 = up(_p54);
						var flag = _p49._0;
						var newRight = _p49._1;
						var _p50 = flag;
						switch (_p50.ctor) {
							case 'Same':
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Same,
									_1: _elm_lang$core$Dict$RBNode_elm_builtin.func(_p51, _p52, _p55, _p53, newRight)
								};
							case 'Insert':
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Insert,
									_1: _elm_lang$core$Dict$balance.func(_p51, _p52, _p55, _p53, newRight)
								};
							default:
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Remove,
									_1: _elm_lang$core$Dict$bubble.func(_p51, _p52, _p55, _p53, newRight)
								};
						}
				}
			}
		};
		var _p56 = up(dict);
		var flag = _p56._0;
		var updatedDict = _p56._1;
		var _p57 = flag;
		switch (_p57.ctor) {
			case 'Same':
				return updatedDict;
			case 'Insert':
				return _elm_lang$core$Dict$ensureBlackRoot(updatedDict);
			default:
				return _elm_lang$core$Dict$blacken(updatedDict);
		}
	});
var _elm_lang$core$Dict$insert = F3(
	function (key, value, dict) {
		return _elm_lang$core$Dict$update.func(key, _elm_lang$core$Basics$always(
            _elm_lang$core$Maybe$Just(value)), dict);
	});
var _elm_lang$core$Dict$singleton = F2(
	function (key, value) {
		return _elm_lang$core$Dict$insert.func(key, value, _elm_lang$core$Dict$empty);
	});
var _elm_lang$core$Dict$union = F2(
	function (t1, t2) {
		return _elm_lang$core$Dict$foldl.func(_elm_lang$core$Dict$insert, t2, t1);
	});
var _elm_lang$core$Dict$filter = F2(
	function (predicate, dictionary) {
		var add = F3(
			function (key, value, dict) {
				return A2(predicate, key, value) ? _elm_lang$core$Dict$insert.func(key, value, dict) : dict;
			});
		return _elm_lang$core$Dict$foldl.func(add, _elm_lang$core$Dict$empty, dictionary);
	});
var _elm_lang$core$Dict$intersect = F2(
	function (t1, t2) {
		return _elm_lang$core$Dict$filter.func(F2(
            function (k, _p58) {
                return _elm_lang$core$Dict$member.func(k, t2);
            }), t1);
	});
var _elm_lang$core$Dict$partition = F2(
	function (predicate, dict) {
		var add = F3(
			function (key, value, _p59) {
				var _p60 = _p59;
				var _p62 = _p60._1;
				var _p61 = _p60._0;
				return A2(predicate, key, value) ? {
					ctor: '_Tuple2',
					_0: _elm_lang$core$Dict$insert.func(key, value, _p61),
					_1: _p62
				} : {
					ctor: '_Tuple2',
					_0: _p61,
					_1: _elm_lang$core$Dict$insert.func(key, value, _p62)
				};
			});
		return _elm_lang$core$Dict$foldl.func(
            add,
            {ctor: '_Tuple2', _0: _elm_lang$core$Dict$empty, _1: _elm_lang$core$Dict$empty},
            dict
        );
	});
var _elm_lang$core$Dict$fromList = function (assocs) {
	return _elm_lang$core$List$foldl.func(F2(
        function (_p63, dict) {
            var _p64 = _p63;
            return _elm_lang$core$Dict$insert.func(_p64._0, _p64._1, dict);
        }), _elm_lang$core$Dict$empty, assocs);
};
var _elm_lang$core$Dict$remove = F2(
	function (key, dict) {
		return _elm_lang$core$Dict$update.func(key, _elm_lang$core$Basics$always(_elm_lang$core$Maybe$Nothing), dict);
	});
var _elm_lang$core$Dict$diff = F2(
	function (t1, t2) {
		return _elm_lang$core$Dict$foldl.func(F3(
            function (k, v, t) {
                return _elm_lang$core$Dict$remove.func(k, t);
            }), t1, t2);
	});

//import Maybe, Native.Array, Native.List, Native.Utils, Result //

var _elm_lang$core$Native_Json = function() {


// CORE DECODERS

function succeed(msg)
{
	return {
		ctor: '<decoder>',
		tag: 'succeed',
		msg: msg
	};
}

function fail(msg)
{
	return {
		ctor: '<decoder>',
		tag: 'fail',
		msg: msg
	};
}

function decodePrimitive(tag)
{
	return {
		ctor: '<decoder>',
		tag: tag
	};
}

function decodeContainer(tag, decoder)
{
	return {
		ctor: '<decoder>',
		tag: tag,
		decoder: decoder
	};
}

function decodeNull(value)
{
	return {
		ctor: '<decoder>',
		tag: 'null',
		value: value
	};
}

function decodeField(field, decoder)
{
	return {
		ctor: '<decoder>',
		tag: 'field',
		field: field,
		decoder: decoder
	};
}

function decodeIndex(index, decoder)
{
	return {
		ctor: '<decoder>',
		tag: 'index',
		index: index,
		decoder: decoder
	};
}

function decodeKeyValuePairs(decoder)
{
	return {
		ctor: '<decoder>',
		tag: 'key-value',
		decoder: decoder
	};
}

function mapMany(f, decoders)
{
	return {
		ctor: '<decoder>',
		tag: 'map-many',
		func: f,
		decoders: decoders
	};
}

function andThen(callback, decoder)
{
	return {
		ctor: '<decoder>',
		tag: 'andThen',
		decoder: decoder,
		callback: callback
	};
}

function oneOf(decoders)
{
	return {
		ctor: '<decoder>',
		tag: 'oneOf',
		decoders: decoders
	};
}


// DECODING OBJECTS

function map1(f, d1)
{
	return mapMany(f, [d1]);
}

function map2(f, d1, d2)
{
	return mapMany(f, [d1, d2]);
}

function map3(f, d1, d2, d3)
{
	return mapMany(f, [d1, d2, d3]);
}

function map4(f, d1, d2, d3, d4)
{
	return mapMany(f, [d1, d2, d3, d4]);
}

function map5(f, d1, d2, d3, d4, d5)
{
	return mapMany(f, [d1, d2, d3, d4, d5]);
}

function map6(f, d1, d2, d3, d4, d5, d6)
{
	return mapMany(f, [d1, d2, d3, d4, d5, d6]);
}

function map7(f, d1, d2, d3, d4, d5, d6, d7)
{
	return mapMany(f, [d1, d2, d3, d4, d5, d6, d7]);
}

function map8(f, d1, d2, d3, d4, d5, d6, d7, d8)
{
	return mapMany(f, [d1, d2, d3, d4, d5, d6, d7, d8]);
}


// DECODE HELPERS

function ok(value)
{
	return { tag: 'ok', value: value };
}

function badPrimitive(type, value)
{
	return { tag: 'primitive', type: type, value: value };
}

function badIndex(index, nestedProblems)
{
	return { tag: 'index', index: index, rest: nestedProblems };
}

function badField(field, nestedProblems)
{
	return { tag: 'field', field: field, rest: nestedProblems };
}

function badIndex(index, nestedProblems)
{
	return { tag: 'index', index: index, rest: nestedProblems };
}

function badOneOf(problems)
{
	return { tag: 'oneOf', problems: problems };
}

function bad(msg)
{
	return { tag: 'fail', msg: msg };
}

function badToString(problem)
{
	var context = '_';
	while (problem)
	{
		switch (problem.tag)
		{
			case 'primitive':
				return 'Expecting ' + problem.type
					+ (context === '_' ? '' : ' at ' + context)
					+ ' but instead got: ' + jsToString(problem.value);

			case 'index':
				context += '[' + problem.index + ']';
				problem = problem.rest;
				break;

			case 'field':
				context += '.' + problem.field;
				problem = problem.rest;
				break;

			case 'oneOf':
				var problems = problem.problems;
				for (var i = 0; i < problems.length; i++)
				{
					problems[i] = badToString(problems[i]);
				}
				return 'I ran into the following problems'
					+ (context === '_' ? '' : ' at ' + context)
					+ ':\n\n' + problems.join('\n');

			case 'fail':
				return 'I ran into a `fail` decoder'
					+ (context === '_' ? '' : ' at ' + context)
					+ ': ' + problem.msg;
		}
	}
}

function jsToString(value)
{
	return value === undefined
		? 'undefined'
		: JSON.stringify(value);
}


// DECODE

function runOnString(decoder, string)
{
	var json;
	try
	{
		json = JSON.parse(string);
	}
	catch (e)
	{
		return _elm_lang$core$Result$Err('Given an invalid JSON: ' + e.message);
	}
	return run(decoder, json);
}

function run(decoder, value)
{
	var result = runHelp(decoder, value);
	return (result.tag === 'ok')
		? _elm_lang$core$Result$Ok(result.value)
		: _elm_lang$core$Result$Err(badToString(result));
}

function runHelp(decoder, value)
{
	switch (decoder.tag)
	{
		case 'bool':
			return (typeof value === 'boolean')
				? ok(value)
				: badPrimitive('a Bool', value);

		case 'int':
			if (typeof value !== 'number') {
				return badPrimitive('an Int', value);
			}

			if (-2147483647 < value && value < 2147483647 && (value | 0) === value) {
				return ok(value);
			}

			if (isFinite(value) && !(value % 1)) {
				return ok(value);
			}

			return badPrimitive('an Int', value);

		case 'float':
			return (typeof value === 'number')
				? ok(value)
				: badPrimitive('a Float', value);

		case 'string':
			return (typeof value === 'string')
				? ok(value)
				: (value instanceof String)
					? ok(value + '')
					: badPrimitive('a String', value);

		case 'null':
			return (value === null)
				? ok(decoder.value)
				: badPrimitive('null', value);

		case 'value':
			return ok(value);

		case 'list':
			if (!(value instanceof Array))
			{
				return badPrimitive('a List', value);
			}

			var list = _elm_lang$core$Native_List.Nil;
			for (var i = value.length; i--; )
			{
				var result = runHelp(decoder.decoder, value[i]);
				if (result.tag !== 'ok')
				{
					return badIndex(i, result)
				}
				list = _elm_lang$core$Native_List.Cons(result.value, list);
			}
			return ok(list);

		case 'array':
			if (!(value instanceof Array))
			{
				return badPrimitive('an Array', value);
			}

			var len = value.length;
			var array = new Array(len);
			for (var i = len; i--; )
			{
				var result = runHelp(decoder.decoder, value[i]);
				if (result.tag !== 'ok')
				{
					return badIndex(i, result);
				}
				array[i] = result.value;
			}
			return ok(_elm_lang$core$Native_Array.fromJSArray(array));

		case 'maybe':
			var result = runHelp(decoder.decoder, value);
			return (result.tag === 'ok')
				? ok(_elm_lang$core$Maybe$Just(result.value))
				: ok(_elm_lang$core$Maybe$Nothing);

		case 'field':
			var field = decoder.field;
			if (typeof value !== 'object' || value === null || !(field in value))
			{
				return badPrimitive('an object with a field named `' + field + '`', value);
			}

			var result = runHelp(decoder.decoder, value[field]);
			return (result.tag === 'ok') ? result : badField(field, result);

		case 'index':
			var index = decoder.index;
			if (!(value instanceof Array))
			{
				return badPrimitive('an array', value);
			}
			if (index >= value.length)
			{
				return badPrimitive('a longer array. Need index ' + index + ' but there are only ' + value.length + ' entries', value);
			}

			var result = runHelp(decoder.decoder, value[index]);
			return (result.tag === 'ok') ? result : badIndex(index, result);

		case 'key-value':
			if (typeof value !== 'object' || value === null || value instanceof Array)
			{
				return badPrimitive('an object', value);
			}

			var keyValuePairs = _elm_lang$core$Native_List.Nil;
			for (var key in value)
			{
				var result = runHelp(decoder.decoder, value[key]);
				if (result.tag !== 'ok')
				{
					return badField(key, result);
				}
				var pair = _elm_lang$core$Native_Utils.Tuple2(key, result.value);
				keyValuePairs = _elm_lang$core$Native_List.Cons(pair, keyValuePairs);
			}
			return ok(keyValuePairs);

		case 'map-many':
			var answer = decoder.func;
			var decoders = decoder.decoders;
			for (var i = 0; i < decoders.length; i++)
			{
				var result = runHelp(decoders[i], value);
				if (result.tag !== 'ok')
				{
					return result;
				}
				answer = answer(result.value);
			}
			return ok(answer);

		case 'andThen':
			var result = runHelp(decoder.decoder, value);
			return (result.tag !== 'ok')
				? result
				: runHelp(decoder.callback(result.value), value);

		case 'oneOf':
			var errors = [];
			var temp = decoder.decoders;
			while (temp.ctor !== '[]')
			{
				var result = runHelp(temp._0, value);

				if (result.tag === 'ok')
				{
					return result;
				}

				errors.push(result);

				temp = temp._1;
			}
			return badOneOf(errors);

		case 'fail':
			return bad(decoder.msg);

		case 'succeed':
			return ok(decoder.msg);
	}
}


// EQUALITY

function equality(a, b)
{
	if (a === b)
	{
		return true;
	}

	if (a.tag !== b.tag)
	{
		return false;
	}

	switch (a.tag)
	{
		case 'succeed':
		case 'fail':
			return a.msg === b.msg;

		case 'bool':
		case 'int':
		case 'float':
		case 'string':
		case 'value':
			return true;

		case 'null':
			return a.value === b.value;

		case 'list':
		case 'array':
		case 'maybe':
		case 'key-value':
			return equality(a.decoder, b.decoder);

		case 'field':
			return a.field === b.field && equality(a.decoder, b.decoder);

		case 'index':
			return a.index === b.index && equality(a.decoder, b.decoder);

		case 'map-many':
			if (a.func !== b.func)
			{
				return false;
			}
			return listEquality(a.decoders, b.decoders);

		case 'andThen':
			return a.callback === b.callback && equality(a.decoder, b.decoder);

		case 'oneOf':
			return listEquality(a.decoders, b.decoders);
	}
}

function listEquality(aDecoders, bDecoders)
{
	var len = aDecoders.length;
	if (len !== bDecoders.length)
	{
		return false;
	}
	for (var i = 0; i < len; i++)
	{
		if (!equality(aDecoders[i], bDecoders[i]))
		{
			return false;
		}
	}
	return true;
}


// ENCODE

function encode(indentLevel, value)
{
	return JSON.stringify(value, null, indentLevel);
}

function identity(value)
{
	return value;
}

function encodeObject(keyValuePairs)
{
	var obj = {};
	while (keyValuePairs.ctor !== '[]')
	{
		var pair = keyValuePairs._0;
		obj[pair._0] = pair._1;
		keyValuePairs = keyValuePairs._1;
	}
	return obj;
}

return {
	encode: F2(encode),
	runOnString: F2(runOnString),
	run: F2(run),

	decodeNull: decodeNull,
	decodePrimitive: decodePrimitive,
	decodeContainer: F2(decodeContainer),

	decodeField: F2(decodeField),
	decodeIndex: F2(decodeIndex),

	map1: F2(map1),
	map2: F3(map2),
	map3: F4(map3),
	map4: F5(map4),
	map5: F6(map5),
	map6: F7(map6),
	map7: F8(map7),
	map8: F9(map8),
	decodeKeyValuePairs: decodeKeyValuePairs,

	andThen: F2(andThen),
	fail: fail,
	succeed: succeed,
	oneOf: oneOf,

	identity: identity,
	encodeNull: null,
	encodeArray: _elm_lang$core$Native_Array.toJSArray,
	encodeList: _elm_lang$core$Native_List.toArray,
	encodeObject: encodeObject,

	equality: equality
};

}();

var _elm_lang$core$Json_Encode$list = _elm_lang$core$Native_Json.encodeList;
var _elm_lang$core$Json_Encode$array = _elm_lang$core$Native_Json.encodeArray;
var _elm_lang$core$Json_Encode$object = _elm_lang$core$Native_Json.encodeObject;
var _elm_lang$core$Json_Encode$null = _elm_lang$core$Native_Json.encodeNull;
var _elm_lang$core$Json_Encode$bool = _elm_lang$core$Native_Json.identity;
var _elm_lang$core$Json_Encode$float = _elm_lang$core$Native_Json.identity;
var _elm_lang$core$Json_Encode$int = _elm_lang$core$Native_Json.identity;
var _elm_lang$core$Json_Encode$string = _elm_lang$core$Native_Json.identity;
var _elm_lang$core$Json_Encode$encode = _elm_lang$core$Native_Json.encode;
var _elm_lang$core$Json_Encode$Value = {ctor: 'Value'};

var _elm_lang$core$Json_Decode$null = _elm_lang$core$Native_Json.decodeNull;
var _elm_lang$core$Json_Decode$value = _elm_lang$core$Native_Json.decodePrimitive('value');
var _elm_lang$core$Json_Decode$andThen = _elm_lang$core$Native_Json.andThen;
var _elm_lang$core$Json_Decode$fail = _elm_lang$core$Native_Json.fail;
var _elm_lang$core$Json_Decode$succeed = _elm_lang$core$Native_Json.succeed;
var _elm_lang$core$Json_Decode$lazy = function (thunk) {
	return A2(
		_elm_lang$core$Json_Decode$andThen,
		thunk,
		_elm_lang$core$Json_Decode$succeed(
			{ctor: '_Tuple0'}));
};
var _elm_lang$core$Json_Decode$decodeValue = _elm_lang$core$Native_Json.run;
var _elm_lang$core$Json_Decode$decodeString = _elm_lang$core$Native_Json.runOnString;
var _elm_lang$core$Json_Decode$map8 = _elm_lang$core$Native_Json.map8;
var _elm_lang$core$Json_Decode$map7 = _elm_lang$core$Native_Json.map7;
var _elm_lang$core$Json_Decode$map6 = _elm_lang$core$Native_Json.map6;
var _elm_lang$core$Json_Decode$map5 = _elm_lang$core$Native_Json.map5;
var _elm_lang$core$Json_Decode$map4 = _elm_lang$core$Native_Json.map4;
var _elm_lang$core$Json_Decode$map3 = _elm_lang$core$Native_Json.map3;
var _elm_lang$core$Json_Decode$map2 = _elm_lang$core$Native_Json.map2;
var _elm_lang$core$Json_Decode$map = _elm_lang$core$Native_Json.map1;
var _elm_lang$core$Json_Decode$oneOf = _elm_lang$core$Native_Json.oneOf;
var _elm_lang$core$Json_Decode$maybe = function (decoder) {
	return A2(_elm_lang$core$Native_Json.decodeContainer, 'maybe', decoder);
};
var _elm_lang$core$Json_Decode$index = _elm_lang$core$Native_Json.decodeIndex;
var _elm_lang$core$Json_Decode$field = _elm_lang$core$Native_Json.decodeField;
var _elm_lang$core$Json_Decode$at = F2(
	function (fields, decoder) {
		return A3(_elm_lang$core$List$foldr, _elm_lang$core$Json_Decode$field, decoder, fields);
	});
var _elm_lang$core$Json_Decode$keyValuePairs = _elm_lang$core$Native_Json.decodeKeyValuePairs;
var _elm_lang$core$Json_Decode$dict = function (decoder) {
	return A2(
		_elm_lang$core$Json_Decode$map,
		_elm_lang$core$Dict$fromList,
		_elm_lang$core$Json_Decode$keyValuePairs(decoder));
};
var _elm_lang$core$Json_Decode$array = function (decoder) {
	return A2(_elm_lang$core$Native_Json.decodeContainer, 'array', decoder);
};
var _elm_lang$core$Json_Decode$list = function (decoder) {
	return A2(_elm_lang$core$Native_Json.decodeContainer, 'list', decoder);
};
var _elm_lang$core$Json_Decode$nullable = function (decoder) {
	return _elm_lang$core$Json_Decode$oneOf(
		{
			ctor: '::',
			_0: _elm_lang$core$Json_Decode$null(_elm_lang$core$Maybe$Nothing),
			_1: {
				ctor: '::',
				_0: A2(_elm_lang$core$Json_Decode$map, _elm_lang$core$Maybe$Just, decoder),
				_1: {ctor: '[]'}
			}
		});
};
var _elm_lang$core$Json_Decode$float = _elm_lang$core$Native_Json.decodePrimitive('float');
var _elm_lang$core$Json_Decode$int = _elm_lang$core$Native_Json.decodePrimitive('int');
var _elm_lang$core$Json_Decode$bool = _elm_lang$core$Native_Json.decodePrimitive('bool');
var _elm_lang$core$Json_Decode$string = _elm_lang$core$Native_Json.decodePrimitive('string');
var _elm_lang$core$Json_Decode$Decoder = {ctor: 'Decoder'};

var _elm_lang$virtual_dom$VirtualDom_Debug$wrap;
var _elm_lang$virtual_dom$VirtualDom_Debug$wrapWithFlags;

var _elm_lang$virtual_dom$Native_VirtualDom = function() {

var STYLE_KEY = 'STYLE';
var EVENT_KEY = 'EVENT';
var ATTR_KEY = 'ATTR';
var ATTR_NS_KEY = 'ATTR_NS';

var localDoc = typeof document !== 'undefined' ? document : {};


////////////  VIRTUAL DOM NODES  ////////////


function text(string)
{
	return {
		type: 'text',
		text: string
	};
}


function node(tag)
{
	return F2(function(factList, kidList) {
		return nodeHelp(tag, factList, kidList);
	});
}


function nodeHelp(tag, factList, kidList)
{
	var organized = organizeFacts(factList);
	var namespace = organized.namespace;
	var facts = organized.facts;

	var children = [];
	var descendantsCount = 0;
	while (kidList.ctor !== '[]')
	{
		var kid = kidList._0;
		descendantsCount += (kid.descendantsCount || 0);
		children.push(kid);
		kidList = kidList._1;
	}
	descendantsCount += children.length;

	return {
		type: 'node',
		tag: tag,
		facts: facts,
		children: children,
		namespace: namespace,
		descendantsCount: descendantsCount
	};
}


function keyedNode(tag, factList, kidList)
{
	var organized = organizeFacts(factList);
	var namespace = organized.namespace;
	var facts = organized.facts;

	var children = [];
	var descendantsCount = 0;
	while (kidList.ctor !== '[]')
	{
		var kid = kidList._0;
		descendantsCount += (kid._1.descendantsCount || 0);
		children.push(kid);
		kidList = kidList._1;
	}
	descendantsCount += children.length;

	return {
		type: 'keyed-node',
		tag: tag,
		facts: facts,
		children: children,
		namespace: namespace,
		descendantsCount: descendantsCount
	};
}


function custom(factList, model, impl)
{
	var facts = organizeFacts(factList).facts;

	return {
		type: 'custom',
		facts: facts,
		model: model,
		impl: impl
	};
}


function map(tagger, node)
{
	return {
		type: 'tagger',
		tagger: tagger,
		node: node,
		descendantsCount: 1 + (node.descendantsCount || 0)
	};
}


function thunk(func, args, thunk)
{
	return {
		type: 'thunk',
		func: func,
		args: args,
		thunk: thunk,
		node: undefined
	};
}

function lazy(fn, a)
{
	return thunk(fn, [a], function() {
		return fn(a);
	});
}

function lazy2(fn, a, b)
{
	return thunk(fn, [a,b], function() {
		return A2(fn, a, b);
	});
}

function lazy3(fn, a, b, c)
{
	return thunk(fn, [a,b,c], function() {
		return A3(fn, a, b, c);
	});
}



// FACTS


function organizeFacts(factList)
{
	var namespace, facts = {};

	while (factList.ctor !== '[]')
	{
		var entry = factList._0;
		var key = entry.key;

		if (key === ATTR_KEY || key === ATTR_NS_KEY || key === EVENT_KEY)
		{
			var subFacts = facts[key] || {};
			subFacts[entry.realKey] = entry.value;
			facts[key] = subFacts;
		}
		else if (key === STYLE_KEY)
		{
			var styles = facts[key] || {};
			var styleList = entry.value;
			while (styleList.ctor !== '[]')
			{
				var style = styleList._0;
				styles[style._0] = style._1;
				styleList = styleList._1;
			}
			facts[key] = styles;
		}
		else if (key === 'namespace')
		{
			namespace = entry.value;
		}
		else if (key === 'className')
		{
			var classes = facts[key];
			facts[key] = typeof classes === 'undefined'
				? entry.value
				: classes + ' ' + entry.value;
		}
 		else
		{
			facts[key] = entry.value;
		}
		factList = factList._1;
	}

	return {
		facts: facts,
		namespace: namespace
	};
}



////////////  PROPERTIES AND ATTRIBUTES  ////////////


function style(value)
{
	return {
		key: STYLE_KEY,
		value: value
	};
}


function property(key, value)
{
	return {
		key: key,
		value: value
	};
}


function attribute(key, value)
{
	return {
		key: ATTR_KEY,
		realKey: key,
		value: value
	};
}


function attributeNS(namespace, key, value)
{
	return {
		key: ATTR_NS_KEY,
		realKey: key,
		value: {
			value: value,
			namespace: namespace
		}
	};
}


function on(name, options, decoder)
{
	return {
		key: EVENT_KEY,
		realKey: name,
		value: {
			options: options,
			decoder: decoder
		}
	};
}


function equalEvents(a, b)
{
	if (a.options !== b.options)
	{
		if (a.options.stopPropagation !== b.options.stopPropagation || a.options.preventDefault !== b.options.preventDefault)
		{
			return false;
		}
	}
	return _elm_lang$core$Native_Json.equality(a.decoder, b.decoder);
}


function mapProperty(func, property)
{
	if (property.key !== EVENT_KEY)
	{
		return property;
	}
	return on(
		property.realKey,
		property.value.options,
		A2(_elm_lang$core$Json_Decode$map, func, property.value.decoder)
	);
}


////////////  RENDER  ////////////


function render(vNode, eventNode)
{
	switch (vNode.type)
	{
		case 'thunk':
			if (!vNode.node)
			{
				vNode.node = vNode.thunk();
			}
			return render(vNode.node, eventNode);

		case 'tagger':
			var subNode = vNode.node;
			var tagger = vNode.tagger;

			while (subNode.type === 'tagger')
			{
				typeof tagger !== 'object'
					? tagger = [tagger, subNode.tagger]
					: tagger.push(subNode.tagger);

				subNode = subNode.node;
			}

			var subEventRoot = { tagger: tagger, parent: eventNode };
			var domNode = render(subNode, subEventRoot);
			domNode.elm_event_node_ref = subEventRoot;
			return domNode;

		case 'text':
			return localDoc.createTextNode(vNode.text);

		case 'node':
			var domNode = vNode.namespace
				? localDoc.createElementNS(vNode.namespace, vNode.tag)
				: localDoc.createElement(vNode.tag);

			applyFacts(domNode, eventNode, vNode.facts);

			var children = vNode.children;

			for (var i = 0; i < children.length; i++)
			{
				domNode.appendChild(render(children[i], eventNode));
			}

			return domNode;

		case 'keyed-node':
			var domNode = vNode.namespace
				? localDoc.createElementNS(vNode.namespace, vNode.tag)
				: localDoc.createElement(vNode.tag);

			applyFacts(domNode, eventNode, vNode.facts);

			var children = vNode.children;

			for (var i = 0; i < children.length; i++)
			{
				domNode.appendChild(render(children[i]._1, eventNode));
			}

			return domNode;

		case 'custom':
			var domNode = vNode.impl.render(vNode.model);
			applyFacts(domNode, eventNode, vNode.facts);
			return domNode;
	}
}



////////////  APPLY FACTS  ////////////


function applyFacts(domNode, eventNode, facts)
{
	for (var key in facts)
	{
		var value = facts[key];

		switch (key)
		{
			case STYLE_KEY:
				applyStyles(domNode, value);
				break;

			case EVENT_KEY:
				applyEvents(domNode, eventNode, value);
				break;

			case ATTR_KEY:
				applyAttrs(domNode, value);
				break;

			case ATTR_NS_KEY:
				applyAttrsNS(domNode, value);
				break;

			case 'value':
				if (domNode[key] !== value)
				{
					domNode[key] = value;
				}
				break;

			default:
				domNode[key] = value;
				break;
		}
	}
}

function applyStyles(domNode, styles)
{
	var domNodeStyle = domNode.style;

	for (var key in styles)
	{
		domNodeStyle[key] = styles[key];
	}
}

function applyEvents(domNode, eventNode, events)
{
	var allHandlers = domNode.elm_handlers || {};

	for (var key in events)
	{
		var handler = allHandlers[key];
		var value = events[key];

		if (typeof value === 'undefined')
		{
			domNode.removeEventListener(key, handler);
			allHandlers[key] = undefined;
		}
		else if (typeof handler === 'undefined')
		{
			var handler = makeEventHandler(eventNode, value);
			domNode.addEventListener(key, handler);
			allHandlers[key] = handler;
		}
		else
		{
			handler.info = value;
		}
	}

	domNode.elm_handlers = allHandlers;
}

function makeEventHandler(eventNode, info)
{
	function eventHandler(event)
	{
		var info = eventHandler.info;

		var value = A2(_elm_lang$core$Native_Json.run, info.decoder, event);

		if (value.ctor === 'Ok')
		{
			var options = info.options;
			if (options.stopPropagation)
			{
				event.stopPropagation();
			}
			if (options.preventDefault)
			{
				event.preventDefault();
			}

			var message = value._0;

			var currentEventNode = eventNode;
			while (currentEventNode)
			{
				var tagger = currentEventNode.tagger;
				if (typeof tagger === 'function')
				{
					message = tagger(message);
				}
				else
				{
					for (var i = tagger.length; i--; )
					{
						message = tagger[i](message);
					}
				}
				currentEventNode = currentEventNode.parent;
			}
		}
	};

	eventHandler.info = info;

	return eventHandler;
}

function applyAttrs(domNode, attrs)
{
	for (var key in attrs)
	{
		var value = attrs[key];
		if (typeof value === 'undefined')
		{
			domNode.removeAttribute(key);
		}
		else
		{
			domNode.setAttribute(key, value);
		}
	}
}

function applyAttrsNS(domNode, nsAttrs)
{
	for (var key in nsAttrs)
	{
		var pair = nsAttrs[key];
		var namespace = pair.namespace;
		var value = pair.value;

		if (typeof value === 'undefined')
		{
			domNode.removeAttributeNS(namespace, key);
		}
		else
		{
			domNode.setAttributeNS(namespace, key, value);
		}
	}
}



////////////  DIFF  ////////////


function diff(a, b)
{
	var patches = [];
	diffHelp(a, b, patches, 0);
	return patches;
}


function makePatch(type, index, data)
{
	return {
		index: index,
		type: type,
		data: data,
		domNode: undefined,
		eventNode: undefined
	};
}


function diffHelp(a, b, patches, index)
{
	if (a === b)
	{
		return;
	}

	var aType = a.type;
	var bType = b.type;

	// Bail if you run into different types of nodes. Implies that the
	// structure has changed significantly and it's not worth a diff.
	if (aType !== bType)
	{
		patches.push(makePatch('p-redraw', index, b));
		return;
	}

	// Now we know that both nodes are the same type.
	switch (bType)
	{
		case 'thunk':
			var aArgs = a.args;
			var bArgs = b.args;
			var i = aArgs.length;
			var same = a.func === b.func && i === bArgs.length;
			while (same && i--)
			{
				same = aArgs[i] === bArgs[i];
			}
			if (same)
			{
				b.node = a.node;
				return;
			}
			b.node = b.thunk();
			var subPatches = [];
			diffHelp(a.node, b.node, subPatches, 0);
			if (subPatches.length > 0)
			{
				patches.push(makePatch('p-thunk', index, subPatches));
			}
			return;

		case 'tagger':
			// gather nested taggers
			var aTaggers = a.tagger;
			var bTaggers = b.tagger;
			var nesting = false;

			var aSubNode = a.node;
			while (aSubNode.type === 'tagger')
			{
				nesting = true;

				typeof aTaggers !== 'object'
					? aTaggers = [aTaggers, aSubNode.tagger]
					: aTaggers.push(aSubNode.tagger);

				aSubNode = aSubNode.node;
			}

			var bSubNode = b.node;
			while (bSubNode.type === 'tagger')
			{
				nesting = true;

				typeof bTaggers !== 'object'
					? bTaggers = [bTaggers, bSubNode.tagger]
					: bTaggers.push(bSubNode.tagger);

				bSubNode = bSubNode.node;
			}

			// Just bail if different numbers of taggers. This implies the
			// structure of the virtual DOM has changed.
			if (nesting && aTaggers.length !== bTaggers.length)
			{
				patches.push(makePatch('p-redraw', index, b));
				return;
			}

			// check if taggers are "the same"
			if (nesting ? !pairwiseRefEqual(aTaggers, bTaggers) : aTaggers !== bTaggers)
			{
				patches.push(makePatch('p-tagger', index, bTaggers));
			}

			// diff everything below the taggers
			diffHelp(aSubNode, bSubNode, patches, index + 1);
			return;

		case 'text':
			if (a.text !== b.text)
			{
				patches.push(makePatch('p-text', index, b.text));
				return;
			}

			return;

		case 'node':
			// Bail if obvious indicators have changed. Implies more serious
			// structural changes such that it's not worth it to diff.
			if (a.tag !== b.tag || a.namespace !== b.namespace)
			{
				patches.push(makePatch('p-redraw', index, b));
				return;
			}

			var factsDiff = diffFacts(a.facts, b.facts);

			if (typeof factsDiff !== 'undefined')
			{
				patches.push(makePatch('p-facts', index, factsDiff));
			}

			diffChildren(a, b, patches, index);
			return;

		case 'keyed-node':
			// Bail if obvious indicators have changed. Implies more serious
			// structural changes such that it's not worth it to diff.
			if (a.tag !== b.tag || a.namespace !== b.namespace)
			{
				patches.push(makePatch('p-redraw', index, b));
				return;
			}

			var factsDiff = diffFacts(a.facts, b.facts);

			if (typeof factsDiff !== 'undefined')
			{
				patches.push(makePatch('p-facts', index, factsDiff));
			}

			diffKeyedChildren(a, b, patches, index);
			return;

		case 'custom':
			if (a.impl !== b.impl)
			{
				patches.push(makePatch('p-redraw', index, b));
				return;
			}

			var factsDiff = diffFacts(a.facts, b.facts);
			if (typeof factsDiff !== 'undefined')
			{
				patches.push(makePatch('p-facts', index, factsDiff));
			}

			var patch = b.impl.diff(a,b);
			if (patch)
			{
				patches.push(makePatch('p-custom', index, patch));
				return;
			}

			return;
	}
}


// assumes the incoming arrays are the same length
function pairwiseRefEqual(as, bs)
{
	for (var i = 0; i < as.length; i++)
	{
		if (as[i] !== bs[i])
		{
			return false;
		}
	}

	return true;
}


// TODO Instead of creating a new diff object, it's possible to just test if
// there *is* a diff. During the actual patch, do the diff again and make the
// modifications directly. This way, there's no new allocations. Worth it?
function diffFacts(a, b, category)
{
	var diff;

	// look for changes and removals
	for (var aKey in a)
	{
		if (aKey === STYLE_KEY || aKey === EVENT_KEY || aKey === ATTR_KEY || aKey === ATTR_NS_KEY)
		{
			var subDiff = diffFacts(a[aKey], b[aKey] || {}, aKey);
			if (subDiff)
			{
				diff = diff || {};
				diff[aKey] = subDiff;
			}
			continue;
		}

		// remove if not in the new facts
		if (!(aKey in b))
		{
			diff = diff || {};
			diff[aKey] =
				(typeof category === 'undefined')
					? (typeof a[aKey] === 'string' ? '' : null)
					:
				(category === STYLE_KEY)
					? ''
					:
				(category === EVENT_KEY || category === ATTR_KEY)
					? undefined
					:
				{ namespace: a[aKey].namespace, value: undefined };

			continue;
		}

		var aValue = a[aKey];
		var bValue = b[aKey];

		// reference equal, so don't worry about it
		if (aValue === bValue && aKey !== 'value'
			|| category === EVENT_KEY && equalEvents(aValue, bValue))
		{
			continue;
		}

		diff = diff || {};
		diff[aKey] = bValue;
	}

	// add new stuff
	for (var bKey in b)
	{
		if (!(bKey in a))
		{
			diff = diff || {};
			diff[bKey] = b[bKey];
		}
	}

	return diff;
}


function diffChildren(aParent, bParent, patches, rootIndex)
{
	var aChildren = aParent.children;
	var bChildren = bParent.children;

	var aLen = aChildren.length;
	var bLen = bChildren.length;

	// FIGURE OUT IF THERE ARE INSERTS OR REMOVALS

	if (aLen > bLen)
	{
		patches.push(makePatch('p-remove-last', rootIndex, aLen - bLen));
	}
	else if (aLen < bLen)
	{
		patches.push(makePatch('p-append', rootIndex, bChildren.slice(aLen)));
	}

	// PAIRWISE DIFF EVERYTHING ELSE

	var index = rootIndex;
	var minLen = aLen < bLen ? aLen : bLen;
	for (var i = 0; i < minLen; i++)
	{
		index++;
		var aChild = aChildren[i];
		diffHelp(aChild, bChildren[i], patches, index);
		index += aChild.descendantsCount || 0;
	}
}



////////////  KEYED DIFF  ////////////


function diffKeyedChildren(aParent, bParent, patches, rootIndex)
{
	var localPatches = [];

	var changes = {}; // Dict String Entry
	var inserts = []; // Array { index : Int, entry : Entry }
	// type Entry = { tag : String, vnode : VNode, index : Int, data : _ }

	var aChildren = aParent.children;
	var bChildren = bParent.children;
	var aLen = aChildren.length;
	var bLen = bChildren.length;
	var aIndex = 0;
	var bIndex = 0;

	var index = rootIndex;

	while (aIndex < aLen && bIndex < bLen)
	{
		var a = aChildren[aIndex];
		var b = bChildren[bIndex];

		var aKey = a._0;
		var bKey = b._0;
		var aNode = a._1;
		var bNode = b._1;

		// check if keys match

		if (aKey === bKey)
		{
			index++;
			diffHelp(aNode, bNode, localPatches, index);
			index += aNode.descendantsCount || 0;

			aIndex++;
			bIndex++;
			continue;
		}

		// look ahead 1 to detect insertions and removals.

		var aLookAhead = aIndex + 1 < aLen;
		var bLookAhead = bIndex + 1 < bLen;

		if (aLookAhead)
		{
			var aNext = aChildren[aIndex + 1];
			var aNextKey = aNext._0;
			var aNextNode = aNext._1;
			var oldMatch = bKey === aNextKey;
		}

		if (bLookAhead)
		{
			var bNext = bChildren[bIndex + 1];
			var bNextKey = bNext._0;
			var bNextNode = bNext._1;
			var newMatch = aKey === bNextKey;
		}


		// swap a and b
		if (aLookAhead && bLookAhead && newMatch && oldMatch)
		{
			index++;
			diffHelp(aNode, bNextNode, localPatches, index);
			insertNode(changes, localPatches, aKey, bNode, bIndex, inserts);
			index += aNode.descendantsCount || 0;

			index++;
			removeNode(changes, localPatches, aKey, aNextNode, index);
			index += aNextNode.descendantsCount || 0;

			aIndex += 2;
			bIndex += 2;
			continue;
		}

		// insert b
		if (bLookAhead && newMatch)
		{
			index++;
			insertNode(changes, localPatches, bKey, bNode, bIndex, inserts);
			diffHelp(aNode, bNextNode, localPatches, index);
			index += aNode.descendantsCount || 0;

			aIndex += 1;
			bIndex += 2;
			continue;
		}

		// remove a
		if (aLookAhead && oldMatch)
		{
			index++;
			removeNode(changes, localPatches, aKey, aNode, index);
			index += aNode.descendantsCount || 0;

			index++;
			diffHelp(aNextNode, bNode, localPatches, index);
			index += aNextNode.descendantsCount || 0;

			aIndex += 2;
			bIndex += 1;
			continue;
		}

		// remove a, insert b
		if (aLookAhead && bLookAhead && aNextKey === bNextKey)
		{
			index++;
			removeNode(changes, localPatches, aKey, aNode, index);
			insertNode(changes, localPatches, bKey, bNode, bIndex, inserts);
			index += aNode.descendantsCount || 0;

			index++;
			diffHelp(aNextNode, bNextNode, localPatches, index);
			index += aNextNode.descendantsCount || 0;

			aIndex += 2;
			bIndex += 2;
			continue;
		}

		break;
	}

	// eat up any remaining nodes with removeNode and insertNode

	while (aIndex < aLen)
	{
		index++;
		var a = aChildren[aIndex];
		var aNode = a._1;
		removeNode(changes, localPatches, a._0, aNode, index);
		index += aNode.descendantsCount || 0;
		aIndex++;
	}

	var endInserts;
	while (bIndex < bLen)
	{
		endInserts = endInserts || [];
		var b = bChildren[bIndex];
		insertNode(changes, localPatches, b._0, b._1, undefined, endInserts);
		bIndex++;
	}

	if (localPatches.length > 0 || inserts.length > 0 || typeof endInserts !== 'undefined')
	{
		patches.push(makePatch('p-reorder', rootIndex, {
			patches: localPatches,
			inserts: inserts,
			endInserts: endInserts
		}));
	}
}



////////////  CHANGES FROM KEYED DIFF  ////////////


var POSTFIX = '_elmW6BL';


function insertNode(changes, localPatches, key, vnode, bIndex, inserts)
{
	var entry = changes[key];

	// never seen this key before
	if (typeof entry === 'undefined')
	{
		entry = {
			tag: 'insert',
			vnode: vnode,
			index: bIndex,
			data: undefined
		};

		inserts.push({ index: bIndex, entry: entry });
		changes[key] = entry;

		return;
	}

	// this key was removed earlier, a match!
	if (entry.tag === 'remove')
	{
		inserts.push({ index: bIndex, entry: entry });

		entry.tag = 'move';
		var subPatches = [];
		diffHelp(entry.vnode, vnode, subPatches, entry.index);
		entry.index = bIndex;
		entry.data.data = {
			patches: subPatches,
			entry: entry
		};

		return;
	}

	// this key has already been inserted or moved, a duplicate!
	insertNode(changes, localPatches, key + POSTFIX, vnode, bIndex, inserts);
}


function removeNode(changes, localPatches, key, vnode, index)
{
	var entry = changes[key];

	// never seen this key before
	if (typeof entry === 'undefined')
	{
		var patch = makePatch('p-remove', index, undefined);
		localPatches.push(patch);

		changes[key] = {
			tag: 'remove',
			vnode: vnode,
			index: index,
			data: patch
		};

		return;
	}

	// this key was inserted earlier, a match!
	if (entry.tag === 'insert')
	{
		entry.tag = 'move';
		var subPatches = [];
		diffHelp(vnode, entry.vnode, subPatches, index);

		var patch = makePatch('p-remove', index, {
			patches: subPatches,
			entry: entry
		});
		localPatches.push(patch);

		return;
	}

	// this key has already been removed or moved, a duplicate!
	removeNode(changes, localPatches, key + POSTFIX, vnode, index);
}



////////////  ADD DOM NODES  ////////////
//
// Each DOM node has an "index" assigned in order of traversal. It is important
// to minimize our crawl over the actual DOM, so these indexes (along with the
// descendantsCount of virtual nodes) let us skip touching entire subtrees of
// the DOM if we know there are no patches there.


function addDomNodes(domNode, vNode, patches, eventNode)
{
	addDomNodesHelp(domNode, vNode, patches, 0, 0, vNode.descendantsCount, eventNode);
}


// assumes `patches` is non-empty and indexes increase monotonically.
function addDomNodesHelp(domNode, vNode, patches, i, low, high, eventNode)
{
	var patch = patches[i];
	var index = patch.index;

	while (index === low)
	{
		var patchType = patch.type;

		if (patchType === 'p-thunk')
		{
			addDomNodes(domNode, vNode.node, patch.data, eventNode);
		}
		else if (patchType === 'p-reorder')
		{
			patch.domNode = domNode;
			patch.eventNode = eventNode;

			var subPatches = patch.data.patches;
			if (subPatches.length > 0)
			{
				addDomNodesHelp(domNode, vNode, subPatches, 0, low, high, eventNode);
			}
		}
		else if (patchType === 'p-remove')
		{
			patch.domNode = domNode;
			patch.eventNode = eventNode;

			var data = patch.data;
			if (typeof data !== 'undefined')
			{
				data.entry.data = domNode;
				var subPatches = data.patches;
				if (subPatches.length > 0)
				{
					addDomNodesHelp(domNode, vNode, subPatches, 0, low, high, eventNode);
				}
			}
		}
		else
		{
			patch.domNode = domNode;
			patch.eventNode = eventNode;
		}

		i++;

		if (!(patch = patches[i]) || (index = patch.index) > high)
		{
			return i;
		}
	}

	switch (vNode.type)
	{
		case 'tagger':
			var subNode = vNode.node;

			while (subNode.type === "tagger")
			{
				subNode = subNode.node;
			}

			return addDomNodesHelp(domNode, subNode, patches, i, low + 1, high, domNode.elm_event_node_ref);

		case 'node':
			var vChildren = vNode.children;
			var childNodes = domNode.childNodes;
			for (var j = 0; j < vChildren.length; j++)
			{
				low++;
				var vChild = vChildren[j];
				var nextLow = low + (vChild.descendantsCount || 0);
				if (low <= index && index <= nextLow)
				{
					i = addDomNodesHelp(childNodes[j], vChild, patches, i, low, nextLow, eventNode);
					if (!(patch = patches[i]) || (index = patch.index) > high)
					{
						return i;
					}
				}
				low = nextLow;
			}
			return i;

		case 'keyed-node':
			var vChildren = vNode.children;
			var childNodes = domNode.childNodes;
			for (var j = 0; j < vChildren.length; j++)
			{
				low++;
				var vChild = vChildren[j]._1;
				var nextLow = low + (vChild.descendantsCount || 0);
				if (low <= index && index <= nextLow)
				{
					i = addDomNodesHelp(childNodes[j], vChild, patches, i, low, nextLow, eventNode);
					if (!(patch = patches[i]) || (index = patch.index) > high)
					{
						return i;
					}
				}
				low = nextLow;
			}
			return i;

		case 'text':
		case 'thunk':
			throw new Error('should never traverse `text` or `thunk` nodes like this');
	}
}



////////////  APPLY PATCHES  ////////////


function applyPatches(rootDomNode, oldVirtualNode, patches, eventNode)
{
	if (patches.length === 0)
	{
		return rootDomNode;
	}

	addDomNodes(rootDomNode, oldVirtualNode, patches, eventNode);
	return applyPatchesHelp(rootDomNode, patches);
}

function applyPatchesHelp(rootDomNode, patches)
{
	for (var i = 0; i < patches.length; i++)
	{
		var patch = patches[i];
		var localDomNode = patch.domNode
		var newNode = applyPatch(localDomNode, patch);
		if (localDomNode === rootDomNode)
		{
			rootDomNode = newNode;
		}
	}
	return rootDomNode;
}

function applyPatch(domNode, patch)
{
	switch (patch.type)
	{
		case 'p-redraw':
			return applyPatchRedraw(domNode, patch.data, patch.eventNode);

		case 'p-facts':
			applyFacts(domNode, patch.eventNode, patch.data);
			return domNode;

		case 'p-text':
			domNode.replaceData(0, domNode.length, patch.data);
			return domNode;

		case 'p-thunk':
			return applyPatchesHelp(domNode, patch.data);

		case 'p-tagger':
			if (typeof domNode.elm_event_node_ref !== 'undefined')
			{
				domNode.elm_event_node_ref.tagger = patch.data;
			}
			else
			{
				domNode.elm_event_node_ref = { tagger: patch.data, parent: patch.eventNode };
			}
			return domNode;

		case 'p-remove-last':
			var i = patch.data;
			while (i--)
			{
				domNode.removeChild(domNode.lastChild);
			}
			return domNode;

		case 'p-append':
			var newNodes = patch.data;
			for (var i = 0; i < newNodes.length; i++)
			{
				domNode.appendChild(render(newNodes[i], patch.eventNode));
			}
			return domNode;

		case 'p-remove':
			var data = patch.data;
			if (typeof data === 'undefined')
			{
				domNode.parentNode.removeChild(domNode);
				return domNode;
			}
			var entry = data.entry;
			if (typeof entry.index !== 'undefined')
			{
				domNode.parentNode.removeChild(domNode);
			}
			entry.data = applyPatchesHelp(domNode, data.patches);
			return domNode;

		case 'p-reorder':
			return applyPatchReorder(domNode, patch);

		case 'p-custom':
			var impl = patch.data;
			return impl.applyPatch(domNode, impl.data);

		default:
			throw new Error('Ran into an unknown patch!');
	}
}


function applyPatchRedraw(domNode, vNode, eventNode)
{
	var parentNode = domNode.parentNode;
	var newNode = render(vNode, eventNode);

	if (typeof newNode.elm_event_node_ref === 'undefined')
	{
		newNode.elm_event_node_ref = domNode.elm_event_node_ref;
	}

	if (parentNode && newNode !== domNode)
	{
		parentNode.replaceChild(newNode, domNode);
	}
	return newNode;
}


function applyPatchReorder(domNode, patch)
{
	var data = patch.data;

	// remove end inserts
	var frag = applyPatchReorderEndInsertsHelp(data.endInserts, patch);

	// removals
	domNode = applyPatchesHelp(domNode, data.patches);

	// inserts
	var inserts = data.inserts;
	for (var i = 0; i < inserts.length; i++)
	{
		var insert = inserts[i];
		var entry = insert.entry;
		var node = entry.tag === 'move'
			? entry.data
			: render(entry.vnode, patch.eventNode);
		domNode.insertBefore(node, domNode.childNodes[insert.index]);
	}

	// add end inserts
	if (typeof frag !== 'undefined')
	{
		domNode.appendChild(frag);
	}

	return domNode;
}


function applyPatchReorderEndInsertsHelp(endInserts, patch)
{
	if (typeof endInserts === 'undefined')
	{
		return;
	}

	var frag = localDoc.createDocumentFragment();
	for (var i = 0; i < endInserts.length; i++)
	{
		var insert = endInserts[i];
		var entry = insert.entry;
		frag.appendChild(entry.tag === 'move'
			? entry.data
			: render(entry.vnode, patch.eventNode)
		);
	}
	return frag;
}


// PROGRAMS

var program = makeProgram(checkNoFlags);
var programWithFlags = makeProgram(checkYesFlags);

function makeProgram(flagChecker)
{
	return F2(function(debugWrap, impl)
	{
		return function(flagDecoder)
		{
			return function(object, moduleName, debugMetadata)
			{
				var checker = flagChecker(flagDecoder, moduleName);
				if (typeof debugMetadata === 'undefined')
				{
					normalSetup(impl, object, moduleName, checker);
				}
				else
				{
					debugSetup(A2(debugWrap, debugMetadata, impl), object, moduleName, checker);
				}
			};
		};
	});
}

function staticProgram(vNode)
{
	var nothing = _elm_lang$core$Native_Utils.Tuple2(
		_elm_lang$core$Native_Utils.Tuple0,
		_elm_lang$core$Platform_Cmd$none
	);
	return A2(program, _elm_lang$virtual_dom$VirtualDom_Debug$wrap, {
		init: nothing,
		view: function() { return vNode; },
		update: F2(function() { return nothing; }),
		subscriptions: function() { return _elm_lang$core$Platform_Sub$none; }
	})();
}


// FLAG CHECKERS

function checkNoFlags(flagDecoder, moduleName)
{
	return function(init, flags, domNode)
	{
		if (typeof flags === 'undefined')
		{
			return init;
		}

		var errorMessage =
			'The `' + moduleName + '` module does not need flags.\n'
			+ 'Initialize it with no arguments and you should be all set!';

		crash(errorMessage, domNode);
	};
}

function checkYesFlags(flagDecoder, moduleName)
{
	return function(init, flags, domNode)
	{
		if (typeof flagDecoder === 'undefined')
		{
			var errorMessage =
				'Are you trying to sneak a Never value into Elm? Trickster!\n'
				+ 'It looks like ' + moduleName + '.main is defined with `programWithFlags` but has type `Program Never`.\n'
				+ 'Use `program` instead if you do not want flags.'

			crash(errorMessage, domNode);
		}

		var result = A2(_elm_lang$core$Native_Json.run, flagDecoder, flags);
		if (result.ctor === 'Ok')
		{
			return init(result._0);
		}

		var errorMessage =
			'Trying to initialize the `' + moduleName + '` module with an unexpected flag.\n'
			+ 'I tried to convert it to an Elm value, but ran into this problem:\n\n'
			+ result._0;

		crash(errorMessage, domNode);
	};
}

function crash(errorMessage, domNode)
{
	if (domNode)
	{
		domNode.innerHTML =
			'<div style="padding-left:1em;">'
			+ '<h2 style="font-weight:normal;"><b>Oops!</b> Something went wrong when starting your Elm program.</h2>'
			+ '<pre style="padding-left:1em;">' + errorMessage + '</pre>'
			+ '</div>';
	}

	throw new Error(errorMessage);
}


//  NORMAL SETUP

function normalSetup(impl, object, moduleName, flagChecker)
{
	object['embed'] = function embed(node, flags)
	{
		while (node.lastChild)
		{
			node.removeChild(node.lastChild);
		}

		return _elm_lang$core$Native_Platform.initialize(
			flagChecker(impl.init, flags, node),
			impl.update,
			impl.subscriptions,
			normalRenderer(node, impl.view)
		);
	};

	object['fullscreen'] = function fullscreen(flags)
	{
		return _elm_lang$core$Native_Platform.initialize(
			flagChecker(impl.init, flags, document.body),
			impl.update,
			impl.subscriptions,
			normalRenderer(document.body, impl.view)
		);
	};
}

function normalRenderer(parentNode, view)
{
	return function(tagger, initialModel)
	{
		var eventNode = { tagger: tagger, parent: undefined };
		var initialVirtualNode = view(initialModel);
		var domNode = render(initialVirtualNode, eventNode);
		parentNode.appendChild(domNode);
		return makeStepper(domNode, view, initialVirtualNode, eventNode);
	};
}


// STEPPER

var rAF =
	typeof requestAnimationFrame !== 'undefined'
		? requestAnimationFrame
		: function(callback) { setTimeout(callback, 1000 / 60); };

function makeStepper(domNode, view, initialVirtualNode, eventNode)
{
	var state = 'NO_REQUEST';
	var currNode = initialVirtualNode;
	var nextModel;

	function updateIfNeeded()
	{
		switch (state)
		{
			case 'NO_REQUEST':
				throw new Error(
					'Unexpected draw callback.\n' +
					'Please report this to <https://github.com/elm-lang/virtual-dom/issues>.'
				);

			case 'PENDING_REQUEST':
				rAF(updateIfNeeded);
				state = 'EXTRA_REQUEST';

				var nextNode = view(nextModel);
				var patches = diff(currNode, nextNode);
				domNode = applyPatches(domNode, currNode, patches, eventNode);
				currNode = nextNode;

				return;

			case 'EXTRA_REQUEST':
				state = 'NO_REQUEST';
				return;
		}
	}

	return function stepper(model)
	{
		if (state === 'NO_REQUEST')
		{
			rAF(updateIfNeeded);
		}
		state = 'PENDING_REQUEST';
		nextModel = model;
	};
}


// DEBUG SETUP

function debugSetup(impl, object, moduleName, flagChecker)
{
	object['fullscreen'] = function fullscreen(flags)
	{
		var popoutRef = { doc: undefined };
		return _elm_lang$core$Native_Platform.initialize(
			flagChecker(impl.init, flags, document.body),
			impl.update(scrollTask(popoutRef)),
			impl.subscriptions,
			debugRenderer(moduleName, document.body, popoutRef, impl.view, impl.viewIn, impl.viewOut)
		);
	};

	object['embed'] = function fullscreen(node, flags)
	{
		var popoutRef = { doc: undefined };
		return _elm_lang$core$Native_Platform.initialize(
			flagChecker(impl.init, flags, node),
			impl.update(scrollTask(popoutRef)),
			impl.subscriptions,
			debugRenderer(moduleName, node, popoutRef, impl.view, impl.viewIn, impl.viewOut)
		);
	};
}

function scrollTask(popoutRef)
{
	return _elm_lang$core$Native_Scheduler.nativeBinding(function(callback)
	{
		var doc = popoutRef.doc;
		if (doc)
		{
			var msgs = doc.getElementsByClassName('debugger-sidebar-messages')[0];
			if (msgs)
			{
				msgs.scrollTop = msgs.scrollHeight;
			}
		}
		callback(_elm_lang$core$Native_Scheduler.succeed(_elm_lang$core$Native_Utils.Tuple0));
	});
}


function debugRenderer(moduleName, parentNode, popoutRef, view, viewIn, viewOut)
{
	return function(tagger, initialModel)
	{
		var appEventNode = { tagger: tagger, parent: undefined };
		var eventNode = { tagger: tagger, parent: undefined };

		// make normal stepper
		var appVirtualNode = view(initialModel);
		var appNode = render(appVirtualNode, appEventNode);
		parentNode.appendChild(appNode);
		var appStepper = makeStepper(appNode, view, appVirtualNode, appEventNode);

		// make overlay stepper
		var overVirtualNode = viewIn(initialModel)._1;
		var overNode = render(overVirtualNode, eventNode);
		parentNode.appendChild(overNode);
		var wrappedViewIn = wrapViewIn(appEventNode, overNode, viewIn);
		var overStepper = makeStepper(overNode, wrappedViewIn, overVirtualNode, eventNode);

		// make debugger stepper
		var debugStepper = makeDebugStepper(initialModel, viewOut, eventNode, parentNode, moduleName, popoutRef);

		return function stepper(model)
		{
			appStepper(model);
			overStepper(model);
			debugStepper(model);
		}
	};
}

function makeDebugStepper(initialModel, view, eventNode, parentNode, moduleName, popoutRef)
{
	var curr;
	var domNode;

	return function stepper(model)
	{
		if (!model.isDebuggerOpen)
		{
			return;
		}

		if (!popoutRef.doc)
		{
			curr = view(model);
			domNode = openDebugWindow(moduleName, popoutRef, curr, eventNode);
			return;
		}

		// switch to document of popout
		localDoc = popoutRef.doc;

		var next = view(model);
		var patches = diff(curr, next);
		domNode = applyPatches(domNode, curr, patches, eventNode);
		curr = next;

		// switch back to normal document
		localDoc = document;
	};
}

function openDebugWindow(moduleName, popoutRef, virtualNode, eventNode)
{
	var w = 900;
	var h = 360;
	var x = screen.width - w;
	var y = screen.height - h;
	var debugWindow = window.open('', '', 'width=' + w + ',height=' + h + ',left=' + x + ',top=' + y);

	// switch to window document
	localDoc = debugWindow.document;

	popoutRef.doc = localDoc;
	localDoc.title = 'Debugger - ' + moduleName;
	localDoc.body.style.margin = '0';
	localDoc.body.style.padding = '0';
	var domNode = render(virtualNode, eventNode);
	localDoc.body.appendChild(domNode);

	localDoc.addEventListener('keydown', function(event) {
		if (event.metaKey && event.which === 82)
		{
			window.location.reload();
		}
		if (event.which === 38)
		{
			eventNode.tagger({ ctor: 'Up' });
			event.preventDefault();
		}
		if (event.which === 40)
		{
			eventNode.tagger({ ctor: 'Down' });
			event.preventDefault();
		}
	});

	function close()
	{
		popoutRef.doc = undefined;
		debugWindow.close();
	}
	window.addEventListener('unload', close);
	debugWindow.addEventListener('unload', function() {
		popoutRef.doc = undefined;
		window.removeEventListener('unload', close);
		eventNode.tagger({ ctor: 'Close' });
	});

	// switch back to the normal document
	localDoc = document;

	return domNode;
}


// BLOCK EVENTS

function wrapViewIn(appEventNode, overlayNode, viewIn)
{
	var ignorer = makeIgnorer(overlayNode);
	var blocking = 'Normal';
	var overflow;

	var normalTagger = appEventNode.tagger;
	var blockTagger = function() {};

	return function(model)
	{
		var tuple = viewIn(model);
		var newBlocking = tuple._0.ctor;
		appEventNode.tagger = newBlocking === 'Normal' ? normalTagger : blockTagger;
		if (blocking !== newBlocking)
		{
			traverse('removeEventListener', ignorer, blocking);
			traverse('addEventListener', ignorer, newBlocking);

			if (blocking === 'Normal')
			{
				overflow = document.body.style.overflow;
				document.body.style.overflow = 'hidden';
			}

			if (newBlocking === 'Normal')
			{
				document.body.style.overflow = overflow;
			}

			blocking = newBlocking;
		}
		return tuple._1;
	}
}

function traverse(verbEventListener, ignorer, blocking)
{
	switch(blocking)
	{
		case 'Normal':
			return;

		case 'Pause':
			return traverseHelp(verbEventListener, ignorer, mostEvents);

		case 'Message':
			return traverseHelp(verbEventListener, ignorer, allEvents);
	}
}

function traverseHelp(verbEventListener, handler, eventNames)
{
	for (var i = 0; i < eventNames.length; i++)
	{
		document.body[verbEventListener](eventNames[i], handler, true);
	}
}

function makeIgnorer(overlayNode)
{
	return function(event)
	{
		if (event.type === 'keydown' && event.metaKey && event.which === 82)
		{
			return;
		}

		var isScroll = event.type === 'scroll' || event.type === 'wheel';

		var node = event.target;
		while (node !== null)
		{
			if (node.className === 'elm-overlay-message-details' && isScroll)
			{
				return;
			}

			if (node === overlayNode && !isScroll)
			{
				return;
			}
			node = node.parentNode;
		}

		event.stopPropagation();
		event.preventDefault();
	}
}

var mostEvents = [
	'click', 'dblclick', 'mousemove',
	'mouseup', 'mousedown', 'mouseenter', 'mouseleave',
	'touchstart', 'touchend', 'touchcancel', 'touchmove',
	'pointerdown', 'pointerup', 'pointerover', 'pointerout',
	'pointerenter', 'pointerleave', 'pointermove', 'pointercancel',
	'dragstart', 'drag', 'dragend', 'dragenter', 'dragover', 'dragleave', 'drop',
	'keyup', 'keydown', 'keypress',
	'input', 'change',
	'focus', 'blur'
];

var allEvents = mostEvents.concat('wheel', 'scroll');


return {
	node: node,
	text: text,
	custom: custom,
	map: F2(map),

	on: F3(on),
	style: style,
	property: F2(property),
	attribute: F2(attribute),
	attributeNS: F3(attributeNS),
	mapProperty: F2(mapProperty),

	lazy: F2(lazy),
	lazy2: F3(lazy2),
	lazy3: F4(lazy3),
	keyedNode: F3(keyedNode),

	program: program,
	programWithFlags: programWithFlags,
	staticProgram: staticProgram
};

}();

var _elm_lang$virtual_dom$VirtualDom$programWithFlags = function (impl) {
	return A2(_elm_lang$virtual_dom$Native_VirtualDom.programWithFlags, _elm_lang$virtual_dom$VirtualDom_Debug$wrapWithFlags, impl);
};
var _elm_lang$virtual_dom$VirtualDom$program = function (impl) {
	return A2(_elm_lang$virtual_dom$Native_VirtualDom.program, _elm_lang$virtual_dom$VirtualDom_Debug$wrap, impl);
};
var _elm_lang$virtual_dom$VirtualDom$keyedNode = _elm_lang$virtual_dom$Native_VirtualDom.keyedNode;
var _elm_lang$virtual_dom$VirtualDom$lazy3 = _elm_lang$virtual_dom$Native_VirtualDom.lazy3;
var _elm_lang$virtual_dom$VirtualDom$lazy2 = _elm_lang$virtual_dom$Native_VirtualDom.lazy2;
var _elm_lang$virtual_dom$VirtualDom$lazy = _elm_lang$virtual_dom$Native_VirtualDom.lazy;
var _elm_lang$virtual_dom$VirtualDom$defaultOptions = {stopPropagation: false, preventDefault: false};
var _elm_lang$virtual_dom$VirtualDom$onWithOptions = _elm_lang$virtual_dom$Native_VirtualDom.on;
var _elm_lang$virtual_dom$VirtualDom$on = F2(
	function (eventName, decoder) {
		return A3(_elm_lang$virtual_dom$VirtualDom$onWithOptions, eventName, _elm_lang$virtual_dom$VirtualDom$defaultOptions, decoder);
	});
var _elm_lang$virtual_dom$VirtualDom$style = _elm_lang$virtual_dom$Native_VirtualDom.style;
var _elm_lang$virtual_dom$VirtualDom$mapProperty = _elm_lang$virtual_dom$Native_VirtualDom.mapProperty;
var _elm_lang$virtual_dom$VirtualDom$attributeNS = _elm_lang$virtual_dom$Native_VirtualDom.attributeNS;
var _elm_lang$virtual_dom$VirtualDom$attribute = _elm_lang$virtual_dom$Native_VirtualDom.attribute;
var _elm_lang$virtual_dom$VirtualDom$property = _elm_lang$virtual_dom$Native_VirtualDom.property;
var _elm_lang$virtual_dom$VirtualDom$map = _elm_lang$virtual_dom$Native_VirtualDom.map;
var _elm_lang$virtual_dom$VirtualDom$text = _elm_lang$virtual_dom$Native_VirtualDom.text;
var _elm_lang$virtual_dom$VirtualDom$node = _elm_lang$virtual_dom$Native_VirtualDom.node;
var _elm_lang$virtual_dom$VirtualDom$Options = F2(
	function (a, b) {
		return {stopPropagation: a, preventDefault: b};
	});
var _elm_lang$virtual_dom$VirtualDom$Node = {ctor: 'Node'};
var _elm_lang$virtual_dom$VirtualDom$Property = {ctor: 'Property'};

var _elm_lang$html$Html$programWithFlags = _elm_lang$virtual_dom$VirtualDom$programWithFlags;
var _elm_lang$html$Html$program = _elm_lang$virtual_dom$VirtualDom$program;
var _elm_lang$html$Html$beginnerProgram = function (_p0) {
	var _p1 = _p0;
	return _elm_lang$html$Html$program(
		{
			init: A2(
				_elm_lang$core$Platform_Cmd_ops['!'],
				_p1.model,
				{ctor: '[]'}),
			update: F2(
				function (msg, model) {
					return A2(
						_elm_lang$core$Platform_Cmd_ops['!'],
						A2(_p1.update, msg, model),
						{ctor: '[]'});
				}),
			view: _p1.view,
			subscriptions: function (_p2) {
				return _elm_lang$core$Platform_Sub$none;
			}
		});
};
var _elm_lang$html$Html$map = _elm_lang$virtual_dom$VirtualDom$map;
var _elm_lang$html$Html$text = _elm_lang$virtual_dom$VirtualDom$text;
var _elm_lang$html$Html$node = _elm_lang$virtual_dom$VirtualDom$node;
var _elm_lang$html$Html$body = _elm_lang$html$Html$node('body');
var _elm_lang$html$Html$section = _elm_lang$html$Html$node('section');
var _elm_lang$html$Html$nav = _elm_lang$html$Html$node('nav');
var _elm_lang$html$Html$article = _elm_lang$html$Html$node('article');
var _elm_lang$html$Html$aside = _elm_lang$html$Html$node('aside');
var _elm_lang$html$Html$h1 = _elm_lang$html$Html$node('h1');
var _elm_lang$html$Html$h2 = _elm_lang$html$Html$node('h2');
var _elm_lang$html$Html$h3 = _elm_lang$html$Html$node('h3');
var _elm_lang$html$Html$h4 = _elm_lang$html$Html$node('h4');
var _elm_lang$html$Html$h5 = _elm_lang$html$Html$node('h5');
var _elm_lang$html$Html$h6 = _elm_lang$html$Html$node('h6');
var _elm_lang$html$Html$header = _elm_lang$html$Html$node('header');
var _elm_lang$html$Html$footer = _elm_lang$html$Html$node('footer');
var _elm_lang$html$Html$address = _elm_lang$html$Html$node('address');
var _elm_lang$html$Html$main_ = _elm_lang$html$Html$node('main');
var _elm_lang$html$Html$p = _elm_lang$html$Html$node('p');
var _elm_lang$html$Html$hr = _elm_lang$html$Html$node('hr');
var _elm_lang$html$Html$pre = _elm_lang$html$Html$node('pre');
var _elm_lang$html$Html$blockquote = _elm_lang$html$Html$node('blockquote');
var _elm_lang$html$Html$ol = _elm_lang$html$Html$node('ol');
var _elm_lang$html$Html$ul = _elm_lang$html$Html$node('ul');
var _elm_lang$html$Html$li = _elm_lang$html$Html$node('li');
var _elm_lang$html$Html$dl = _elm_lang$html$Html$node('dl');
var _elm_lang$html$Html$dt = _elm_lang$html$Html$node('dt');
var _elm_lang$html$Html$dd = _elm_lang$html$Html$node('dd');
var _elm_lang$html$Html$figure = _elm_lang$html$Html$node('figure');
var _elm_lang$html$Html$figcaption = _elm_lang$html$Html$node('figcaption');
var _elm_lang$html$Html$div = _elm_lang$html$Html$node('div');
var _elm_lang$html$Html$a = _elm_lang$html$Html$node('a');
var _elm_lang$html$Html$em = _elm_lang$html$Html$node('em');
var _elm_lang$html$Html$strong = _elm_lang$html$Html$node('strong');
var _elm_lang$html$Html$small = _elm_lang$html$Html$node('small');
var _elm_lang$html$Html$s = _elm_lang$html$Html$node('s');
var _elm_lang$html$Html$cite = _elm_lang$html$Html$node('cite');
var _elm_lang$html$Html$q = _elm_lang$html$Html$node('q');
var _elm_lang$html$Html$dfn = _elm_lang$html$Html$node('dfn');
var _elm_lang$html$Html$abbr = _elm_lang$html$Html$node('abbr');
var _elm_lang$html$Html$time = _elm_lang$html$Html$node('time');
var _elm_lang$html$Html$code = _elm_lang$html$Html$node('code');
var _elm_lang$html$Html$var = _elm_lang$html$Html$node('var');
var _elm_lang$html$Html$samp = _elm_lang$html$Html$node('samp');
var _elm_lang$html$Html$kbd = _elm_lang$html$Html$node('kbd');
var _elm_lang$html$Html$sub = _elm_lang$html$Html$node('sub');
var _elm_lang$html$Html$sup = _elm_lang$html$Html$node('sup');
var _elm_lang$html$Html$i = _elm_lang$html$Html$node('i');
var _elm_lang$html$Html$b = _elm_lang$html$Html$node('b');
var _elm_lang$html$Html$u = _elm_lang$html$Html$node('u');
var _elm_lang$html$Html$mark = _elm_lang$html$Html$node('mark');
var _elm_lang$html$Html$ruby = _elm_lang$html$Html$node('ruby');
var _elm_lang$html$Html$rt = _elm_lang$html$Html$node('rt');
var _elm_lang$html$Html$rp = _elm_lang$html$Html$node('rp');
var _elm_lang$html$Html$bdi = _elm_lang$html$Html$node('bdi');
var _elm_lang$html$Html$bdo = _elm_lang$html$Html$node('bdo');
var _elm_lang$html$Html$span = _elm_lang$html$Html$node('span');
var _elm_lang$html$Html$br = _elm_lang$html$Html$node('br');
var _elm_lang$html$Html$wbr = _elm_lang$html$Html$node('wbr');
var _elm_lang$html$Html$ins = _elm_lang$html$Html$node('ins');
var _elm_lang$html$Html$del = _elm_lang$html$Html$node('del');
var _elm_lang$html$Html$img = _elm_lang$html$Html$node('img');
var _elm_lang$html$Html$iframe = _elm_lang$html$Html$node('iframe');
var _elm_lang$html$Html$embed = _elm_lang$html$Html$node('embed');
var _elm_lang$html$Html$object = _elm_lang$html$Html$node('object');
var _elm_lang$html$Html$param = _elm_lang$html$Html$node('param');
var _elm_lang$html$Html$video = _elm_lang$html$Html$node('video');
var _elm_lang$html$Html$audio = _elm_lang$html$Html$node('audio');
var _elm_lang$html$Html$source = _elm_lang$html$Html$node('source');
var _elm_lang$html$Html$track = _elm_lang$html$Html$node('track');
var _elm_lang$html$Html$canvas = _elm_lang$html$Html$node('canvas');
var _elm_lang$html$Html$math = _elm_lang$html$Html$node('math');
var _elm_lang$html$Html$table = _elm_lang$html$Html$node('table');
var _elm_lang$html$Html$caption = _elm_lang$html$Html$node('caption');
var _elm_lang$html$Html$colgroup = _elm_lang$html$Html$node('colgroup');
var _elm_lang$html$Html$col = _elm_lang$html$Html$node('col');
var _elm_lang$html$Html$tbody = _elm_lang$html$Html$node('tbody');
var _elm_lang$html$Html$thead = _elm_lang$html$Html$node('thead');
var _elm_lang$html$Html$tfoot = _elm_lang$html$Html$node('tfoot');
var _elm_lang$html$Html$tr = _elm_lang$html$Html$node('tr');
var _elm_lang$html$Html$td = _elm_lang$html$Html$node('td');
var _elm_lang$html$Html$th = _elm_lang$html$Html$node('th');
var _elm_lang$html$Html$form = _elm_lang$html$Html$node('form');
var _elm_lang$html$Html$fieldset = _elm_lang$html$Html$node('fieldset');
var _elm_lang$html$Html$legend = _elm_lang$html$Html$node('legend');
var _elm_lang$html$Html$label = _elm_lang$html$Html$node('label');
var _elm_lang$html$Html$input = _elm_lang$html$Html$node('input');
var _elm_lang$html$Html$button = _elm_lang$html$Html$node('button');
var _elm_lang$html$Html$select = _elm_lang$html$Html$node('select');
var _elm_lang$html$Html$datalist = _elm_lang$html$Html$node('datalist');
var _elm_lang$html$Html$optgroup = _elm_lang$html$Html$node('optgroup');
var _elm_lang$html$Html$option = _elm_lang$html$Html$node('option');
var _elm_lang$html$Html$textarea = _elm_lang$html$Html$node('textarea');
var _elm_lang$html$Html$keygen = _elm_lang$html$Html$node('keygen');
var _elm_lang$html$Html$output = _elm_lang$html$Html$node('output');
var _elm_lang$html$Html$progress = _elm_lang$html$Html$node('progress');
var _elm_lang$html$Html$meter = _elm_lang$html$Html$node('meter');
var _elm_lang$html$Html$details = _elm_lang$html$Html$node('details');
var _elm_lang$html$Html$summary = _elm_lang$html$Html$node('summary');
var _elm_lang$html$Html$menuitem = _elm_lang$html$Html$node('menuitem');
var _elm_lang$html$Html$menu = _elm_lang$html$Html$node('menu');

var _elm_lang$html$Html_Attributes$map = _elm_lang$virtual_dom$VirtualDom$mapProperty;
var _elm_lang$html$Html_Attributes$attribute = _elm_lang$virtual_dom$VirtualDom$attribute;
var _elm_lang$html$Html_Attributes$contextmenu = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'contextmenu', value);
};
var _elm_lang$html$Html_Attributes$draggable = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'draggable', value);
};
var _elm_lang$html$Html_Attributes$itemprop = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'itemprop', value);
};
var _elm_lang$html$Html_Attributes$tabindex = function (n) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'tabIndex',
		_elm_lang$core$Basics$toString(n));
};
var _elm_lang$html$Html_Attributes$charset = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'charset', value);
};
var _elm_lang$html$Html_Attributes$height = function (value) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'height',
		_elm_lang$core$Basics$toString(value));
};
var _elm_lang$html$Html_Attributes$width = function (value) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'width',
		_elm_lang$core$Basics$toString(value));
};
var _elm_lang$html$Html_Attributes$formaction = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'formAction', value);
};
var _elm_lang$html$Html_Attributes$list = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'list', value);
};
var _elm_lang$html$Html_Attributes$minlength = function (n) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'minLength',
		_elm_lang$core$Basics$toString(n));
};
var _elm_lang$html$Html_Attributes$maxlength = function (n) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'maxlength',
		_elm_lang$core$Basics$toString(n));
};
var _elm_lang$html$Html_Attributes$size = function (n) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'size',
		_elm_lang$core$Basics$toString(n));
};
var _elm_lang$html$Html_Attributes$form = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'form', value);
};
var _elm_lang$html$Html_Attributes$cols = function (n) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'cols',
		_elm_lang$core$Basics$toString(n));
};
var _elm_lang$html$Html_Attributes$rows = function (n) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'rows',
		_elm_lang$core$Basics$toString(n));
};
var _elm_lang$html$Html_Attributes$challenge = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'challenge', value);
};
var _elm_lang$html$Html_Attributes$media = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'media', value);
};
var _elm_lang$html$Html_Attributes$rel = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'rel', value);
};
var _elm_lang$html$Html_Attributes$datetime = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'datetime', value);
};
var _elm_lang$html$Html_Attributes$pubdate = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'pubdate', value);
};
var _elm_lang$html$Html_Attributes$colspan = function (n) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'colspan',
		_elm_lang$core$Basics$toString(n));
};
var _elm_lang$html$Html_Attributes$rowspan = function (n) {
	return A2(
		_elm_lang$html$Html_Attributes$attribute,
		'rowspan',
		_elm_lang$core$Basics$toString(n));
};
var _elm_lang$html$Html_Attributes$manifest = function (value) {
	return A2(_elm_lang$html$Html_Attributes$attribute, 'manifest', value);
};
var _elm_lang$html$Html_Attributes$property = _elm_lang$virtual_dom$VirtualDom$property;
var _elm_lang$html$Html_Attributes$stringProperty = F2(
	function (name, string) {
		return A2(
			_elm_lang$html$Html_Attributes$property,
			name,
			_elm_lang$core$Json_Encode$string(string));
	});
var _elm_lang$html$Html_Attributes$class = function (name) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('className', name);
};
var _elm_lang$html$Html_Attributes$id = function (name) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('id', name);
};
var _elm_lang$html$Html_Attributes$title = function (name) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('title', name);
};
var _elm_lang$html$Html_Attributes$accesskey = function ($char) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('accessKey', _elm_lang$core$String$fromChar($char));
};
var _elm_lang$html$Html_Attributes$dir = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('dir', value);
};
var _elm_lang$html$Html_Attributes$dropzone = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('dropzone', value);
};
var _elm_lang$html$Html_Attributes$lang = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('lang', value);
};
var _elm_lang$html$Html_Attributes$content = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('content', value);
};
var _elm_lang$html$Html_Attributes$httpEquiv = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('httpEquiv', value);
};
var _elm_lang$html$Html_Attributes$language = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('language', value);
};
var _elm_lang$html$Html_Attributes$src = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('src', value);
};
var _elm_lang$html$Html_Attributes$alt = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('alt', value);
};
var _elm_lang$html$Html_Attributes$preload = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('preload', value);
};
var _elm_lang$html$Html_Attributes$poster = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('poster', value);
};
var _elm_lang$html$Html_Attributes$kind = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('kind', value);
};
var _elm_lang$html$Html_Attributes$srclang = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('srclang', value);
};
var _elm_lang$html$Html_Attributes$sandbox = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('sandbox', value);
};
var _elm_lang$html$Html_Attributes$srcdoc = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('srcdoc', value);
};
var _elm_lang$html$Html_Attributes$type_ = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('type', value);
};
var _elm_lang$html$Html_Attributes$value = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('value', value);
};
var _elm_lang$html$Html_Attributes$defaultValue = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('defaultValue', value);
};
var _elm_lang$html$Html_Attributes$placeholder = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('placeholder', value);
};
var _elm_lang$html$Html_Attributes$accept = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('accept', value);
};
var _elm_lang$html$Html_Attributes$acceptCharset = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('acceptCharset', value);
};
var _elm_lang$html$Html_Attributes$action = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('action', value);
};
var _elm_lang$html$Html_Attributes$autocomplete = function (bool) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('autocomplete', bool ? 'on' : 'off');
};
var _elm_lang$html$Html_Attributes$enctype = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('enctype', value);
};
var _elm_lang$html$Html_Attributes$method = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('method', value);
};
var _elm_lang$html$Html_Attributes$name = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('name', value);
};
var _elm_lang$html$Html_Attributes$pattern = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('pattern', value);
};
var _elm_lang$html$Html_Attributes$for = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('htmlFor', value);
};
var _elm_lang$html$Html_Attributes$max = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('max', value);
};
var _elm_lang$html$Html_Attributes$min = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('min', value);
};
var _elm_lang$html$Html_Attributes$step = function (n) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('step', n);
};
var _elm_lang$html$Html_Attributes$wrap = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('wrap', value);
};
var _elm_lang$html$Html_Attributes$usemap = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('useMap', value);
};
var _elm_lang$html$Html_Attributes$shape = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('shape', value);
};
var _elm_lang$html$Html_Attributes$coords = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('coords', value);
};
var _elm_lang$html$Html_Attributes$keytype = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('keytype', value);
};
var _elm_lang$html$Html_Attributes$align = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('align', value);
};
var _elm_lang$html$Html_Attributes$cite = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('cite', value);
};
var _elm_lang$html$Html_Attributes$href = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('href', value);
};
var _elm_lang$html$Html_Attributes$target = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('target', value);
};
var _elm_lang$html$Html_Attributes$downloadAs = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('download', value);
};
var _elm_lang$html$Html_Attributes$hreflang = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('hreflang', value);
};
var _elm_lang$html$Html_Attributes$ping = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('ping', value);
};
var _elm_lang$html$Html_Attributes$start = function (n) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('start', _elm_lang$core$Basics$toString(n));
};
var _elm_lang$html$Html_Attributes$headers = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('headers', value);
};
var _elm_lang$html$Html_Attributes$scope = function (value) {
	return _elm_lang$html$Html_Attributes$stringProperty.func('scope', value);
};
var _elm_lang$html$Html_Attributes$boolProperty = F2(
	function (name, bool) {
		return A2(
			_elm_lang$html$Html_Attributes$property,
			name,
			_elm_lang$core$Json_Encode$bool(bool));
	});
var _elm_lang$html$Html_Attributes$hidden = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('hidden', bool);
};
var _elm_lang$html$Html_Attributes$contenteditable = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('contentEditable', bool);
};
var _elm_lang$html$Html_Attributes$spellcheck = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('spellcheck', bool);
};
var _elm_lang$html$Html_Attributes$async = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('async', bool);
};
var _elm_lang$html$Html_Attributes$defer = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('defer', bool);
};
var _elm_lang$html$Html_Attributes$scoped = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('scoped', bool);
};
var _elm_lang$html$Html_Attributes$autoplay = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('autoplay', bool);
};
var _elm_lang$html$Html_Attributes$controls = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('controls', bool);
};
var _elm_lang$html$Html_Attributes$loop = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('loop', bool);
};
var _elm_lang$html$Html_Attributes$default = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('default', bool);
};
var _elm_lang$html$Html_Attributes$seamless = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('seamless', bool);
};
var _elm_lang$html$Html_Attributes$checked = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('checked', bool);
};
var _elm_lang$html$Html_Attributes$selected = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('selected', bool);
};
var _elm_lang$html$Html_Attributes$autofocus = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('autofocus', bool);
};
var _elm_lang$html$Html_Attributes$disabled = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('disabled', bool);
};
var _elm_lang$html$Html_Attributes$multiple = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('multiple', bool);
};
var _elm_lang$html$Html_Attributes$novalidate = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('noValidate', bool);
};
var _elm_lang$html$Html_Attributes$readonly = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('readOnly', bool);
};
var _elm_lang$html$Html_Attributes$required = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('required', bool);
};
var _elm_lang$html$Html_Attributes$ismap = function (value) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('isMap', value);
};
var _elm_lang$html$Html_Attributes$download = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('download', bool);
};
var _elm_lang$html$Html_Attributes$reversed = function (bool) {
	return _elm_lang$html$Html_Attributes$boolProperty.func('reversed', bool);
};
var _elm_lang$html$Html_Attributes$classList = function (list) {
	return _elm_lang$html$Html_Attributes$class(
		A2(
			_elm_lang$core$String$join,
			' ',
			_elm_lang$core$List$map.func(
                _elm_lang$core$Tuple$first,
                _elm_lang$core$List$filter.func(_elm_lang$core$Tuple$second, list)
            )));
};
var _elm_lang$html$Html_Attributes$style = _elm_lang$virtual_dom$VirtualDom$style;

var _elm_lang$html$Html_Events$keyCode = A2(_elm_lang$core$Json_Decode$field, 'keyCode', _elm_lang$core$Json_Decode$int);
var _elm_lang$html$Html_Events$targetChecked = _elm_lang$core$Json_Decode$at.func({
    ctor: '::',
    _0: 'target',
    _1: {
        ctor: '::',
        _0: 'checked',
        _1: {ctor: '[]'}
    }
}, _elm_lang$core$Json_Decode$bool);
var _elm_lang$html$Html_Events$targetValue = _elm_lang$core$Json_Decode$at.func({
    ctor: '::',
    _0: 'target',
    _1: {
        ctor: '::',
        _0: 'value',
        _1: {ctor: '[]'}
    }
}, _elm_lang$core$Json_Decode$string);
var _elm_lang$html$Html_Events$defaultOptions = _elm_lang$virtual_dom$VirtualDom$defaultOptions;
var _elm_lang$html$Html_Events$onWithOptions = _elm_lang$virtual_dom$VirtualDom$onWithOptions;
var _elm_lang$html$Html_Events$on = _elm_lang$virtual_dom$VirtualDom$on;
var _elm_lang$html$Html_Events$onFocus = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'focus',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onBlur = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'blur',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onSubmitOptions = _elm_lang$core$Native_Utils.update(
	_elm_lang$html$Html_Events$defaultOptions,
	{preventDefault: true});
var _elm_lang$html$Html_Events$onSubmit = function (msg) {
	return A3(
		_elm_lang$html$Html_Events$onWithOptions,
		'submit',
		_elm_lang$html$Html_Events$onSubmitOptions,
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onCheck = function (tagger) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'change',
		A2(_elm_lang$core$Json_Decode$map, tagger, _elm_lang$html$Html_Events$targetChecked));
};
var _elm_lang$html$Html_Events$onInput = function (tagger) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'input',
		A2(_elm_lang$core$Json_Decode$map, tagger, _elm_lang$html$Html_Events$targetValue));
};
var _elm_lang$html$Html_Events$onMouseOut = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'mouseout',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onMouseOver = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'mouseover',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onMouseLeave = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'mouseleave',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onMouseEnter = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'mouseenter',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onMouseUp = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'mouseup',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onMouseDown = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'mousedown',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onDoubleClick = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'dblclick',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$onClick = function (msg) {
	return A2(
		_elm_lang$html$Html_Events$on,
		'click',
		_elm_lang$core$Json_Decode$succeed(msg));
};
var _elm_lang$html$Html_Events$Options = F2(
	function (a, b) {
		return {stopPropagation: a, preventDefault: b};
	});

var _elm_lang$html$Html_Keyed$node = _elm_lang$virtual_dom$VirtualDom$keyedNode;
var _elm_lang$html$Html_Keyed$ol = _elm_lang$html$Html_Keyed$node('ol');
var _elm_lang$html$Html_Keyed$ul = _elm_lang$html$Html_Keyed$node('ul');

var _user$project$Coverage$fromAnnotation = F2(
	function (settings, annotation) {
		var _p0 = annotation;
		switch (_p0) {
			case 'declaration':
				return settings.declaration;
			case 'letDeclaration':
				return settings.letDeclaration;
			case 'lambdaBody':
				return settings.lambdaBody;
			case 'caseBranch':
				return settings.caseBranch;
			case 'ifElseBranch':
				return settings.ifElseBranch;
			default:
				return settings.$default;
		}
	});
var _user$project$Coverage$ifElseBranch = 'ifElseBranch';
var _user$project$Coverage$caseBranch = 'caseBranch';
var _user$project$Coverage$lambdaBody = 'lambdaBody';
var _user$project$Coverage$letDeclaration = 'letDeclaration';
var _user$project$Coverage$declaration = 'declaration';
var _user$project$Coverage$annotationType = function (annotation) {
	var _p1 = annotation;
	switch (_p1.ctor) {
		case 'Declaration':
			return _user$project$Coverage$declaration;
		case 'LetDeclaration':
			return _user$project$Coverage$letDeclaration;
		case 'LambdaBody':
			return _user$project$Coverage$lambdaBody;
		case 'CaseBranch':
			return _user$project$Coverage$caseBranch;
		default:
			return _user$project$Coverage$ifElseBranch;
	}
};
var _user$project$Coverage$index = function (input) {
	return _elm_lang$core$Tuple$first(
		_elm_lang$core$List$foldl.func(F2(
            function (line, _p2) {
                var _p3 = _p2;
                var _p4 = _p3._1;
                return {
                    ctor: '_Tuple2',
                    _0: _Skinney$elm_array_exploration$Array_Hamt$push.func(_p4, _p3._0),
                    _1: (_p4 + _elm_lang$core$String$length(line)) + 1
                };
            }), {ctor: '_Tuple2', _0: _Skinney$elm_array_exploration$Array_Hamt$empty, _1: 0}, _elm_lang$core$String$lines(input)));
};
var _user$project$Coverage$withComplexity = function (tag) {
	return A2(
		_elm_lang$core$Json_Decode$map,
		tag,
		A2(_elm_lang$core$Json_Decode$field, 'complexity', _elm_lang$core$Json_Decode$int));
};
var _user$project$Coverage$typeIs = F2(
	function (expectedValue, decoder) {
		return A2(
			_elm_lang$core$Json_Decode$andThen,
			function (actual) {
				return _elm_lang$core$Native_Utils.eq(actual, expectedValue) ? decoder : _elm_lang$core$Json_Decode$fail('not this one');
			},
			A2(_elm_lang$core$Json_Decode$field, 'type', _elm_lang$core$Json_Decode$string));
	});
var _user$project$Coverage$evaluationCountDecoder = _elm_lang$core$Json_Decode$oneOf(
	{
		ctor: '::',
		_0: A2(_elm_lang$core$Json_Decode$field, 'count', _elm_lang$core$Json_Decode$int),
		_1: {
			ctor: '::',
			_0: _elm_lang$core$Json_Decode$succeed(0),
			_1: {ctor: '[]'}
		}
	});
var _user$project$Coverage$position = A3(
	_elm_lang$core$Json_Decode$map2,
	F2(
		function (v0, v1) {
			return {ctor: '_Tuple2', _0: v0, _1: v1};
		}),
	A2(_elm_lang$core$Json_Decode$field, 'line', _elm_lang$core$Json_Decode$int),
	A2(_elm_lang$core$Json_Decode$field, 'column', _elm_lang$core$Json_Decode$int));
var _user$project$Coverage$column = _elm_lang$core$Tuple$second;
var _user$project$Coverage$line = _elm_lang$core$Tuple$first;
var _user$project$Coverage$positionToOffset = F2(
	function (position, idx) {
		return _elm_lang$core$Maybe$map.func(function (offSet) {
            return (offSet + _user$project$Coverage$column(position)) - 1;
        }, _Skinney$elm_array_exploration$Array_Hamt$get.func(_user$project$Coverage$line(position) - 1, idx));
	});
var _user$project$Coverage$complexity = function (annotation) {
	var _p5 = annotation;
	switch (_p5.ctor) {
		case 'Declaration':
			return _elm_lang$core$Maybe$Just(_p5._1);
		case 'LetDeclaration':
			return _elm_lang$core$Maybe$Just(_p5._0);
		case 'LambdaBody':
			return _elm_lang$core$Maybe$Just(_p5._0);
		default:
			return _elm_lang$core$Maybe$Nothing;
	}
};
var _user$project$Coverage$Region = F2(
	function (a, b) {
		return {from: a, to: b};
	});
var _user$project$Coverage$regionDecoder = A3(
	_elm_lang$core$Json_Decode$map2,
	_user$project$Coverage$Region,
	A2(_elm_lang$core$Json_Decode$field, 'from', _user$project$Coverage$position),
	A2(_elm_lang$core$Json_Decode$field, 'to', _user$project$Coverage$position));
var _user$project$Coverage$IfElseBranch = {ctor: 'IfElseBranch'};
var _user$project$Coverage$CaseBranch = {ctor: 'CaseBranch'};
var _user$project$Coverage$LambdaBody = function (a) {
	return {ctor: 'LambdaBody', _0: a};
};
var _user$project$Coverage$LetDeclaration = function (a) {
	return {ctor: 'LetDeclaration', _0: a};
};
var _user$project$Coverage$Declaration = F2(
	function (a, b) {
		return {ctor: 'Declaration', _0: a, _1: b};
	});
var _user$project$Coverage$declarationDecoder = A3(
	_elm_lang$core$Json_Decode$map2,
	_user$project$Coverage$Declaration,
	A2(_elm_lang$core$Json_Decode$field, 'name', _elm_lang$core$Json_Decode$string),
	A2(_elm_lang$core$Json_Decode$field, 'complexity', _elm_lang$core$Json_Decode$int));
var _user$project$Coverage$annotationDecoder = _elm_lang$core$Json_Decode$oneOf(
	{
		ctor: '::',
		_0: _user$project$Coverage$typeIs.func('declaration', _user$project$Coverage$declarationDecoder),
		_1: {
			ctor: '::',
			_0: _user$project$Coverage$typeIs.func(
                'letDeclaration',
                _user$project$Coverage$withComplexity(_user$project$Coverage$LetDeclaration)
            ),
			_1: {
				ctor: '::',
				_0: _user$project$Coverage$typeIs.func(
                    'lambdaBody',
                    _user$project$Coverage$withComplexity(_user$project$Coverage$LambdaBody)
                ),
				_1: {
					ctor: '::',
					_0: _user$project$Coverage$typeIs.func(
                        'caseBranch',
                        _elm_lang$core$Json_Decode$succeed(_user$project$Coverage$CaseBranch)
                    ),
					_1: {
						ctor: '::',
						_0: _user$project$Coverage$typeIs.func(
                            'ifElseBranch',
                            _elm_lang$core$Json_Decode$succeed(_user$project$Coverage$IfElseBranch)
                        ),
						_1: {ctor: '[]'}
					}
				}
			}
		}
	});
var _user$project$Coverage$annotationInfoDecoder = A4(
	_elm_lang$core$Json_Decode$map3,
	F3(
		function (v0, v1, v2) {
			return {ctor: '_Tuple3', _0: v0, _1: v1, _2: v2};
		}),
	_user$project$Coverage$regionDecoder,
	_user$project$Coverage$annotationDecoder,
	_user$project$Coverage$evaluationCountDecoder);
var _user$project$Coverage$regionsDecoder = A2(
	_elm_lang$core$Json_Decode$map,
	_Skinney$elm_dict_exploration$Dict_LLRB$fromList,
	_elm_lang$core$Json_Decode$keyValuePairs(
		_elm_lang$core$Json_Decode$list(_user$project$Coverage$annotationInfoDecoder)));

var _zwilias$elm_html_string$Html_Types$indent = F3(
	function (perLevel, level, x) {
		return A2(
			_elm_lang$core$Basics_ops['++'],
			A2(_elm_lang$core$String$repeat, perLevel * level, ' '),
			x);
	});
var _zwilias$elm_html_string$Html_Types$closingTag = function (tagName) {
	return A2(
		_elm_lang$core$Basics_ops['++'],
		'</',
		A2(_elm_lang$core$Basics_ops['++'], tagName, '>'));
};
var _zwilias$elm_html_string$Html_Types$hyphenate = A2(
	_elm_lang$core$String$foldl,
	F2(
		function ($char, acc) {
			return _elm_lang$core$Char$isUpper($char) ? A2(
				_elm_lang$core$Basics_ops['++'],
				acc,
				A2(
					_elm_lang$core$Basics_ops['++'],
					'-',
					_elm_lang$core$String$fromChar(
						_elm_lang$core$Char$toLower($char)))) : A2(
				_elm_lang$core$Basics_ops['++'],
				acc,
				_elm_lang$core$String$fromChar($char));
		}),
	'');
var _zwilias$elm_html_string$Html_Types$escape = A2(
	_elm_lang$core$String$foldl,
	F2(
		function ($char, acc) {
			return _elm_lang$core$Native_Utils.eq(
				$char,
				_elm_lang$core$Native_Utils.chr('\"')) ? A2(_elm_lang$core$Basics_ops['++'], acc, '\\\"') : A2(
				_elm_lang$core$Basics_ops['++'],
				acc,
				_elm_lang$core$String$fromChar($char));
		}),
	'');
var _zwilias$elm_html_string$Html_Types$buildProp = F2(
	function (key, value) {
		return A2(
			_elm_lang$core$Basics_ops['++'],
			_zwilias$elm_html_string$Html_Types$hyphenate(key),
			A2(
				_elm_lang$core$Basics_ops['++'],
				'=\"',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_zwilias$elm_html_string$Html_Types$escape(value),
					'\"')));
	});
var _zwilias$elm_html_string$Html_Types$propName = function (prop) {
	var _p0 = prop;
	switch (_p0) {
		case 'className':
			return 'class';
		case 'defaultValue':
			return 'value';
		case 'htmlFor':
			return 'for';
		default:
			return prop;
	}
};
var _zwilias$elm_html_string$Html_Types$attributeToString = function (attribute) {
	var _p1 = attribute;
	switch (_p1.ctor) {
		case 'Attribute':
			return _elm_lang$core$Maybe$Just(
				_zwilias$elm_html_string$Html_Types$buildProp.func(_p1._0, _p1._1));
		case 'StringProperty':
			return _elm_lang$core$Maybe$Just(
				_zwilias$elm_html_string$Html_Types$buildProp.func(_zwilias$elm_html_string$Html_Types$propName(_p1._0), _p1._1));
		case 'BoolProperty':
			return _p1._1 ? _elm_lang$core$Maybe$Just(
				_zwilias$elm_html_string$Html_Types$hyphenate(
					_zwilias$elm_html_string$Html_Types$propName(_p1._0))) : _elm_lang$core$Maybe$Nothing;
		case 'ValueProperty':
			return _elm_lang$core$Maybe$Just(
				_zwilias$elm_html_string$Html_Types$buildProp.func(
                    _zwilias$elm_html_string$Html_Types$propName(_p1._0),
                    _elm_lang$core$Basics$toString(_p1._1)
                ));
		case 'Style':
			return _elm_lang$core$Maybe$Just(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'style=\"',
					A2(
						_elm_lang$core$Basics_ops['++'],
						A2(
							_elm_lang$core$String$join,
							'; ',
							_elm_lang$core$List$map.func(function (_p2) {
                                var _p3 = _p2;
                                return A2(
                                    _elm_lang$core$Basics_ops['++'],
                                    _p3._0,
                                    A2(_elm_lang$core$Basics_ops['++'], ': ', _p3._1));
                            }, _p1._0)),
						'\"')));
		default:
			return _elm_lang$core$Maybe$Nothing;
	}
};
var _zwilias$elm_html_string$Html_Types$tag = F2(
	function (tagName, attributes) {
		return A2(
			_elm_lang$core$Basics_ops['++'],
			'<',
			A2(
				_elm_lang$core$Basics_ops['++'],
				A2(
					_elm_lang$core$String$join,
					' ',
					{
						ctor: '::',
						_0: tagName,
						_1: _elm_lang$core$List$filterMap.func(_zwilias$elm_html_string$Html_Types$attributeToString, attributes)
					}),
				'>'));
	});
var _zwilias$elm_html_string$Html_Types$toStringHelper = F3(
	function (indenter, tags, acc) {
		toStringHelper:
		while (true) {
			var _p4 = tags;
			if (_p4.ctor === '[]') {
				var _p5 = acc.stack;
				if (_p5.ctor === '[]') {
					return acc;
				} else {
					var _v5 = indenter,
						_v6 = _p5._0._1,
						_v7 = _elm_lang$core$Native_Utils.update(
						acc,
						{
							result: {
								ctor: '::',
								_0: A2(
									indenter,
									acc.depth - 1,
									_zwilias$elm_html_string$Html_Types$closingTag(_p5._0._0)),
								_1: acc.result
							},
							depth: acc.depth - 1,
							stack: _p5._1
						});
					indenter = _v5;
					tags = _v6;
					acc = _v7;
					continue toStringHelper;
				}
			} else {
				if (_p4._0.ctor === 'Node') {
					var _p9 = _p4._0._0;
					var _p8 = _p4._1;
					var _p7 = _p4._0._1;
					var _p6 = _p4._0._2;
					switch (_p6.ctor) {
						case 'NoChildren':
							var _v9 = indenter,
								_v10 = _p8,
								_v11 = _elm_lang$core$Native_Utils.update(
								acc,
								{
									result: {
										ctor: '::',
										_0: A2(
											indenter,
											acc.depth,
											_zwilias$elm_html_string$Html_Types$tag.func(_p9, _p7)),
										_1: acc.result
									}
								});
							indenter = _v9;
							tags = _v10;
							acc = _v11;
							continue toStringHelper;
						case 'Regular':
							var _v12 = indenter,
								_v13 = _p6._0,
								_v14 = _elm_lang$core$Native_Utils.update(
								acc,
								{
									result: {
										ctor: '::',
										_0: A2(
											indenter,
											acc.depth,
											_zwilias$elm_html_string$Html_Types$tag.func(_p9, _p7)),
										_1: acc.result
									},
									depth: acc.depth + 1,
									stack: {
										ctor: '::',
										_0: {ctor: '_Tuple2', _0: _p9, _1: _p8},
										_1: acc.stack
									}
								});
							indenter = _v12;
							tags = _v13;
							acc = _v14;
							continue toStringHelper;
						default:
							var _v15 = indenter,
								_v16 = _elm_lang$core$List$map.func(_elm_lang$core$Tuple$second, _p6._0),
								_v17 = _elm_lang$core$Native_Utils.update(
								acc,
								{
									result: {
										ctor: '::',
										_0: A2(
											indenter,
											acc.depth,
											_zwilias$elm_html_string$Html_Types$tag.func(_p9, _p7)),
										_1: acc.result
									},
									depth: acc.depth + 1,
									stack: {
										ctor: '::',
										_0: {ctor: '_Tuple2', _0: _p9, _1: _p8},
										_1: acc.stack
									}
								});
							indenter = _v15;
							tags = _v16;
							acc = _v17;
							continue toStringHelper;
					}
				} else {
					var _v18 = indenter,
						_v19 = _p4._1,
						_v20 = _elm_lang$core$Native_Utils.update(
						acc,
						{
							result: {
								ctor: '::',
								_0: A2(indenter, acc.depth, _p4._0._0),
								_1: acc.result
							}
						});
					indenter = _v18;
					tags = _v19;
					acc = _v20;
					continue toStringHelper;
				}
			}
		}
	});
var _zwilias$elm_html_string$Html_Types$join = F2(
	function (between, list) {
		var _p10 = list;
		if (_p10.ctor === '[]') {
			return '';
		} else {
			if (_p10._1.ctor === '[]') {
				return _p10._0;
			} else {
				return _elm_lang$core$List$foldl.func(F2(
                    function (y, acc) {
                        return A2(
                            _elm_lang$core$Basics_ops['++'],
                            y,
                            A2(_elm_lang$core$Basics_ops['++'], between, acc));
                    }), _p10._0, _p10._1);
			}
		}
	});
var _zwilias$elm_html_string$Html_Types$toString = F2(
	function (depth, html) {
		var initialAcc = {
			depth: 0,
			stack: {ctor: '[]'},
			result: {ctor: '[]'}
		};
		var joinString = function () {
			var _p11 = depth;
			if (_p11 === 0) {
				return '';
			} else {
				return '\n';
			}
		}();
		var indenter = function () {
			var _p12 = depth;
			if (_p12 === 0) {
				return _elm_lang$core$Basics$always(_elm_lang$core$Basics$identity);
			} else {
				return _zwilias$elm_html_string$Html_Types$indent(depth);
			}
		}();
		return _zwilias$elm_html_string$Html_Types$join.func(joinString, function (_) {
            return _.result;
        }(
            _zwilias$elm_html_string$Html_Types$toStringHelper.func(indenter, {
                ctor: '::',
                _0: html,
                _1: {ctor: '[]'}
            }, initialAcc)));
	});
var _zwilias$elm_html_string$Html_Types$attributeToHtml = function (attribute) {
	var _p13 = attribute;
	switch (_p13.ctor) {
		case 'Attribute':
			return A2(_elm_lang$html$Html_Attributes$attribute, _p13._0, _p13._1);
		case 'StringProperty':
			return A2(
				_elm_lang$html$Html_Attributes$property,
				_p13._0,
				_elm_lang$core$Json_Encode$string(_p13._1));
		case 'BoolProperty':
			return A2(
				_elm_lang$html$Html_Attributes$property,
				_p13._0,
				_elm_lang$core$Json_Encode$bool(_p13._1));
		case 'ValueProperty':
			return A2(_elm_lang$html$Html_Attributes$property, _p13._0, _p13._1);
		case 'Style':
			return _elm_lang$html$Html_Attributes$style(_p13._0);
		default:
			return A3(_elm_lang$html$Html_Events$onWithOptions, _p13._0, _p13._1, _p13._2);
	}
};
var _zwilias$elm_html_string$Html_Types$toHtml = function (node) {
	var _p14 = node;
	if (_p14.ctor === 'Node') {
		var _p17 = _p14._0;
		var _p16 = _p14._1;
		var _p15 = _p14._2;
		switch (_p15.ctor) {
			case 'NoChildren':
				return A3(
					_elm_lang$html$Html$node,
					_p17,
					_elm_lang$core$List$map.func(_zwilias$elm_html_string$Html_Types$attributeToHtml, _p16),
					{ctor: '[]'});
			case 'Regular':
				return A3(
					_elm_lang$html$Html$node,
					_p17,
					_elm_lang$core$List$map.func(_zwilias$elm_html_string$Html_Types$attributeToHtml, _p16),
					_elm_lang$core$List$map.func(_zwilias$elm_html_string$Html_Types$toHtml, _p15._0));
			default:
				return A3(
					_elm_lang$html$Html_Keyed$node,
					_p17,
					_elm_lang$core$List$map.func(_zwilias$elm_html_string$Html_Types$attributeToHtml, _p16),
					_elm_lang$core$List$map.func(
                        _elm_lang$core$Tuple$mapSecond(_zwilias$elm_html_string$Html_Types$toHtml),
                        _p15._0
                    ));
		}
	} else {
		return _elm_lang$html$Html$text(_p14._0);
	}
};
var _zwilias$elm_html_string$Html_Types$Acc = F3(
	function (a, b, c) {
		return {depth: a, stack: b, result: c};
	});
var _zwilias$elm_html_string$Html_Types$Keyed = function (a) {
	return {ctor: 'Keyed', _0: a};
};
var _zwilias$elm_html_string$Html_Types$Regular = function (a) {
	return {ctor: 'Regular', _0: a};
};
var _zwilias$elm_html_string$Html_Types$NoChildren = {ctor: 'NoChildren'};
var _zwilias$elm_html_string$Html_Types$TextNode = function (a) {
	return {ctor: 'TextNode', _0: a};
};
var _zwilias$elm_html_string$Html_Types$Node = F3(
	function (a, b, c) {
		return {ctor: 'Node', _0: a, _1: b, _2: c};
	});
var _zwilias$elm_html_string$Html_Types$Event = F3(
	function (a, b, c) {
		return {ctor: 'Event', _0: a, _1: b, _2: c};
	});
var _zwilias$elm_html_string$Html_Types$Style = function (a) {
	return {ctor: 'Style', _0: a};
};
var _zwilias$elm_html_string$Html_Types$ValueProperty = F2(
	function (a, b) {
		return {ctor: 'ValueProperty', _0: a, _1: b};
	});
var _zwilias$elm_html_string$Html_Types$BoolProperty = F2(
	function (a, b) {
		return {ctor: 'BoolProperty', _0: a, _1: b};
	});
var _zwilias$elm_html_string$Html_Types$StringProperty = F2(
	function (a, b) {
		return {ctor: 'StringProperty', _0: a, _1: b};
	});
var _zwilias$elm_html_string$Html_Types$Attribute = F2(
	function (a, b) {
		return {ctor: 'Attribute', _0: a, _1: b};
	});
var _zwilias$elm_html_string$Html_Types$mapAttribute = F2(
	function (f, attribute) {
		var _p18 = attribute;
		switch (_p18.ctor) {
			case 'Attribute':
				return _zwilias$elm_html_string$Html_Types$Attribute.func(_p18._0, _p18._1);
			case 'StringProperty':
				return _zwilias$elm_html_string$Html_Types$StringProperty.func(_p18._0, _p18._1);
			case 'BoolProperty':
				return _zwilias$elm_html_string$Html_Types$BoolProperty.func(_p18._0, _p18._1);
			case 'ValueProperty':
				return _zwilias$elm_html_string$Html_Types$ValueProperty.func(_p18._0, _p18._1);
			case 'Style':
				return _zwilias$elm_html_string$Html_Types$Style(_p18._0);
			default:
				return _zwilias$elm_html_string$Html_Types$Event.func(_p18._0, _p18._1, A2(_elm_lang$core$Json_Decode$map, f, _p18._2));
		}
	});
var _zwilias$elm_html_string$Html_Types$map = F2(
	function (f, node) {
		var _p19 = node;
		if (_p19.ctor === 'Node') {
			return _zwilias$elm_html_string$Html_Types$Node.func(
                _p19._0,
                _elm_lang$core$List$map.func(_zwilias$elm_html_string$Html_Types$mapAttribute(f), _p19._1),
                _zwilias$elm_html_string$Html_Types$mapChildren.func(f, _p19._2)
            );
		} else {
			return _zwilias$elm_html_string$Html_Types$TextNode(_p19._0);
		}
	});
var _zwilias$elm_html_string$Html_Types$mapChildren = F2(
	function (f, children) {
		var _p20 = children;
		switch (_p20.ctor) {
			case 'NoChildren':
				return _zwilias$elm_html_string$Html_Types$NoChildren;
			case 'Regular':
				return _zwilias$elm_html_string$Html_Types$Regular(
					_elm_lang$core$List$map.func(_zwilias$elm_html_string$Html_Types$map(f), _p20._0));
			default:
				return _zwilias$elm_html_string$Html_Types$Keyed(
					_elm_lang$core$List$map.func(_elm_lang$core$Tuple$mapSecond(
                        _zwilias$elm_html_string$Html_Types$map(f)), _p20._0));
		}
	});

var _zwilias$elm_html_string$Html_String$text = _zwilias$elm_html_string$Html_Types$TextNode;
var _zwilias$elm_html_string$Html_String$toString = function (indent) {
	return _zwilias$elm_html_string$Html_Types$toString(indent);
};
var _zwilias$elm_html_string$Html_String$toHtml = _zwilias$elm_html_string$Html_Types$toHtml;
var _zwilias$elm_html_string$Html_String$program = function (config) {
	return _elm_lang$html$Html$program(
		_elm_lang$core$Native_Utils.update(
			config,
			{
				view: function (_p0) {
					return _zwilias$elm_html_string$Html_String$toHtml(
						config.view(_p0));
				}
			}));
};
var _zwilias$elm_html_string$Html_String$beginnerProgram = function (_p1) {
	var _p2 = _p1;
	return _zwilias$elm_html_string$Html_String$program(
		{
			init: A2(
				_elm_lang$core$Platform_Cmd_ops['!'],
				_p2.model,
				{ctor: '[]'}),
			update: F2(
				function (msg, model) {
					return A2(
						_elm_lang$core$Platform_Cmd_ops['!'],
						A2(_p2.update, msg, model),
						{ctor: '[]'});
				}),
			view: _p2.view,
			subscriptions: function (_p3) {
				return _elm_lang$core$Platform_Sub$none;
			}
		});
};
var _zwilias$elm_html_string$Html_String$programWithFlags = function (config) {
	return _elm_lang$html$Html$programWithFlags(
		_elm_lang$core$Native_Utils.update(
			config,
			{
				view: function (_p4) {
					return _zwilias$elm_html_string$Html_String$toHtml(
						config.view(_p4));
				}
			}));
};
var _zwilias$elm_html_string$Html_String$map = _zwilias$elm_html_string$Html_Types$map;
var _zwilias$elm_html_string$Html_String$nodeWithoutChildren = F3(
	function (tag, attrs, _p5) {
		return _zwilias$elm_html_string$Html_Types$Node.func(tag, attrs, _zwilias$elm_html_string$Html_Types$NoChildren);
	});
var _zwilias$elm_html_string$Html_String$hr = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('hr');
var _zwilias$elm_html_string$Html_String$br = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('br');
var _zwilias$elm_html_string$Html_String$wbr = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('wbr');
var _zwilias$elm_html_string$Html_String$img = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('img');
var _zwilias$elm_html_string$Html_String$embed = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('embed');
var _zwilias$elm_html_string$Html_String$param = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('param');
var _zwilias$elm_html_string$Html_String$source = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('source');
var _zwilias$elm_html_string$Html_String$track = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('track');
var _zwilias$elm_html_string$Html_String$col = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('col');
var _zwilias$elm_html_string$Html_String$input = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('input');
var _zwilias$elm_html_string$Html_String$keygen = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('keygen');
var _zwilias$elm_html_string$Html_String$menuitem = _zwilias$elm_html_string$Html_String$nodeWithoutChildren('menuitem');
var _zwilias$elm_html_string$Html_String$node = F3(
	function (tag, attributes, children) {
		return _zwilias$elm_html_string$Html_Types$Node.func(tag, attributes, _zwilias$elm_html_string$Html_Types$Regular(children));
	});
var _zwilias$elm_html_string$Html_String$body = _zwilias$elm_html_string$Html_String$node('body');
var _zwilias$elm_html_string$Html_String$section = _zwilias$elm_html_string$Html_String$node('section');
var _zwilias$elm_html_string$Html_String$nav = _zwilias$elm_html_string$Html_String$node('nav');
var _zwilias$elm_html_string$Html_String$article = _zwilias$elm_html_string$Html_String$node('article');
var _zwilias$elm_html_string$Html_String$aside = _zwilias$elm_html_string$Html_String$node('aside');
var _zwilias$elm_html_string$Html_String$h1 = _zwilias$elm_html_string$Html_String$node('h1');
var _zwilias$elm_html_string$Html_String$h2 = _zwilias$elm_html_string$Html_String$node('h2');
var _zwilias$elm_html_string$Html_String$h3 = _zwilias$elm_html_string$Html_String$node('h3');
var _zwilias$elm_html_string$Html_String$h4 = _zwilias$elm_html_string$Html_String$node('h4');
var _zwilias$elm_html_string$Html_String$h5 = _zwilias$elm_html_string$Html_String$node('h5');
var _zwilias$elm_html_string$Html_String$h6 = _zwilias$elm_html_string$Html_String$node('h6');
var _zwilias$elm_html_string$Html_String$header = _zwilias$elm_html_string$Html_String$node('header');
var _zwilias$elm_html_string$Html_String$footer = _zwilias$elm_html_string$Html_String$node('footer');
var _zwilias$elm_html_string$Html_String$address = _zwilias$elm_html_string$Html_String$node('address');
var _zwilias$elm_html_string$Html_String$main_ = _zwilias$elm_html_string$Html_String$node('main');
var _zwilias$elm_html_string$Html_String$p = _zwilias$elm_html_string$Html_String$node('p');
var _zwilias$elm_html_string$Html_String$pre = _zwilias$elm_html_string$Html_String$node('pre');
var _zwilias$elm_html_string$Html_String$blockquote = _zwilias$elm_html_string$Html_String$node('blockquote');
var _zwilias$elm_html_string$Html_String$ol = _zwilias$elm_html_string$Html_String$node('ol');
var _zwilias$elm_html_string$Html_String$ul = _zwilias$elm_html_string$Html_String$node('ul');
var _zwilias$elm_html_string$Html_String$li = _zwilias$elm_html_string$Html_String$node('li');
var _zwilias$elm_html_string$Html_String$dl = _zwilias$elm_html_string$Html_String$node('dl');
var _zwilias$elm_html_string$Html_String$dt = _zwilias$elm_html_string$Html_String$node('dt');
var _zwilias$elm_html_string$Html_String$dd = _zwilias$elm_html_string$Html_String$node('dd');
var _zwilias$elm_html_string$Html_String$figure = _zwilias$elm_html_string$Html_String$node('figure');
var _zwilias$elm_html_string$Html_String$figcaption = _zwilias$elm_html_string$Html_String$node('figcaption');
var _zwilias$elm_html_string$Html_String$div = _zwilias$elm_html_string$Html_String$node('div');
var _zwilias$elm_html_string$Html_String$a = _zwilias$elm_html_string$Html_String$node('a');
var _zwilias$elm_html_string$Html_String$em = _zwilias$elm_html_string$Html_String$node('em');
var _zwilias$elm_html_string$Html_String$strong = _zwilias$elm_html_string$Html_String$node('strong');
var _zwilias$elm_html_string$Html_String$small = _zwilias$elm_html_string$Html_String$node('small');
var _zwilias$elm_html_string$Html_String$s = _zwilias$elm_html_string$Html_String$node('s');
var _zwilias$elm_html_string$Html_String$cite = _zwilias$elm_html_string$Html_String$node('cite');
var _zwilias$elm_html_string$Html_String$q = _zwilias$elm_html_string$Html_String$node('q');
var _zwilias$elm_html_string$Html_String$dfn = _zwilias$elm_html_string$Html_String$node('dfn');
var _zwilias$elm_html_string$Html_String$abbr = _zwilias$elm_html_string$Html_String$node('abbr');
var _zwilias$elm_html_string$Html_String$time = _zwilias$elm_html_string$Html_String$node('time');
var _zwilias$elm_html_string$Html_String$code = _zwilias$elm_html_string$Html_String$node('code');
var _zwilias$elm_html_string$Html_String$var = _zwilias$elm_html_string$Html_String$node('var');
var _zwilias$elm_html_string$Html_String$samp = _zwilias$elm_html_string$Html_String$node('samp');
var _zwilias$elm_html_string$Html_String$kbd = _zwilias$elm_html_string$Html_String$node('kbd');
var _zwilias$elm_html_string$Html_String$sub = _zwilias$elm_html_string$Html_String$node('sub');
var _zwilias$elm_html_string$Html_String$sup = _zwilias$elm_html_string$Html_String$node('sup');
var _zwilias$elm_html_string$Html_String$i = _zwilias$elm_html_string$Html_String$node('i');
var _zwilias$elm_html_string$Html_String$b = _zwilias$elm_html_string$Html_String$node('b');
var _zwilias$elm_html_string$Html_String$u = _zwilias$elm_html_string$Html_String$node('u');
var _zwilias$elm_html_string$Html_String$mark = _zwilias$elm_html_string$Html_String$node('mark');
var _zwilias$elm_html_string$Html_String$ruby = _zwilias$elm_html_string$Html_String$node('ruby');
var _zwilias$elm_html_string$Html_String$rt = _zwilias$elm_html_string$Html_String$node('rt');
var _zwilias$elm_html_string$Html_String$rp = _zwilias$elm_html_string$Html_String$node('rp');
var _zwilias$elm_html_string$Html_String$bdi = _zwilias$elm_html_string$Html_String$node('bdi');
var _zwilias$elm_html_string$Html_String$bdo = _zwilias$elm_html_string$Html_String$node('bdo');
var _zwilias$elm_html_string$Html_String$span = _zwilias$elm_html_string$Html_String$node('span');
var _zwilias$elm_html_string$Html_String$ins = _zwilias$elm_html_string$Html_String$node('ins');
var _zwilias$elm_html_string$Html_String$del = _zwilias$elm_html_string$Html_String$node('del');
var _zwilias$elm_html_string$Html_String$iframe = _zwilias$elm_html_string$Html_String$node('iframe');
var _zwilias$elm_html_string$Html_String$object = _zwilias$elm_html_string$Html_String$node('object');
var _zwilias$elm_html_string$Html_String$video = _zwilias$elm_html_string$Html_String$node('video');
var _zwilias$elm_html_string$Html_String$audio = _zwilias$elm_html_string$Html_String$node('audio');
var _zwilias$elm_html_string$Html_String$canvas = _zwilias$elm_html_string$Html_String$node('canvas');
var _zwilias$elm_html_string$Html_String$math = _zwilias$elm_html_string$Html_String$node('math');
var _zwilias$elm_html_string$Html_String$table = _zwilias$elm_html_string$Html_String$node('table');
var _zwilias$elm_html_string$Html_String$caption = _zwilias$elm_html_string$Html_String$node('caption');
var _zwilias$elm_html_string$Html_String$colgroup = _zwilias$elm_html_string$Html_String$node('colgroup');
var _zwilias$elm_html_string$Html_String$tbody = _zwilias$elm_html_string$Html_String$node('tbody');
var _zwilias$elm_html_string$Html_String$thead = _zwilias$elm_html_string$Html_String$node('thead');
var _zwilias$elm_html_string$Html_String$tfoot = _zwilias$elm_html_string$Html_String$node('tfoot');
var _zwilias$elm_html_string$Html_String$tr = _zwilias$elm_html_string$Html_String$node('tr');
var _zwilias$elm_html_string$Html_String$td = _zwilias$elm_html_string$Html_String$node('td');
var _zwilias$elm_html_string$Html_String$th = _zwilias$elm_html_string$Html_String$node('th');
var _zwilias$elm_html_string$Html_String$form = _zwilias$elm_html_string$Html_String$node('form');
var _zwilias$elm_html_string$Html_String$fieldset = _zwilias$elm_html_string$Html_String$node('fieldset');
var _zwilias$elm_html_string$Html_String$legend = _zwilias$elm_html_string$Html_String$node('legend');
var _zwilias$elm_html_string$Html_String$label = _zwilias$elm_html_string$Html_String$node('label');
var _zwilias$elm_html_string$Html_String$button = _zwilias$elm_html_string$Html_String$node('button');
var _zwilias$elm_html_string$Html_String$select = _zwilias$elm_html_string$Html_String$node('select');
var _zwilias$elm_html_string$Html_String$datalist = _zwilias$elm_html_string$Html_String$node('datalist');
var _zwilias$elm_html_string$Html_String$optgroup = _zwilias$elm_html_string$Html_String$node('optgroup');
var _zwilias$elm_html_string$Html_String$option = _zwilias$elm_html_string$Html_String$node('option');
var _zwilias$elm_html_string$Html_String$textarea = _zwilias$elm_html_string$Html_String$node('textarea');
var _zwilias$elm_html_string$Html_String$output = _zwilias$elm_html_string$Html_String$node('output');
var _zwilias$elm_html_string$Html_String$progress = _zwilias$elm_html_string$Html_String$node('progress');
var _zwilias$elm_html_string$Html_String$meter = _zwilias$elm_html_string$Html_String$node('meter');
var _zwilias$elm_html_string$Html_String$details = _zwilias$elm_html_string$Html_String$node('details');
var _zwilias$elm_html_string$Html_String$summary = _zwilias$elm_html_string$Html_String$node('summary');
var _zwilias$elm_html_string$Html_String$menu = _zwilias$elm_html_string$Html_String$node('menu');

var _zwilias$elm_html_string$Html_String_Attributes$map = _zwilias$elm_html_string$Html_Types$mapAttribute;
var _zwilias$elm_html_string$Html_String_Attributes$attribute = _zwilias$elm_html_string$Html_Types$Attribute;
var _zwilias$elm_html_string$Html_String_Attributes$contextmenu = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'contextmenu', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$draggable = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'draggable', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$itemprop = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'itemprop', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$tabindex = function (n) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'tabIndex',
		_elm_lang$core$Basics$toString(n));
};
var _zwilias$elm_html_string$Html_String_Attributes$charset = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'charset', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$height = function (value) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'height',
		_elm_lang$core$Basics$toString(value));
};
var _zwilias$elm_html_string$Html_String_Attributes$width = function (value) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'width',
		_elm_lang$core$Basics$toString(value));
};
var _zwilias$elm_html_string$Html_String_Attributes$formaction = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'formAction', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$list = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'list', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$minlength = function (n) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'minLength',
		_elm_lang$core$Basics$toString(n));
};
var _zwilias$elm_html_string$Html_String_Attributes$maxlength = function (n) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'maxlength',
		_elm_lang$core$Basics$toString(n));
};
var _zwilias$elm_html_string$Html_String_Attributes$size = function (n) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'size',
		_elm_lang$core$Basics$toString(n));
};
var _zwilias$elm_html_string$Html_String_Attributes$form = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'form', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$cols = function (n) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'cols',
		_elm_lang$core$Basics$toString(n));
};
var _zwilias$elm_html_string$Html_String_Attributes$rows = function (n) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'rows',
		_elm_lang$core$Basics$toString(n));
};
var _zwilias$elm_html_string$Html_String_Attributes$challenge = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'challenge', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$media = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'media', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$rel = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'rel', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$datetime = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'datetime', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$pubdate = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'pubdate', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$colspan = function (n) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'colspan',
		_elm_lang$core$Basics$toString(n));
};
var _zwilias$elm_html_string$Html_String_Attributes$rowspan = function (n) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$attribute,
		'rowspan',
		_elm_lang$core$Basics$toString(n));
};
var _zwilias$elm_html_string$Html_String_Attributes$manifest = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'manifest', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$boolProperty = _zwilias$elm_html_string$Html_Types$BoolProperty;
var _zwilias$elm_html_string$Html_String_Attributes$hidden = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'hidden', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$contenteditable = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'contentEditable', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$spellcheck = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'spellcheck', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$async = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'async', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$defer = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'defer', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$scoped = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'scoped', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$autoplay = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'autoplay', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$controls = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'controls', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$loop = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'loop', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$default = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'default', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$seamless = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'seamless', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$checked = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'checked', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$selected = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'selected', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$autofocus = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'autofocus', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$disabled = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'disabled', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$multiple = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'multiple', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$novalidate = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'noValidate', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$readonly = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'readOnly', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$required = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'required', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$ismap = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'isMap', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$download = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'download', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$reversed = function (bool) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$boolProperty, 'reversed', bool);
};
var _zwilias$elm_html_string$Html_String_Attributes$stringProperty = _zwilias$elm_html_string$Html_Types$StringProperty;
var _zwilias$elm_html_string$Html_String_Attributes$class = function (name) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'className', name);
};
var _zwilias$elm_html_string$Html_String_Attributes$id = function (name) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'id', name);
};
var _zwilias$elm_html_string$Html_String_Attributes$title = function (name) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'title', name);
};
var _zwilias$elm_html_string$Html_String_Attributes$accesskey = function ($char) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$stringProperty,
		'accessKey',
		_elm_lang$core$String$fromChar($char));
};
var _zwilias$elm_html_string$Html_String_Attributes$dir = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'dir', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$dropzone = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'dropzone', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$lang = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'lang', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$content = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'content', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$httpEquiv = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'httpEquiv', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$language = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'language', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$src = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'src', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$alt = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'alt', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$preload = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'preload', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$poster = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'poster', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$kind = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'kind', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$srclang = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'srclang', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$sandbox = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'sandbox', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$srcdoc = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'srcdoc', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$type_ = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'type', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$value = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'value', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$defaultValue = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'defaultValue', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$placeholder = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'placeholder', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$accept = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'accept', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$acceptCharset = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'acceptCharset', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$action = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'action', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$autocomplete = function (bool) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$stringProperty,
		'autocomplete',
		bool ? 'on' : 'off');
};
var _zwilias$elm_html_string$Html_String_Attributes$enctype = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'enctype', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$method = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'method', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$name = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'name', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$pattern = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'pattern', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$for = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'htmlFor', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$max = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'max', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$min = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'min', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$step = function (n) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'step', n);
};
var _zwilias$elm_html_string$Html_String_Attributes$wrap = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'wrap', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$usemap = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'useMap', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$shape = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'shape', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$coords = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'coords', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$keytype = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'keytype', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$align = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'align', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$cite = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'cite', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$href = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'href', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$target = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'target', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$downloadAs = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'download', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$hreflang = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'hreflang', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$ping = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'ping', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$start = function (n) {
	return A2(
		_zwilias$elm_html_string$Html_String_Attributes$stringProperty,
		'start',
		_elm_lang$core$Basics$toString(n));
};
var _zwilias$elm_html_string$Html_String_Attributes$headers = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'headers', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$scope = function (value) {
	return A2(_zwilias$elm_html_string$Html_String_Attributes$stringProperty, 'scope', value);
};
var _zwilias$elm_html_string$Html_String_Attributes$property = _zwilias$elm_html_string$Html_Types$ValueProperty;
var _zwilias$elm_html_string$Html_String_Attributes$classList = function (list) {
	return _zwilias$elm_html_string$Html_String_Attributes$class(
		A2(
			_elm_lang$core$String$join,
			' ',
			_elm_lang$core$List$map.func(
                _elm_lang$core$Tuple$first,
                _elm_lang$core$List$filter.func(_elm_lang$core$Tuple$second, list)
            )));
};
var _zwilias$elm_html_string$Html_String_Attributes$style = _zwilias$elm_html_string$Html_Types$Style;

var _user$project$Util$mapBoth = F3(
	function (f, _p1, _p0) {
		var _p2 = _p1;
		var _p3 = _p0;
		return {
			ctor: '_Tuple2',
			_0: A2(f, _p2._0, _p3._0),
			_1: A2(f, _p2._1, _p3._1)
		};
	});

var _user$project$Overview$showCount = F2(
	function (coverageType, _p0) {
		var _p1 = _p0;
		var _p3 = _p1._0;
		var _p2 = _p1._1;
		return _elm_lang$core$Native_Utils.eq(_p2, 0) ? A2(
			_zwilias$elm_html_string$Html_String$td,
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String_Attributes$class('none'),
				_1: {ctor: '[]'}
			},
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String$text('n/a'),
				_1: {ctor: '[]'}
			}) : A2(
			_zwilias$elm_html_string$Html_String$td,
			{ctor: '[]'},
			{
				ctor: '::',
				_0: A2(
					_zwilias$elm_html_string$Html_String$div,
					{
						ctor: '::',
						_0: _zwilias$elm_html_string$Html_String_Attributes$class('wrapper'),
						_1: {ctor: '[]'}
					},
					{
						ctor: '::',
						_0: A2(
							_zwilias$elm_html_string$Html_String$div,
							{
								ctor: '::',
								_0: _zwilias$elm_html_string$Html_String_Attributes$class('info'),
								_1: {ctor: '[]'}
							},
							{
								ctor: '::',
								_0: _zwilias$elm_html_string$Html_String$text(
									A2(
										_elm_lang$core$Basics_ops['++'],
										_elm_lang$core$Basics$toString(_p3),
										A2(
											_elm_lang$core$Basics_ops['++'],
											'/',
											_elm_lang$core$Basics$toString(_p2)))),
								_1: {ctor: '[]'}
							}),
						_1: {
							ctor: '::',
							_0: A2(
								_zwilias$elm_html_string$Html_String$progress,
								{
									ctor: '::',
									_0: _zwilias$elm_html_string$Html_String_Attributes$max(
										_elm_lang$core$Basics$toString(_p2)),
									_1: {
										ctor: '::',
										_0: _zwilias$elm_html_string$Html_String_Attributes$value(
											_elm_lang$core$Basics$toString(_p3)),
										_1: {ctor: '[]'}
									}
								},
								{ctor: '[]'}),
							_1: {ctor: '[]'}
						}
					}),
				_1: {ctor: '[]'}
			});
	});
var _user$project$Overview$row = F2(
	function (name, counts) {
		return A2(
			_zwilias$elm_html_string$Html_String$tr,
			{ctor: '[]'},
			{
				ctor: '::',
				_0: A2(
					_zwilias$elm_html_string$Html_String$th,
					{ctor: '[]'},
					{
						ctor: '::',
						_0: name,
						_1: {ctor: '[]'}
					}),
				_1: _elm_lang$core$List$map.func(
                    _elm_lang$core$Basics$uncurry(_user$project$Overview$showCount),
                    _Skinney$elm_dict_exploration$Dict_LLRB$toList(counts)
                )
			});
	});
var _user$project$Overview$addCount = F2(
	function (_p4, acc) {
		var _p5 = _p4;
		return _Skinney$elm_dict_exploration$Dict_LLRB$update.func(_user$project$Coverage$annotationType(_p5._1), function (current) {
            return _elm_lang$core$Maybe$Just(
                _user$project$Util$mapBoth.func(F2(
                    function (x, y) {
                        return x + y;
                    }), {
                    ctor: '_Tuple2',
                    _0: _elm_lang$core$Basics$min.func(_p5._2, 1),
                    _1: 1
                }, _elm_lang$core$Maybe$withDefault.func({ctor: '_Tuple2', _0: 0, _1: 0}, current)));
        }, acc);
	});
var _user$project$Overview$computeCounts = function (emptyCountDict) {
	return A2(_elm_lang$core$List$foldl, _user$project$Overview$addCount, emptyCountDict);
};
var _user$project$Overview$shortHumanCoverageType = _user$project$Coverage$fromAnnotation(
	{
		caseBranch: {
			ctor: '::',
			_0: A2(
				_zwilias$elm_html_string$Html_String$code,
				{ctor: '[]'},
				{
					ctor: '::',
					_0: _zwilias$elm_html_string$Html_String$text('case'),
					_1: {ctor: '[]'}
				}),
			_1: {
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String$text(' branches'),
				_1: {ctor: '[]'}
			}
		},
		ifElseBranch: {
			ctor: '::',
			_0: A2(
				_zwilias$elm_html_string$Html_String$code,
				{ctor: '[]'},
				{
					ctor: '::',
					_0: _zwilias$elm_html_string$Html_String$text('if/else'),
					_1: {ctor: '[]'}
				}),
			_1: {
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String$text(' branches'),
				_1: {ctor: '[]'}
			}
		},
		declaration: {
			ctor: '::',
			_0: _zwilias$elm_html_string$Html_String$text('Declarations'),
			_1: {ctor: '[]'}
		},
		lambdaBody: {
			ctor: '::',
			_0: _zwilias$elm_html_string$Html_String$text('Lambdas'),
			_1: {ctor: '[]'}
		},
		letDeclaration: {
			ctor: '::',
			_0: A2(
				_zwilias$elm_html_string$Html_String$code,
				{ctor: '[]'},
				{
					ctor: '::',
					_0: _zwilias$elm_html_string$Html_String$text('let'),
					_1: {ctor: '[]'}
				}),
			_1: {
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String$text(' declarations'),
				_1: {ctor: '[]'}
			}
		},
		$default: {
			ctor: '::',
			_0: _zwilias$elm_html_string$Html_String$text('unknown'),
			_1: {ctor: '[]'}
		}
	});
var _user$project$Overview$heading = function (map) {
	var makeHead = function (_p6) {
		return A2(
			_zwilias$elm_html_string$Html_String$th,
			{ctor: '[]'},
			_user$project$Overview$shortHumanCoverageType(_p6));
	};
	return A2(
		_zwilias$elm_html_string$Html_String$tr,
		{ctor: '[]'},
		{
			ctor: '::',
			_0: A2(
				_zwilias$elm_html_string$Html_String$th,
				{ctor: '[]'},
				{ctor: '[]'}),
			_1: _elm_lang$core$List$map.func(makeHead, _Skinney$elm_dict_exploration$Dict_LLRB$keys(map))
		});
};

var _user$project$Markup$toClass = function (cnt) {
	return _elm_lang$core$Native_Utils.eq(cnt, 0) ? 'cover uncovered' : 'cover covered';
};
var _user$project$Markup$wrapper = F3(
	function (cnt, annotation, content) {
		var title = function () {
			var _p0 = annotation;
			switch (_p0.ctor) {
				case 'Declaration':
					return A2(
						_elm_lang$core$Basics_ops['++'],
						'Evaluated ',
						A2(
							_elm_lang$core$Basics_ops['++'],
							_elm_lang$core$Basics$toString(cnt),
							A2(
								_elm_lang$core$Basics_ops['++'],
								' times, complexity ',
								A2(
									_elm_lang$core$Basics_ops['++'],
									_elm_lang$core$Basics$toString(_p0._1),
									'.'))));
				case 'LetDeclaration':
					return A2(
						_elm_lang$core$Basics_ops['++'],
						'Evaluated ',
						A2(
							_elm_lang$core$Basics_ops['++'],
							_elm_lang$core$Basics$toString(cnt),
							A2(
								_elm_lang$core$Basics_ops['++'],
								' times, complexity ',
								A2(
									_elm_lang$core$Basics_ops['++'],
									_elm_lang$core$Basics$toString(_p0._0),
									'.'))));
				case 'LambdaBody':
					return A2(
						_elm_lang$core$Basics_ops['++'],
						'Evaluated ',
						A2(
							_elm_lang$core$Basics_ops['++'],
							_elm_lang$core$Basics$toString(cnt),
							A2(
								_elm_lang$core$Basics_ops['++'],
								' times, complexity ',
								A2(
									_elm_lang$core$Basics_ops['++'],
									_elm_lang$core$Basics$toString(_p0._0),
									'.'))));
				default:
					return A2(
						_elm_lang$core$Basics_ops['++'],
						'Evaluated ',
						A2(
							_elm_lang$core$Basics_ops['++'],
							_elm_lang$core$Basics$toString(cnt),
							' times.'));
			}
		}();
		return A2(
			_zwilias$elm_html_string$Html_String$span,
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String_Attributes$class(
					_user$project$Markup$toClass(cnt)),
				_1: {
					ctor: '::',
					_0: _zwilias$elm_html_string$Html_String_Attributes$title(title),
					_1: {ctor: '[]'}
				}
			},
			{
				ctor: '::',
				_0: content,
				_1: {ctor: '[]'}
			});
	});
var _user$project$Markup$whitespace = function (indent) {
	return _zwilias$elm_html_string$Html_String$text(
		A2(_elm_lang$core$String$repeat, indent, ' '));
};
var _user$project$Markup$wrapTagger = F3(
	function (_p1, tagger, content) {
		var _p2 = _p1;
		return _user$project$Markup$wrapper.func(_p2.count, _p2.annotation, tagger(content));
	});
var _user$project$Markup$tagWith = F3(
	function (markers, s, tagger) {
		tagWith:
		while (true) {
			var _p3 = markers;
			if (_p3.ctor === '[]') {
				return tagger(
					_zwilias$elm_html_string$Html_String$text(s));
			} else {
				var _v3 = _p3._1,
					_v4 = s,
					_v5 = A2(_user$project$Markup$wrapTagger, _p3._0, tagger);
				markers = _v3;
				s = _v4;
				tagger = _v5;
				continue tagWith;
			}
		}
	});
var _user$project$Markup$popStack = function (acc) {
	var _p4 = acc.stack;
	if (_p4.ctor === '[]') {
		return acc;
	} else {
		return _elm_lang$core$Native_Utils.update(
			acc,
			{stack: _p4._1});
	}
};
var _user$project$Markup$linebreak = A2(
	_zwilias$elm_html_string$Html_String$br,
	{ctor: '[]'},
	{ctor: '[]'});
var _user$project$Markup$indicator = function (_p5) {
	var _p6 = _p5;
	var intensity = function (complexity) {
		return _elm_lang$core$Basics$sqrt(
			_elm_lang$core$Basics$toFloat(
				_elm_lang$core$Basics$clamp.func(0, 50, complexity)) / 50);
	};
	return _elm_lang$core$Maybe$map.func(function (complexity) {
        return A2(
            _zwilias$elm_html_string$Html_String$span,
            {
                ctor: '::',
                _0: _zwilias$elm_html_string$Html_String_Attributes$class('indicator'),
                _1: {
                    ctor: '::',
                    _0: _zwilias$elm_html_string$Html_String_Attributes$style(
                        {
                            ctor: '::',
                            _0: {
                                ctor: '_Tuple2',
                                _0: 'opacity',
                                _1: _elm_lang$core$Basics$toString(
                                    intensity(complexity))
                            },
                            _1: {ctor: '[]'}
                        }),
                    _1: {
                        ctor: '::',
                        _0: _zwilias$elm_html_string$Html_String_Attributes$title(
                            A2(
                                _elm_lang$core$Basics_ops['++'],
                                'Cyclomatic complexity: ',
                                _elm_lang$core$Basics$toString(complexity))),
                        _1: {ctor: '[]'}
                    }
                }
            },
            {
                ctor: '::',
                _0: _zwilias$elm_html_string$Html_String$text(' '),
                _1: {ctor: '[]'}
            });
    }, _user$project$Coverage$complexity(_p6.annotation));
};
var _user$project$Markup$rFilterMap = function (toMaybe) {
	return A2(
		_elm_lang$core$List$foldl,
		F2(
			function (x, acc) {
				var _p7 = toMaybe(x);
				if (_p7.ctor === 'Just') {
					return {ctor: '::', _0: _p7._0, _1: acc};
				} else {
					return acc;
				}
			}),
		{ctor: '[]'});
};
var _user$project$Markup$showLine = F3(
	function (coverageId, lineNr, info) {
		var lineId = A2(
			_elm_lang$core$Basics_ops['++'],
			coverageId,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'_',
				_elm_lang$core$Basics$toString(lineNr)));
		return A2(
			_zwilias$elm_html_string$Html_String$a,
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String_Attributes$href(
					A2(_elm_lang$core$Basics_ops['++'], '#', lineId)),
				_1: {
					ctor: '::',
					_0: _zwilias$elm_html_string$Html_String_Attributes$id(lineId),
					_1: {
						ctor: '::',
						_0: _zwilias$elm_html_string$Html_String_Attributes$class('line'),
						_1: {ctor: '[]'}
					}
				}
			},
			{
				ctor: '::',
				_0: A2(
					_zwilias$elm_html_string$Html_String$div,
					{ctor: '[]'},
					A2(
						_elm_lang$core$Basics_ops['++'],
						A2(_user$project$Markup$rFilterMap, _user$project$Markup$indicator, info),
						{
							ctor: '::',
							_0: _zwilias$elm_html_string$Html_String$text(
								_elm_lang$core$Basics$toString(lineNr)),
							_1: {ctor: '[]'}
						})),
				_1: {ctor: '[]'}
			});
	});
var _user$project$Markup$intercalate = function (sep) {
	return function (_p8) {
		return _elm_lang$core$List$concat(
			_elm_lang$core$List$intersperse.func({
                ctor: '::',
                _0: sep,
                _1: {ctor: '[]'}
            }, _p8));
	};
};
var _user$project$Markup$indexedFoldr = F3(
	function (op, acc, xs) {
		return _elm_lang$core$Tuple$second(
			A3(
				_elm_lang$core$List$foldr,
				F2(
					function (x, _p9) {
						var _p10 = _p9;
						var _p11 = _p10._0;
						return {
							ctor: '_Tuple2',
							_0: _p11 - 1,
							_1: A3(op, _p11, x, _p10._1)
						};
					}),
				{
					ctor: '_Tuple2',
					_0: _elm_lang$core$List$length(xs) - 1,
					_1: acc
				},
				xs));
	});
var _user$project$Markup$foldRendered = F2(
	function (coverageId, xs) {
		return _elm_lang$core$Tuple$mapSecond.func(
            _user$project$Markup$intercalate(_user$project$Markup$linebreak),
            _user$project$Markup$indexedFoldr.func(F3(
                function (idx, _p13, _p12) {
                    var _p14 = _p13;
                    var _p15 = _p12;
                    return {
                        ctor: '_Tuple2',
                        _0: {
                            ctor: '::',
                            _0: _user$project$Markup$showLine.func(coverageId, idx + 1, _p14._0),
                            _1: _p15._0
                        },
                        _1: {ctor: '::', _0: _p14._1, _1: _p15._1}
                    };
                }), {
                ctor: '_Tuple2',
                _0: {ctor: '[]'},
                _1: {ctor: '[]'}
            }, xs)
        );
	});
var _user$project$Markup$addToListDict = F2(
	function (a, m) {
		var _p16 = m;
		if (_p16.ctor === 'Nothing') {
			return _elm_lang$core$Maybe$Just(
				{
					ctor: '::',
					_0: a,
					_1: {ctor: '[]'}
				});
		} else {
			return _elm_lang$core$Maybe$Just(
				{ctor: '::', _0: a, _1: _p16._0});
		}
	});
var _user$project$Markup$emptyCountDict = _elm_lang$core$List$foldl.func(function (k) {
    return A2(
        _Skinney$elm_dict_exploration$Dict_LLRB$insert,
        k,
        {ctor: '_Tuple2', _0: 0, _1: 0});
}, _Skinney$elm_dict_exploration$Dict_LLRB$empty, {
    ctor: '::',
    _0: _user$project$Coverage$letDeclaration,
    _1: {
        ctor: '::',
        _0: _user$project$Coverage$lambdaBody,
        _1: {
            ctor: '::',
            _0: _user$project$Coverage$caseBranch,
            _1: {
                ctor: '::',
                _0: _user$project$Coverage$ifElseBranch,
                _1: {ctor: '[]'}
            }
        }
    }
});
var _user$project$Markup$foldDeclarations = F3(
	function (moduleId, _p18, _p17) {
		var _p19 = _p18;
		var _p22 = _p19.complexity;
		var _p20 = _p17;
		var formattedName = A2(
			_zwilias$elm_html_string$Html_String$a,
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String_Attributes$href(
					A2(
						_elm_lang$core$Basics_ops['++'],
						'#',
						A2(
							_elm_lang$core$Basics_ops['++'],
							moduleId,
							A2(
								_elm_lang$core$Basics_ops['++'],
								'_',
								_elm_lang$core$Basics$toString(_p19.startLine))))),
				_1: {ctor: '[]'}
			},
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String$text(
					A2(
						_elm_lang$core$Basics_ops['++'],
						'(',
						A2(
							_elm_lang$core$Basics_ops['++'],
							_elm_lang$core$Basics$toString(_p22),
							') '))),
				_1: {
					ctor: '::',
					_0: A2(
						_zwilias$elm_html_string$Html_String$code,
						{ctor: '[]'},
						{
							ctor: '::',
							_0: _zwilias$elm_html_string$Html_String$text(_p19.name),
							_1: {ctor: '[]'}
						}),
					_1: {ctor: '[]'}
				}
			});
		var adjustTotals = F2(
			function (coverageType, counts) {
				return A2(
					_Skinney$elm_dict_exploration$Dict_LLRB$update,
					coverageType,
					function (_p21) {
						return _elm_lang$core$Maybe$Just(
							_elm_lang$core$Maybe$withDefault.func(counts, _elm_lang$core$Maybe$map.func(A2(
                                _user$project$Util$mapBoth,
                                F2(
                                    function (x, y) {
                                        return x + y;
                                    }),
                                counts), _p21)));
					});
			});
		var counts = A2(_user$project$Overview$computeCounts, _user$project$Markup$emptyCountDict, _p19.children);
		var adjustedTotals = _Skinney$elm_dict_exploration$Dict_LLRB$foldl.func(adjustTotals, _p20._1, counts);
		return {
			ctor: '_Tuple3',
			_0: {
				ctor: '::',
				_0: _user$project$Overview$row.func(formattedName, counts),
				_1: _p20._0
			},
			_1: adjustedTotals,
			_2: {ctor: '::', _0: _p22, _1: _p20._2}
		};
	});
var _user$project$Markup$topLevelDeclarationInfo = F3(
	function (acc, children, annotations) {
		topLevelDeclarationInfo:
		while (true) {
			var _p23 = annotations;
			if (_p23.ctor === '[]') {
				return _elm_lang$core$List$reverse(acc);
			} else {
				if ((_p23._0.ctor === '_Tuple3') && (_p23._0._1.ctor === 'Declaration')) {
					var decl = {
						name: _p23._0._1._0,
						complexity: _p23._0._1._1,
						startLine: _user$project$Coverage$line(_p23._0._0.from),
						children: children
					};
					var _v16 = {ctor: '::', _0: decl, _1: acc},
						_v17 = {ctor: '[]'},
						_v18 = _p23._1;
					acc = _v16;
					children = _v17;
					annotations = _v18;
					continue topLevelDeclarationInfo;
				} else {
					var _v19 = acc,
						_v20 = {ctor: '::', _0: _p23._0, _1: children},
						_v21 = _p23._1;
					acc = _v19;
					children = _v20;
					annotations = _v21;
					continue topLevelDeclarationInfo;
				}
			}
		}
	});
var _user$project$Markup$listDeclarations = F2(
	function (moduleId, annotations) {
		var declarations = A2(
			_elm_lang$core$List$sortBy,
			function (_) {
				return _.complexity;
			},
			_user$project$Markup$topLevelDeclarationInfo.func({ctor: '[]'}, {ctor: '[]'}, annotations));
		var _p24 = _elm_lang$core$List$foldl.func(_user$project$Markup$foldDeclarations(moduleId), {
            ctor: '_Tuple3',
            _0: {ctor: '[]'},
            _1: _Skinney$elm_dict_exploration$Dict_LLRB$empty,
            _2: {ctor: '[]'}
        }, declarations);
		var rows = _p24._0;
		var totals = _p24._1;
		var complexities = _p24._2;
		var totalComplexity = (_elm_lang$core$List$sum(complexities) - _elm_lang$core$List$length(complexities)) + 1;
		return A2(
			_zwilias$elm_html_string$Html_String$table,
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String_Attributes$class('overview'),
				_1: {ctor: '[]'}
			},
			{
				ctor: '::',
				_0: A2(
					_zwilias$elm_html_string$Html_String$thead,
					{ctor: '[]'},
					{
						ctor: '::',
						_0: _user$project$Overview$heading(totals),
						_1: {ctor: '[]'}
					}),
				_1: {
					ctor: '::',
					_0: A2(
						_zwilias$elm_html_string$Html_String$tbody,
						{ctor: '[]'},
						rows),
					_1: {
						ctor: '::',
						_0: A2(
							_zwilias$elm_html_string$Html_String$tfoot,
							{ctor: '[]'},
							{
								ctor: '::',
								_0: _user$project$Overview$row.func(_zwilias$elm_html_string$Html_String$text(
                                    A2(
                                        _elm_lang$core$Basics_ops['++'],
                                        '(',
                                        A2(
                                            _elm_lang$core$Basics_ops['++'],
                                            _elm_lang$core$Basics$toString(totalComplexity),
                                            ') total'))), totals),
								_1: {ctor: '[]'}
							}),
						_1: {ctor: '[]'}
					}
				}
			});
	});
var _user$project$Markup$moduleToId = function (_p25) {
	return A2(
		_elm_lang$core$String$join,
		'-',
		A2(
			_elm_lang$core$String$split,
			'.',
			_elm_lang$core$String$toLower(_p25)));
};
var _user$project$Markup$TopLevelDecl = F4(
	function (a, b, c, d) {
		return {name: a, complexity: b, startLine: c, children: d};
	});
var _user$project$Markup$MarkerInfo = F2(
	function (a, b) {
		return {count: a, annotation: b};
	});
var _user$project$Markup$Acc = F2(
	function (a, b) {
		return {children: a, stack: b};
	});
var _user$project$Markup$ToHtmlAcc = F3(
	function (a, b, c) {
		return {lineSoFar: a, stack: b, lines: c};
	});
var _user$project$Markup$End = {ctor: 'End'};
var _user$project$Markup$Begin = function (a) {
	return {ctor: 'Begin', _0: a};
};
var _user$project$Markup$addRegion = F3(
	function (offsets, _p26, acc) {
		var _p27 = _p26;
		var _p28 = _p27._0;
		return _elm_lang$core$Maybe$withDefault.func(acc, _elm_lang$core$Maybe$map2.func(F2(
            function (from, to) {
                return _Skinney$elm_dict_exploration$Dict_LLRB$update.func(
                    to,
                    _user$project$Markup$addToListDict(_user$project$Markup$End),
                    _Skinney$elm_dict_exploration$Dict_LLRB$update.func(from, _user$project$Markup$addToListDict(
                        _user$project$Markup$Begin(
                            _user$project$Markup$MarkerInfo.func(_p27._2, _p27._1))), acc)
                );
            }), _user$project$Coverage$positionToOffset.func(_p28.from, offsets), _user$project$Coverage$positionToOffset.func(_p28.to, offsets)));
	});
var _user$project$Markup$toMarkerDict = F2(
	function (regions, offsets) {
		return _elm_lang$core$List$foldl.func(
            _user$project$Markup$addRegion(offsets),
            _Skinney$elm_dict_exploration$Dict_LLRB$empty,
            regions
        );
	});
var _user$project$Markup$Indented = F2(
	function (a, b) {
		return {ctor: 'Indented', _0: a, _1: b};
	});
var _user$project$Markup$LineBreak = {ctor: 'LineBreak'};
var _user$project$Markup$Part = function (a) {
	return {ctor: 'Part', _0: a};
};
var _user$project$Markup$findIndent = function (string) {
	var toIndentedString = function (spaces) {
		return _elm_lang$core$Native_Utils.eq(
			_elm_lang$core$String$length(string),
			spaces) ? _user$project$Markup$Indented.func(spaces, '') : (_elm_lang$core$Native_Utils.eq(spaces, 0) ? _user$project$Markup$Part(string) : _user$project$Markup$Indented.func(spaces, A3(
            _elm_lang$core$String$slice,
            spaces,
            _elm_lang$core$String$length(string),
            string)));
	};
	var countIndentLength = F2(
		function (c, _p29) {
			var _p30 = _p29;
			var _p31 = _p30._0;
			return (_p30._1 && _elm_lang$core$Native_Utils.eq(
				c,
				_elm_lang$core$Native_Utils.chr(' '))) ? {ctor: '_Tuple2', _0: _p31 + 1, _1: true} : {ctor: '_Tuple2', _0: _p31, _1: false};
		});
	return toIndentedString(
		_elm_lang$core$Tuple$first(
			A3(
				_elm_lang$core$String$foldl,
				countIndentLength,
				{ctor: '_Tuple2', _0: 0, _1: true},
				string)));
};
var _user$project$Markup$Content = F2(
	function (a, b) {
		return {ctor: 'Content', _0: a, _1: b};
	});
var _user$project$Markup$consumeMarker = F2(
	function (marker, acc) {
		var _p32 = marker;
		if (_p32.ctor === 'Begin') {
			return {
				children: {ctor: '[]'},
				stack: {
					ctor: '::',
					_0: {ctor: '_Tuple2', _0: _p32._0, _1: acc.children},
					_1: acc.stack
				}
			};
		} else {
			var _p33 = acc.stack;
			if (_p33.ctor === '[]') {
				return _elm_lang$core$Native_Utils.crashCase(
					'Markup',
					{
						start: {line: 514, column: 13},
						end: {line: 526, column: 22}
					},
					_p33)('unexpected end');
			} else {
				var content = _user$project$Markup$Content.func(_p33._0._0, acc.children);
				return {
					children: {ctor: '::', _0: content, _1: _p33._0._1},
					stack: _p33._1
				};
			}
		}
	});
var _user$project$Markup$consumeMarkers = F2(
	function (markers, acc) {
		return _elm_lang$core$List$foldl.func(_user$project$Markup$consumeMarker, acc, markers);
	});
var _user$project$Markup$Plain = function (a) {
	return {ctor: 'Plain', _0: a};
};
var _user$project$Markup$stringParts = function (string) {
	var _p35 = _elm_lang$core$String$lines(string);
	if (_p35.ctor === '[]') {
		return _user$project$Markup$Plain(
			{ctor: '[]'});
	} else {
		return _user$project$Markup$Plain(
			_elm_lang$core$List$reverse(
				_elm_lang$core$List$intersperse.func(_user$project$Markup$LineBreak, {
                    ctor: '::',
                    _0: _user$project$Markup$Part(_p35._0),
                    _1: _elm_lang$core$List$map.func(_user$project$Markup$findIndent, _p35._1)
                })));
	}
};
var _user$project$Markup$markupHelper = F4(
	function (original, offset, markers, acc) {
		markupHelper:
		while (true) {
			var readUntil = function (pos) {
				return function (_p36) {
					return _user$project$Markup$stringParts(
						A3(_elm_lang$core$String$slice, offset, pos, _p36));
				};
			};
			var rest = function (input) {
				return _user$project$Markup$stringParts(
					A3(
						_elm_lang$core$String$slice,
						offset,
						_elm_lang$core$String$length(input),
						input));
			};
			var _p37 = markers;
			if (_p37.ctor === '[]') {
				return _elm_lang$core$Native_Utils.update(
					acc,
					{
						children: {
							ctor: '::',
							_0: rest(original),
							_1: acc.children
						}
					});
			} else {
				var _p38 = _p37._0._0;
				var _v28 = original,
					_v29 = _p38,
					_v30 = _p37._1,
					_v31 = _user$project$Markup$consumeMarkers.func(_p37._0._1, _elm_lang$core$Native_Utils.update(
						acc,
						{
							children: {
								ctor: '::',
								_0: A2(readUntil, _p38, original),
								_1: acc.children
							}
						}));
				original = _v28;
				offset = _v29;
				markers = _v30;
				acc = _v31;
				continue markupHelper;
			}
		}
	});
var _user$project$Markup$Line = F2(
	function (a, b) {
		return {ctor: 'Line', _0: a, _1: b};
	});
var _user$project$Markup$addMarkerToLine = F2(
	function (marker, _p39) {
		var _p40 = _p39;
		return _user$project$Markup$Line.func({ctor: '::', _0: marker, _1: _p40._0}, _p40._1);
	});
var _user$project$Markup$pushStack = F2(
	function (marker, acc) {
		return _elm_lang$core$Native_Utils.update(
			acc,
			{
				stack: {ctor: '::', _0: marker, _1: acc.stack},
				lineSoFar: _user$project$Markup$addMarkerToLine.func(marker, acc.lineSoFar)
			});
	});
var _user$project$Markup$addToLine = F2(
	function (x, _p41) {
		var _p42 = _p41;
		return _user$project$Markup$Line.func(_p42._0, {ctor: '::', _0: x, _1: _p42._1});
	});
var _user$project$Markup$add = F2(
	function (content, acc) {
		return _elm_lang$core$Native_Utils.update(
			acc,
			{
				lineSoFar: _user$project$Markup$addToLine.func(content, acc.lineSoFar)
			});
	});
var _user$project$Markup$tagAndAdd = F2(
	function (content, acc) {
		return _user$project$Markup$add.func(
            _user$project$Markup$tagWith.func(acc.stack, content, _elm_lang$core$Basics$identity),
            acc
        );
	});
var _user$project$Markup$newLine = function (acc) {
	return _elm_lang$core$Native_Utils.update(
		acc,
		{
			lineSoFar: _user$project$Markup$Line.func(acc.stack, {ctor: '[]'}),
			lines: {ctor: '::', _0: acc.lineSoFar, _1: acc.lines}
		});
};
var _user$project$Markup$partsToHtml = F2(
	function (parts, acc) {
		partsToHtml:
		while (true) {
			var _p43 = parts;
			if (_p43.ctor === '[]') {
				return acc;
			} else {
				switch (_p43._0.ctor) {
					case 'Part':
						if (_p43._0._0 === '') {
							var _v35 = _p43._1,
								_v36 = acc;
							parts = _v35;
							acc = _v36;
							continue partsToHtml;
						} else {
							var _v37 = _p43._1,
								_v38 = _user$project$Markup$tagAndAdd.func(_p43._0._0, acc);
							parts = _v37;
							acc = _v38;
							continue partsToHtml;
						}
					case 'LineBreak':
						var _v39 = _p43._1,
							_v40 = _user$project$Markup$newLine(acc);
						parts = _v39;
						acc = _v40;
						continue partsToHtml;
					default:
						if ((_p43._0._0 === 0) && (_p43._0._1 === '')) {
							var _v41 = _p43._1,
								_v42 = acc;
							parts = _v41;
							acc = _v42;
							continue partsToHtml;
						} else {
							var _v43 = _p43._1,
								_v44 = _user$project$Markup$add.func(
                                    _user$project$Markup$whitespace(_p43._0._0),
                                    _user$project$Markup$tagAndAdd.func(_p43._0._1, acc)
                                );
							parts = _v43;
							acc = _v44;
							continue partsToHtml;
						}
				}
			}
		}
	});
var _user$project$Markup$contentToHtml = F2(
	function (content, acc) {
		var _p44 = content;
		if (_p44.ctor === 'Plain') {
			return _user$project$Markup$partsToHtml.func(_p44._0, acc);
		} else {
			return _user$project$Markup$popStack(
				_elm_lang$core$List$foldl.func(
                    _user$project$Markup$contentToHtml,
                    _user$project$Markup$pushStack.func(_p44._0, acc),
                    _p44._1
                ));
		}
	});
var _user$project$Markup$toHtml = function (content) {
	var finalize = function (_p45) {
		var _p46 = _p45;
		return {ctor: '::', _0: _p46.lineSoFar, _1: _p46.lines};
	};
	var initialAcc = {
		lineSoFar: _user$project$Markup$Line.func({ctor: '[]'}, {ctor: '[]'}),
		stack: {ctor: '[]'},
		lines: {ctor: '[]'}
	};
	return finalize(
		_elm_lang$core$List$foldl.func(_user$project$Markup$contentToHtml, initialAcc, content));
};
var _user$project$Markup$markup = F3(
	function (coverageId, input, markers) {
		var content = function (_) {
			return _.children;
		}(
			_user$project$Markup$markupHelper.func(input, 0, _Skinney$elm_dict_exploration$Dict_LLRB$toList(markers), {
                children: {ctor: '[]'},
                stack: {ctor: '[]'}
            }));
		var _p47 = _user$project$Markup$foldRendered.func(coverageId, _user$project$Markup$toHtml(content));
		var lines = _p47._0;
		var rendered = _p47._1;
		return A2(
			_zwilias$elm_html_string$Html_String$div,
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String_Attributes$class('coverage'),
				_1: {ctor: '[]'}
			},
			{
				ctor: '::',
				_0: A2(
					_zwilias$elm_html_string$Html_String$div,
					{
						ctor: '::',
						_0: _zwilias$elm_html_string$Html_String_Attributes$class('lines'),
						_1: {ctor: '[]'}
					},
					lines),
				_1: {
					ctor: '::',
					_0: A2(
						_zwilias$elm_html_string$Html_String$div,
						{
							ctor: '::',
							_0: _zwilias$elm_html_string$Html_String_Attributes$class('source'),
							_1: {ctor: '[]'}
						},
						rendered),
					_1: {ctor: '[]'}
				}
			});
	});
var _user$project$Markup$process = F4(
	function (coverageId, input, index, regions) {
		var markerDict = _user$project$Markup$toMarkerDict.func(regions, index);
		return _user$project$Markup$markup.func(coverageId, input, markerDict);
	});
var _user$project$Markup$file = F3(
	function (moduleName, coverageInfo, source) {
		var fileIndex = _user$project$Coverage$index(source);
		return A2(
			_zwilias$elm_html_string$Html_String$div,
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String_Attributes$class('file'),
				_1: {ctor: '[]'}
			},
			{
				ctor: '::',
				_0: A2(
					_zwilias$elm_html_string$Html_String$h2,
					{
						ctor: '::',
						_0: _zwilias$elm_html_string$Html_String_Attributes$id(
							_user$project$Markup$moduleToId(moduleName)),
						_1: {ctor: '[]'}
					},
					{
						ctor: '::',
						_0: _zwilias$elm_html_string$Html_String$text('Module: '),
						_1: {
							ctor: '::',
							_0: A2(
								_zwilias$elm_html_string$Html_String$code,
								{ctor: '[]'},
								{
									ctor: '::',
									_0: _zwilias$elm_html_string$Html_String$text(moduleName),
									_1: {ctor: '[]'}
								}),
							_1: {
								ctor: '::',
								_0: A2(
									_zwilias$elm_html_string$Html_String$a,
									{
										ctor: '::',
										_0: _zwilias$elm_html_string$Html_String_Attributes$class('toTop'),
										_1: {
											ctor: '::',
											_0: _zwilias$elm_html_string$Html_String_Attributes$href('#top'),
											_1: {ctor: '[]'}
										}
									},
									{
										ctor: '::',
										_0: _zwilias$elm_html_string$Html_String$text('▲'),
										_1: {ctor: '[]'}
									}),
								_1: {ctor: '[]'}
							}
						}
					}),
				_1: {
					ctor: '::',
					_0: _user$project$Markup$listDeclarations.func(_user$project$Markup$moduleToId(moduleName), coverageInfo),
					_1: {
						ctor: '::',
						_0: A2(
							_zwilias$elm_html_string$Html_String$p,
							{
								ctor: '::',
								_0: _zwilias$elm_html_string$Html_String_Attributes$class('legend'),
								_1: {ctor: '[]'}
							},
							{
								ctor: '::',
								_0: _zwilias$elm_html_string$Html_String$text('Declarations sorted by cyclomatic complexity, and an overview of their internal coverage.'),
								_1: {ctor: '[]'}
							}),
						_1: {
							ctor: '::',
							_0: _user$project$Markup$process.func(
                                _user$project$Markup$moduleToId(moduleName),
                                source,
                                fileIndex,
                                coverageInfo
                            ),
							_1: {ctor: '[]'}
						}
					}
				}
			});
	});

var _user$project$Service$emit = _elm_lang$core$Native_Platform.outgoingPort(
	'emit',
	function (v) {
		return v;
	});
var _user$project$Service$handle = F4(
	function (handler, encode, msg, version) {
		var _p0 = msg;
		if (_p0.ctor === 'Receive') {
			return {
				ctor: '_Tuple2',
				_0: version,
				_1: _user$project$Service$emit(
					encode(
						A2(handler, version, _p0._0)))
			};
		} else {
			return {
				ctor: '_Tuple2',
				_0: version,
				_1: _user$project$Service$emit(
					_elm_lang$core$Json_Encode$object(
						{
							ctor: '::',
							_0: {
								ctor: '_Tuple2',
								_0: 'type',
								_1: _elm_lang$core$Json_Encode$string('error')
							},
							_1: {
								ctor: '::',
								_0: {
									ctor: '_Tuple2',
									_0: 'message',
									_1: _elm_lang$core$Json_Encode$string(_p0._0)
								},
								_1: {ctor: '[]'}
							}
						}))
			};
		}
	});
var _user$project$Service$receive = _elm_lang$core$Native_Platform.incomingPort('receive', _elm_lang$core$Json_Decode$value);
var _user$project$Service$Bad = function (a) {
	return {ctor: 'Bad', _0: a};
};
var _user$project$Service$Receive = function (a) {
	return {ctor: 'Receive', _0: a};
};
var _user$project$Service$subscribe = F2(
	function (decoder, _p1) {
		return _user$project$Service$receive(
			function (data) {
				var _p2 = A2(_elm_lang$core$Json_Decode$decodeValue, decoder, data);
				if (_p2.ctor === 'Ok') {
					return _user$project$Service$Receive(_p2._0);
				} else {
					return _user$project$Service$Bad(_p2._0);
				}
			});
	});
var _user$project$Service$create = function (settings) {
	return _elm_lang$core$Platform$programWithFlags(
		{
			init: A2(
				_elm_lang$core$Basics$flip,
				F2(
					function (x, y) {
						return A2(_elm_lang$core$Platform_Cmd_ops['!'], x, y);
					}),
				{ctor: '[]'}),
			update: A2(_user$project$Service$handle, settings.handle, settings.emit),
			subscriptions: _user$project$Service$subscribe(settings.receive)
		});
};

var _user$project$Html_String_Extra$data = F2(
	function (key, value) {
		return A2(
			_zwilias$elm_html_string$Html_String_Attributes$attribute,
			A2(_elm_lang$core$Basics_ops['++'], 'data-', key),
			value);
	});
var _user$project$Html_String_Extra$style = _zwilias$elm_html_string$Html_String$node('style');
var _user$project$Html_String_Extra$head = _zwilias$elm_html_string$Html_String$node('head');
var _user$project$Html_String_Extra$html = _zwilias$elm_html_string$Html_String$node('html');

var _user$project$Styles$overview = '\n.overview {\n    width: 100%;\n    padding: 0 30px;\n    border: 1px solid #d0d0d0;\n    border-radius: 0.5em;\n    table-layout: fixed;\n}\n\n.overview thead {\n    text-align: center;\n}\n\n.overview thead tr,\n.overview tfoot tr {\n    height: 3em;\n}\n\n.overview tbody th,\n.overview tfoot th {\n    text-align: right;\n    text-overflow: ellipsis;\n    overflow: hidden;\n    direction: rtl;\n}\n\n.overview .wrapper {\n    display: flex;\n}\n\n.overview .none {\n    text-align: center;\n    color: #606060;\n    font-size: 0.8em;\n}\n\n.overview progress {\n    flex: 1.5;\n    display: none;\n}\n\n@media only screen  and (min-width : 960px) {\n    .overview progress {\n        display: block;\n    }\n}\n\n.overview .info {\n    flex: 1;\n    text-align: right;\n    margin: 0 1em;\n}\n';
var _user$project$Styles$file = '\n.toTop {\n    float: right;\n    text-decoration: none;\n}\n\n.coverage {\n    font-family: \"Fira Code\", monospace;\n    font-size: 0.8em;\n    white-space: pre;\n    line-height: 1.2rem;\n    background-color: #fdfdfd;\n    padding: 1em 0.4em;\n    border: 1px solid #D0D0D0;\n    border-radius: 0.5em;\n    display: flex;\n    flex-direction: row;\n    padding-left: 0;\n}\n\n.source .covered {\n    background-color: #aef5ae;\n    color: #202020;\n    box-shadow: 0 0 0 2px #aef5ae;\n    border-bottom: 1px solid #aef5ae;\n}\n\n.source .uncovered {\n    background-color: rgb(255, 30, 30);\n    color: white;\n    box-shadow: 0 0 0 2px rgb(255, 30, 30);\n    border-bottom-width: 1px;\n    border-bottom-style: dashed;\n}\n\n.source .covered > .covered {\n    box-shadow: none;\n    background-color: initial;\n    border-bottom: none;\n}\n\n.source .uncovered > .uncovered {\n    box-shadow: none;\n    border-bottom: none;\n    background-color: initial;\n}\n\n.source .uncovered .covered {\n    background-color: transparent;\n    color: inherit;\n    box-shadow: none;\n}\n\n.lines {\n    text-align: right;\n    margin-right: 10px;\n    border-right: 1px solid #d0d0d0;\n    padding-right: 10px;\n    margin-top: -1em;\n    padding-top: 1em;\n    padding-bottom: 1em;\n    margin-bottom: -1em;\n}\n\n.lines .line {\n    display: block;\n    color: #c0c0c0;\n    text-decoration: none;\n    transition: all 0.3s ease;\n    font-size: 0.9em;\n    line-height: 1.2rem;\n}\n\n.lines .line:hover {\n    color: #303030;\n}\n\n.source {\n    flex: 1;\n    overflow: scroll;\n}\n\n.legend {\n    text-align: center;\n    font-size: 0.9em;\n    margin-bottom: 2em;\n}\n\n.indicator {\n    display: inline-block;\n    float: left;\n    background-color: rgb(255, 30, 30);\n}\n';
var _user$project$Styles$general = '\n@import url(https://fonts.googleapis.com/css?family=Fira+Sans);\n\n@font-face {\n    font-family: \'Fira Code\';\n    src: local(\'Fira Code\'), local(\'FiraCode\'), url(https://cdn.rawgit.com/tonsky/FiraCode/master/distr/ttf/FiraCode-Regular.ttf);\n}\n\ncode {\n    font-family: \"Fira Code\", monospace;\n    font-size: 0.9em;\n}\n\nbody {\n    margin: 0 30px;\n    color: #333333;\n    font-family: \"Fira Sans\", sans-serif;\n    background-color: #fdfdfd;\n    font-size: 16px;\n}\n\nfooter {\n    margin: 1em;\n    text-align: center;\n    font-size: 0.8em;\n}\n\na {\n    font-weight: normal;\n}\n';
var _user$project$Styles$page = F4(
	function (title, styles, version, content) {
		return A2(
			_user$project$Html_String_Extra$html,
			{ctor: '[]'},
			{
				ctor: '::',
				_0: A2(
					_user$project$Html_String_Extra$head,
					{ctor: '[]'},
					{
						ctor: '::',
						_0: A2(
							_user$project$Html_String_Extra$style,
							{ctor: '[]'},
							{
								ctor: '::',
								_0: _zwilias$elm_html_string$Html_String$text(styles),
								_1: {ctor: '[]'}
							}),
						_1: {
							ctor: '::',
							_0: _zwilias$elm_html_string$Html_String$node.func('meta', {
                                ctor: '::',
                                _0: A2(_zwilias$elm_html_string$Html_String_Attributes$attribute, 'charset', 'UTF-8'),
                                _1: {ctor: '[]'}
                            }, {ctor: '[]'}),
							_1: {ctor: '[]'}
						}
					}),
				_1: {
					ctor: '::',
					_0: A2(
						_zwilias$elm_html_string$Html_String$body,
						{ctor: '[]'},
						{
							ctor: '::',
							_0: A2(
								_zwilias$elm_html_string$Html_String$header,
								{ctor: '[]'},
								{
									ctor: '::',
									_0: A2(
										_zwilias$elm_html_string$Html_String$h1,
										{
											ctor: '::',
											_0: _zwilias$elm_html_string$Html_String_Attributes$id('top'),
											_1: {ctor: '[]'}
										},
										{
											ctor: '::',
											_0: _zwilias$elm_html_string$Html_String$text(title),
											_1: {ctor: '[]'}
										}),
									_1: {ctor: '[]'}
								}),
							_1: {
								ctor: '::',
								_0: A2(
									_zwilias$elm_html_string$Html_String$section,
									{ctor: '[]'},
									content),
								_1: {
									ctor: '::',
									_0: A2(
										_zwilias$elm_html_string$Html_String$footer,
										{ctor: '[]'},
										{
											ctor: '::',
											_0: _zwilias$elm_html_string$Html_String$text('Generated with '),
											_1: {
												ctor: '::',
												_0: A2(
													_zwilias$elm_html_string$Html_String$a,
													{
														ctor: '::',
														_0: _zwilias$elm_html_string$Html_String_Attributes$href('https://github.com/zwilias/elm-coverage'),
														_1: {ctor: '[]'}
													},
													{
														ctor: '::',
														_0: _zwilias$elm_html_string$Html_String$text('elm-coverage'),
														_1: {ctor: '[]'}
													}),
												_1: {
													ctor: '::',
													_0: _zwilias$elm_html_string$Html_String$text(
														A2(_elm_lang$core$Basics_ops['++'], '@', version)),
													_1: {ctor: '[]'}
												}
											}
										}),
									_1: {ctor: '[]'}
								}
							}
						}),
					_1: {ctor: '[]'}
				}
			});
	});

var _user$project$Analyzer$styles = _elm_lang$core$String$concat(
	{
		ctor: '::',
		_0: _user$project$Styles$general,
		_1: {
			ctor: '::',
			_0: _user$project$Styles$file,
			_1: {
				ctor: '::',
				_0: _user$project$Styles$overview,
				_1: {ctor: '[]'}
			}
		}
	});
var _user$project$Analyzer$moduleToId = function (_p0) {
	return A2(
		_elm_lang$core$String$join,
		'-',
		A2(
			_elm_lang$core$String$split,
			'.',
			_elm_lang$core$String$toLower(_p0)));
};
var _user$project$Analyzer$emptyCountDict = _elm_lang$core$List$foldl.func(function (k) {
    return A2(
        _Skinney$elm_dict_exploration$Dict_LLRB$insert,
        k,
        {ctor: '_Tuple2', _0: 0, _1: 0});
}, _Skinney$elm_dict_exploration$Dict_LLRB$empty, {
    ctor: '::',
    _0: _user$project$Coverage$declaration,
    _1: {
        ctor: '::',
        _0: _user$project$Coverage$letDeclaration,
        _1: {
            ctor: '::',
            _0: _user$project$Coverage$lambdaBody,
            _1: {
                ctor: '::',
                _0: _user$project$Coverage$caseBranch,
                _1: {
                    ctor: '::',
                    _0: _user$project$Coverage$ifElseBranch,
                    _1: {ctor: '[]'}
                }
            }
        }
    }
});
var _user$project$Analyzer$totalComplexity = function (annotations) {
	var allComplexities = _elm_lang$core$List$filterMap.func(function (_p1) {
        var _p2 = _p1;
        var _p3 = _p2._1;
        if (_p3.ctor === 'Declaration') {
            return _elm_lang$core$Maybe$Just(_p3._1);
        } else {
            return _elm_lang$core$Maybe$Nothing;
        }
    }, annotations);
	return (_elm_lang$core$List$sum(allComplexities) - _elm_lang$core$List$length(allComplexities)) + 1;
};
var _user$project$Analyzer$adjustTotals = F2(
	function (coverageType, counts) {
		return A2(
			_Skinney$elm_dict_exploration$Dict_LLRB$update,
			coverageType,
			function (_p4) {
				return _elm_lang$core$Maybe$Just(
					_elm_lang$core$Maybe$withDefault.func(counts, _elm_lang$core$Maybe$map.func(A2(
                        _user$project$Util$mapBoth,
                        F2(
                            function (x, y) {
                                return x + y;
                            }),
                        counts), _p4)));
			});
	});
var _user$project$Analyzer$foldFile = F2(
	function (_p6, _p5) {
		var _p7 = _p6;
		var _p10 = _p7._0;
		var _p9 = _p7._1;
		var _p8 = _p5;
		var name = A2(
			_zwilias$elm_html_string$Html_String$a,
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String_Attributes$href(
					A2(
						_elm_lang$core$Basics_ops['++'],
						'#',
						_user$project$Analyzer$moduleToId(_p10))),
				_1: {ctor: '[]'}
			},
			{
				ctor: '::',
				_0: _zwilias$elm_html_string$Html_String$text(
					A2(
						_elm_lang$core$Basics_ops['++'],
						'(',
						A2(
							_elm_lang$core$Basics_ops['++'],
							_elm_lang$core$Basics$toString(
								_user$project$Analyzer$totalComplexity(_p9)),
							') '))),
				_1: {
					ctor: '::',
					_0: A2(
						_zwilias$elm_html_string$Html_String$code,
						{ctor: '[]'},
						{
							ctor: '::',
							_0: _zwilias$elm_html_string$Html_String$text(_p10),
							_1: {ctor: '[]'}
						}),
					_1: {ctor: '[]'}
				}
			});
		var counts = A2(_user$project$Overview$computeCounts, _user$project$Analyzer$emptyCountDict, _p9);
		return {
			ctor: '_Tuple2',
			_0: {
				ctor: '::',
				_0: _user$project$Overview$row.func(name, counts),
				_1: _p8._0
			},
			_1: _Skinney$elm_dict_exploration$Dict_LLRB$foldl.func(_user$project$Analyzer$adjustTotals, _p8._1, counts)
		};
	});
var _user$project$Analyzer$overview = function (moduleMap) {
	var _p11 = A3(
		_elm_lang$core$List$foldr,
		_user$project$Analyzer$foldFile,
		{
			ctor: '_Tuple2',
			_0: {ctor: '[]'},
			_1: _Skinney$elm_dict_exploration$Dict_LLRB$empty
		},
		_Skinney$elm_dict_exploration$Dict_LLRB$toList(moduleMap));
	var rows = _p11._0;
	var totals = _p11._1;
	return A2(
		_zwilias$elm_html_string$Html_String$table,
		{
			ctor: '::',
			_0: _zwilias$elm_html_string$Html_String_Attributes$class('overview'),
			_1: {ctor: '[]'}
		},
		{
			ctor: '::',
			_0: A2(
				_zwilias$elm_html_string$Html_String$thead,
				{ctor: '[]'},
				{
					ctor: '::',
					_0: _user$project$Overview$heading(totals),
					_1: {ctor: '[]'}
				}),
			_1: {
				ctor: '::',
				_0: A2(
					_zwilias$elm_html_string$Html_String$tbody,
					{ctor: '[]'},
					rows),
				_1: {
					ctor: '::',
					_0: A2(
						_zwilias$elm_html_string$Html_String$tfoot,
						{ctor: '[]'},
						{
							ctor: '::',
							_0: _user$project$Overview$row.func(_zwilias$elm_html_string$Html_String$text('total'), totals),
							_1: {ctor: '[]'}
						}),
					_1: {ctor: '[]'}
				}
			}
		});
};
var _user$project$Analyzer$view = F2(
	function (version, model) {
		return _user$project$Styles$page.func('Coverage report', _user$project$Analyzer$styles, version, A2(
            F2(
                function (x, y) {
                    return {ctor: '::', _0: x, _1: y};
                }),
            _user$project$Analyzer$overview(model.moduleMap),
            _elm_lang$core$List$filterMap.func(function (_p12) {
                var _p13 = _p12;
                var _p14 = _p13._0;
                return _elm_lang$core$Maybe$map.func(
                    A2(_user$project$Markup$file, _p14, _p13._1),
                    _Skinney$elm_dict_exploration$Dict_LLRB$get.func(_p14, model.inputs)
                );
            }, _Skinney$elm_dict_exploration$Dict_LLRB$toList(model.moduleMap))));
	});
var _user$project$Analyzer$Model = F2(
	function (a, b) {
		return {inputs: a, moduleMap: b};
	});
var _user$project$Analyzer$decodeModel = A3(
	_elm_lang$core$Json_Decode$map2,
	_user$project$Analyzer$Model,
	A2(
		_elm_lang$core$Json_Decode$field,
		'files',
		A2(
			_elm_lang$core$Json_Decode$map,
			_Skinney$elm_dict_exploration$Dict_LLRB$fromList,
			_elm_lang$core$Json_Decode$keyValuePairs(_elm_lang$core$Json_Decode$string))),
	A2(_elm_lang$core$Json_Decode$field, 'coverage', _user$project$Coverage$regionsDecoder));
var _user$project$Analyzer$main = _user$project$Service$create(
	{
		handle: F2(
			function (version, model) {
				return A2(
					_zwilias$elm_html_string$Html_String$toString,
					0,
					_user$project$Analyzer$view.func(version, model));
			}),
		emit: _elm_lang$core$Json_Encode$string,
		receive: _user$project$Analyzer$decodeModel
	})(_elm_lang$core$Json_Decode$string);

var Elm = {};
Elm['Analyzer'] = Elm['Analyzer'] || {};
if (typeof _user$project$Analyzer$main !== 'undefined') {
    _user$project$Analyzer$main(Elm['Analyzer'], 'Analyzer', undefined);
}

if (typeof define === "function" && define['amd'])
{
  define([], function() { return Elm; });
  return;
}

if (typeof module === "object")
{
  module['exports'] = Elm;
  return;
}

var globalElm = this['Elm'];
if (typeof globalElm === "undefined")
{
  this['Elm'] = Elm;
  return;
}

for (var publicModule in Elm)
{
  if (publicModule in globalElm)
  {
    throw new Error('There are two Elm modules called `' + publicModule + '` on this page! Rename one of them.');
  }
  globalElm[publicModule] = Elm[publicModule];
}

}).call(this);

